-*- coding: utf-8 -*-

commit 5124f9ac7513eb590c37717337c430cb93caa151
  Author:     NARUSE, Yui <naruse@airemix.jp>
  AuthorDate: 2023-12-25 14:59:38 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2023-12-25 14:59:38 +0900

    v3.3.0

commit a44a59dbaf1b5c930c9f476077b0be9b1653ad9c
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2023-12-25 14:52:06 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2023-12-25 14:52:06 +0900

    [DOC] Add NEWS for [Feature #19370]

commit a9f096183170810ac6ce32b20d7810d11a51b5f5
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2023-12-23 18:07:37 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2023-12-25 14:44:04 +0900

    [Feature #19370] Prohibit nesting anonymous parameter forwarding

commit b641b7e640b90292e8091348ca05def0a16904a8
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2023-12-25 14:08:21 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2023-12-25 14:11:49 +0900

    Move non-portable pragmas to rubyspec.h

    In the extension libraries in spec/ruby/optional/capi, do not care
    about deprecated declarations.

commit 863ded45a18773742cf3adab0f6deb4ba6b47c6e
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2023-12-25 13:48:26 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2023-12-25 13:50:23 +0900

    Typofix under bootstraptest, spec and yjit directories

commit 2cdbeb29e6e06d3492e2d4a388558ab883b07150
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2023-12-25 11:13:27 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2023-12-25 13:01:55 +0900

    Do not leave test file

    Run this test separately because something seems remained unreleased
    on Windows.

commit b4efa4b7005efee484e61fbc6af9c652fee36db2
  Author:     Peter Zhu <peter@peterzhu.ca>
  AuthorDate: 2023-12-25 11:26:37 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2023-12-25 12:13:49 +0900

    Don't copy RUBY_FL_PROMOTED flag in rb_obj_setup

    RUBY_FL_PROMOTED is used by the garbage collector to track when an
    object becomes promoted to the old generation. rb_obj_setup must not
    copy that flag over because then it may become out-of-sync with the age
    of the object.

    This fixes a bug in Method#clone where the cloned Method object may get
    RUBY_FL_PROMOTED incorrectly set.

commit 1b5f3dd6a1a5d054e3fd5af10b5dc2f49e1046fc
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2023-12-25 12:04:28 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2023-12-25 12:04:28 +0900

    Removed empty sections

commit 27ead9907db12a6ff955cd86a15a62ff1f064392
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2023-12-25 11:32:03 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2023-12-25 11:32:42 +0900

    Typofix under lib and test, tool directories

commit 7002e776944ddfd362cea253d18d02bc250fe9f7
  Author:     Peter Zhu <peter@peterzhu.ca>
  AuthorDate: 2023-12-25 09:22:13 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2023-12-25 11:29:40 +0900

    Fix Symbol#inspect for GC compaction

    The test fails when RGENGC_CHECK_MODE is turned on:

        1) Failure:
        TestSymbol#test_inspect_under_gc_compact_stress [test/ruby/test_symbol.rb:123]:
        <":testing"> expected but was
        <":\x00\x00\x00\x00\x00\x00\x00">.

commit e233730846fd2634208c3c568c49b76bf3b29a0b
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2023-12-25 11:22:12 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2023-12-25 11:22:12 +0900

    Partly reverted c903cddf55af1505a0779e1a131f2fe47b838260

      These are intentional words

commit c903cddf55af1505a0779e1a131f2fe47b838260
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2023-12-25 11:17:51 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2023-12-25 11:17:51 +0900

    Typofix under doc directory

commit 70618a48f7f9f12943e963bf121b56af4153f394
  Author:     Peter Zhu <peter@peterzhu.ca>
  AuthorDate: 2023-12-25 06:23:10 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2023-12-25 10:37:59 +0900

    Fix off-by-one error for declarative marking

    The for loops for marking and reference updating declaratively marked
    TypedData objects did not mark/reference update the very last element.

    When RGENGC_CHECK_MODE is turned on, this caused the test in Enumerator
    to fail with:

        tool/lib/test/unit/testcase.rb:173:in `rescue in run': failed to allocate memory (NoMemoryError)

commit 260bf60e52ffdfa625be1153624b0d123fc305f8
  Author:     Samuel Williams <samuel.williams@oriontransfer.co.nz>
  AuthorDate: 2023-12-25 10:20:53 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2023-12-25 10:20:53 +0900

    Correctly release the underlying file mapping. (#9340)

    * Avoiding using `Tempfile` which was retaining the file preventing it from unlinking.

commit 5af64ff7db3d636201db68b9ba995131a04a8f7b
  Author:     Peter Zhu <peter@peterzhu.ca>
  AuthorDate: 2023-12-25 02:10:10 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2023-12-25 06:22:34 +0900

    Fix Enumerator#with_index for GC compaction

    enumerator_block_call was not safe for compaction because the Array
    backing the argv was not pinned, so it could get moved during compaction
    which would make argv point to somewhere else.

    The test crashes when RGENGC_CHECK_MODE is turned on:

        TestEnumerator#test_with_index_under_gc_compact_stress
        check_rvalue_consistency: 0x55db0b399450 is not a Ruby object.
        test/ruby/test_enumerator.rb:133: [BUG] check_rvalue_consistency_force: there is 1 errors.
        ruby 3.3.0dev (2023-12-23T23:00:27Z master 50bf437341) [x86_64-linux]
        -- Control frame information -----------------------------------------------
        c:0034 p:---- s:0192 e:000187 CFUNC  :with_index
        c:0033 p:---- s:0185 e:000184 CFUNC  :each
        c:0032 p:---- s:0182 e:000181 CFUNC  :to_a
        c:0031 p:0055 s:0178 e:000175 BLOCK  test/ruby/test_enumerator.rb:133
        c:0030 p:0024 s:0172 e:000171 METHOD tool/lib/envutil.rb:242
        c:0029 p:0024 s:0167 e:000166 METHOD tool/lib/envutil.rb:251
        c:0028 p:0005 s:0160 e:000159 METHOD test/ruby/test_enumerator.rb:131
        ...
        -- C level backtrace information -------------------------------------------
        build/ruby(rb_print_backtrace+0x14) [0x55db0b1deb21] vm_dump.c:820
        build/ruby(rb_vm_bugreport) vm_dump.c:1151
        build/ruby(bug_report_end+0x0) [0x55db0b3a53a6] error.c:1042
        build/ruby(rb_bug_without_die) error.c:1042
        build/ruby(die+0x0) [0x55db0afc77c2] error.c:1050
        build/ruby(rb_bug) error.c:1052
        build/ruby(gc_move+0x0) [0x55db0afbada0] gc.c:1714
        build/ruby(check_rvalue_consistency+0xa) [0x55db0afef0c3] gc.c:1729
        build/ruby(is_markable_object) gc.c:4769
        build/ruby(gc_mark_stack_values) gc.c:6595
        build/ruby(rb_gc_mark_vm_stack_values) gc.c:6605
        build/ruby(rb_execution_context_mark+0x39) [0x55db0b1d8589] vm.c:3309
        build/ruby(thread_mark+0x15) [0x55db0b1a9805] vm.c:3381
        build/ruby(gc_mark_stacked_objects+0x6d) [0x55db0aff2c3d] gc.c:7564
        build/ruby(gc_mark_stacked_objects_all) gc.c:7602
        build/ruby(gc_marks_rest) gc.c:8797
        build/ruby(gc_marks+0xd) [0x55db0aff43d5] gc.c:8855
        build/ruby(gc_start) gc.c:9608
        build/ruby(rb_multi_ractor_p+0x0) [0x55db0aff5463] gc.c:9489
        build/ruby(rb_vm_lock_leave) vm_sync.h:92
        build/ruby(garbage_collect) gc.c:9491
        build/ruby(newobj_slowpath+0xcb) [0x55db0aff57ab] gc.c:2871
        build/ruby(newobj_slowpath_wb_protected) gc.c:2895
        build/ruby(newobj_of0+0x24) [0x55db0aff59e4] gc.c:2937
        build/ruby(newobj_of) gc.c:2947
        build/ruby(rb_wb_protected_newobj_of) gc.c:2962
        build/ruby(ary_alloc_embed+0x10) [0x55db0b2f3e40] array.c:668
        build/ruby(ary_new) array.c:709
        build/ruby(rb_ary_tmp_new_from_values) array.c:759
        build/ruby(rb_ary_new_from_values) array.c:771
        build/ruby(args_copy+0x18) [0x55db0b1bbb88] vm_args.c:158

commit 86ef38194bf2f5c854cab0adf29984594ee4a6ec
  Author:     BurdetteLamar <burdettelamar@yahoo.com>
  AuthorDate: 2023-12-25 04:26:07 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2023-12-25 04:56:06 +0900

    RDoc for complex.c

commit f0efeddd41f96d3afae9af73a3dc594d86614f4b
  Author:     Peter Zhu <peter@peterzhu.ca>
  AuthorDate: 2023-12-24 23:08:01 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2023-12-25 01:04:41 +0900

    Fix Regexp#inspect for GC compaction

    rb_reg_desc was not safe for GC compaction because it took in the C
    string and length but not the backing String object so it get moved
    during compaction. This commit changes rb_reg_desc to use the string
    from the Regexp object.

    The test fails when RGENGC_CHECK_MODE is turned on:

        TestRegexp#test_inspect_under_gc_compact_stress [test/ruby/test_regexp.rb:474]:
        <"(?-mix:\\/)|"> expected but was
        <"/\\x00\\x00\\x00\\x00\\x00\\x00\\x00\\x00\\x00\\x00/">.

commit 8ad8803bb4aed01dfe56e42dc7c131b6bf307655
  Author:     BurdetteLamar <burdettelamar@yahoo.com>
  AuthorDate: 2023-12-25 00:26:20 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2023-12-25 01:00:30 +0900

    RDoc for Complex

commit 42442ed7891b1c721b4a306f21ce9548a69e7be3
  Author:     Peter Zhu <peter@peterzhu.ca>
  AuthorDate: 2023-12-24 10:24:15 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2023-12-24 23:03:55 +0900

    Fix Regexp#match for GC compaction

    The test fails when RGENGC_CHECK_MODE is turned on:

        TestRegexp#test_match_under_gc_compact_stress:
        NoMethodError: undefined method `match' for nil
            test_regexp.rb:878:in `block in test_match_under_gc_compact_stress'

commit 37753f163e461e157e6e224d9d3e5626427a50cc
  Author:     Samuel Williams <samuel.williams@oriontransfer.co.nz>
  AuthorDate: 2023-12-24 22:03:36 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2023-12-24 22:03:36 +0900

    IO::Buffer improvements and documentation. (#9329)

    * Restore experimental warnings.

    * Documentation and code structure improvements.

    * Improved validation of flags, clarified documentation of argument handling.

    * Remove inconsistent use of `Example:` and add example to `null?`.

    * Expose `IO::Buffer#private?` and add test.

commit 61289d940597efb76bd7bcdd0501801733d9c9dd
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2023-12-24 15:47:20 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2023-12-24 19:34:25 +0900

    Initialize loop variable of `ccan_list_for_each`

    On platforms where `typeof` is unsupported, `ccan_container_off_var`
    calculates the offset of member by pointer subtraction.  Although this
    will result in the compile-time invariant value regardless the pointer
    value, the loop variable will be used before assignment and may cause
    an using uninitialized variable warning.

commit 86893b28f7ac7cc522d628577564d49a8f558d70
  Author:     git <svn-admin@ruby-lang.org>
  AuthorDate: 2023-12-24 15:58:23 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2023-12-24 15:58:23 +0900

    Update bundled gems list as of 2023-12-24

commit a87ae242bb460c7643d0f974b96489b5f73a2d45
  Author:     Koichi Sasada <ko1@atdot.net>
  AuthorDate: 2023-12-24 14:33:14 +0900
  Commit:     Koichi Sasada <ko1@atdot.net>
  CommitDate: 2023-12-24 15:13:33 +0900

    Use noinline version of accessing current ec

    On universal.arm64e-darwin22 with clang 15.0.0 (I didn't check
    details yet) accessing `ruby_current_ec` directly causes
    assertion violation `VM_ASSERT(ec == rb_current_ec_noinline())`
    on `rb_current_execution_context()`, maybe because TLS accessing
    issue.

commit 541371e286d2f139c49e7805f6f229618eb63144
  Author:     Koichi Sasada <ko1@atdot.net>
  AuthorDate: 2023-12-24 14:20:35 +0900
  Commit:     Koichi Sasada <ko1@atdot.net>
  CommitDate: 2023-12-24 14:53:46 +0900

    accept `RB_WAITFD_IN | RB_WAITFD_OUT` for waiting events

    Assrsion was `events == RB_WAITFD_IN || events == RB_WAITFD_OUT`
    but it should accept `RB_WAITFD_IN | RB_WAITFD_OUT`.

commit 0fef890b4fbe64a319247fee9d2cb13f45b76844
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2023-12-24 13:59:34 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2023-12-24 13:59:34 +0900

    [DOC] Fix markup in HTML

    Inside HTML is not markdown.

commit 82015496b924744ae3999987ba679978beb153c7
  Author:     Koichi Sasada <ko1@atdot.net>
  AuthorDate: 2023-12-24 10:30:03 +0900
  Commit:     Koichi Sasada <ko1@atdot.net>
  CommitDate: 2023-12-24 10:57:27 +0900

    MN: access `timer_th.waiting` with lock

    `timer_th.waiting` should be protected by `timer_th.waiting_lock`

commit daefbf8fbfa1bd2109315bab7658f52460f7ed59
  Author:     Daisuke Fujimura (fd0) <booleanlabel@gmail.com>
  AuthorDate: 2023-12-17 00:02:57 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2023-12-24 08:06:03 +0900

    Use native_thread_init_stack on cygwin

commit 50bf4373411a8780270c7ba1cc983d5756a4fde1
  Author:     Peter Zhu <peter@peterzhu.ca>
  AuthorDate: 2023-12-24 06:22:14 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2023-12-24 08:00:27 +0900

    Fix String#sub for GC compaction

    The test fails when RGENGC_CHECK_MODE is turned on:

        TestString#test_sub_gc_compact_stress = 9.42 s
        1) Failure:
        TestString#test_sub_gc_compact_stress [test/ruby/test_string.rb:2089]:
        <"aaa [amp] yyy"> expected but was
        <"aaa [] yyy">.

commit a2ebf9cc63f0805bc7dd9a92e66bf589a869447e
  Author:     JP Camara <jp@jpcamara.com>
  AuthorDate: 2023-12-23 10:28:55 +0900
  Commit:     Koichi Sasada <ko1@atdot.net>
  CommitDate: 2023-12-24 07:07:11 +0900

    Replicate EEXIST epoll_ctl behavior in kqueue

    * In the epoll implementation, you get an EEXIST if you try to register the same event for the same fd more than once for a particular epoll instance

    * Otherwise kevent will just override the previous event registration, and if multiple threads listen on the same fd only the last one to register will ever finish, the others are stuck

    * This approach will lead to native threads getting created, similar to the epoll implementation. This is not ideal, but it fixes certain test cases for now, like test/socket/test_tcp.rb#test_accept_multithread

commit fadda88903d9fe764ae53eca07aaf85f08e162a7
  Author:     Peter Zhu <peter@peterzhu.ca>
  AuthorDate: 2023-12-24 04:51:43 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2023-12-24 06:52:05 +0900

    Fix Regexp#to_s for GC compaction

    The test fails when RGENGC_CHECK_MODE is turned on:

        TestRegexp#test_to_s_under_gc_compact_stress = 13.46 s
        1) Failure:
        TestRegexp#test_to_s_under_gc_compact_stress [test/ruby/test_regexp.rb:81]:
        <"(?-mix:abcd\u3042)"> expected but was
        <"(?-mix:\u5C78\u3030\u5C78\u3030\u5C78\u3030\u5C78\u3030\u5C78\u3030)">.

commit 688a1314e60b0e58d5325f50c02552e3018c5025
  Author:     Burdette Lamar <BurdetteLamar@Yahoo.com>
  AuthorDate: 2023-12-24 06:08:26 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2023-12-24 06:08:26 +0900

    [DOC] Clean up doc for File#flock (#9332)

commit 47f33c38481d79563271f042946d0f3165d8b638
  Author:     Peter Zhu <peter@peterzhu.ca>
  AuthorDate: 2023-12-23 23:51:30 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2023-12-23 23:51:30 +0900

    Remove useless `#if 1` in array.c

commit fe9e57bac8ec73ad822c1b245376a6cd96139ccb
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2023-12-23 19:36:21 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2023-12-23 19:36:21 +0900

    Adjust indent [ci skip]

commit fd3dede7f4bad52d7ab383eeb9ee29f20b045cb7
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2023-12-23 18:57:47 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2023-12-23 18:57:47 +0900

    Fix for older set versions

    `Set::VERSION` was not defined in old set.rb bundled with ruby 3.2 or
    earlier.
    Also add comment for spec/mspec/tool/remove_old_guards.rb.

commit dc7785e16ba54039d7341bba570ff551f146cf62
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2023-12-23 18:15:26 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2023-12-23 18:15:26 +0900

    Set 1.1 now checks subclass-ness stricter

commit f6e9899e8a84fc98d47d9c0faf59ff3f0684e1b4
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2023-12-23 01:54:35 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2023-12-23 18:03:31 +0900

    Make rbconfig.rb loadable from exe/ruby

    So that it can run without `--disable=gems` option.

commit 8c03bdacd180cc40b9dac2e6ab52ceb96b34bb18
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2023-12-23 01:51:23 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2023-12-23 18:03:30 +0900

    Control the precheck for test-all by `PRECHECK_TEST_ALL`

commit 40bc7ede38f87bfdd768ed277631b240bd0632b4
  Author:     Akinori MUSHA <knu@idaemons.org>
  AuthorDate: 2023-12-23 16:51:41 +0900
  Commit:     Akinori MUSHA <knu@idaemons.org>
  CommitDate: 2023-12-23 16:51:41 +0900

    Set 1.1.0 has been imported

commit c66ff6facedc693622132a343425ff878a163262
  Author:     Akinori MUSHA <knu@idaemons.org>
  AuthorDate: 2023-12-23 16:43:37 +0900
  Commit:     Akinori MUSHA <knu@idaemons.org>
  CommitDate: 2023-12-23 16:50:33 +0900

    [ruby/set] Bump version to 1.1.0

    https://github.com/ruby/set/commit/d6cab5bcc8

commit 67882d7695552202c47a62bae12e8a774f9e64ea
  Author:     Akinori MUSHA <knu@idaemons.org>
  AuthorDate: 2023-12-08 22:20:14 +0900
  Commit:     Akinori MUSHA <knu@idaemons.org>
  CommitDate: 2023-12-23 16:50:31 +0900

    [ruby/set] Use the pattern argument instead of a block

    https://github.com/ruby/set/commit/c63047c2ce

commit 6fc3171e8af966c680664791b05fa9d505c95d19
  Author:     Akinori MUSHA <knu@idaemons.org>
  AuthorDate: 2023-12-08 22:18:25 +0900
  Commit:     Akinori MUSHA <knu@idaemons.org>
  CommitDate: 2023-12-23 16:50:30 +0900

    [ruby/set] The arity of initialize_clone is -1 in Ruby >= 3

    https://github.com/ruby/set/commit/32a9689696

commit 271c74a473b4fa2cdd754865882ba9912b58541c
  Author:     Akinori MUSHA <knu@idaemons.org>
  AuthorDate: 2023-12-08 22:09:22 +0900
  Commit:     Akinori MUSHA <knu@idaemons.org>
  CommitDate: 2023-12-23 16:50:29 +0900

    [ruby/set] Drop support for Ruby 2

    https://github.com/ruby/set/commit/64dad673d8

commit da02d08f2793c1c5d2ce084d6ceb6fa58ed641f2
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2023-12-23 15:17:58 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2023-12-23 15:18:14 +0900

    RJIT: Rewind $! after compilation

commit ef065102653378956f579985d10d3d4816dc87cf
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2023-12-23 14:47:35 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2023-12-23 14:48:26 +0900

    RJIT: Prefer STDERR over $stderr

    When $stderr is redirected, you'll have no way to see why RJIT got
    broken. This reference must always be the actual stderr.

commit c25705c2670ab34a2d4c993436edcf7d77e5cd92
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2023-12-23 13:20:03 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2023-12-23 13:20:42 +0900

    Get rid of obsoleted RJITFirst

    It was renamed from test_mjit, but we did not maintain it as test_rjit.
    We test RJIT very differently.

commit 9b289d58f78e80362984ffb2920e859beeaec2ce
  Author:     Burdette Lamar <BurdetteLamar@Yahoo.com>
  AuthorDate: 2023-12-23 12:31:18 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2023-12-23 12:31:18 +0900

    [DOC] RDoc for Complex (#9307)

commit f1b7424cbed00a27532a053949f524eaaf4be1ba
  Author:     John Hawthorn <john@hawthorn.email>
  AuthorDate: 2023-12-23 05:15:22 +0900
  Commit:     John Hawthorn <john@hawthorn.email>
  CommitDate: 2023-12-23 11:07:22 +0900

    FREE_AT_EXIT: Don't free main stack post-fork

    When a forked process was started in a thread, this would result in a
    double-free during the child process exit.

        RUBY_FREE_AT_EXIT=1 ./miniruby -e 'Thread.new { fork { } }.join; Process.waitpid'

    This is because the main thread in the forked process was not the
    initial VM thread, and the new thread's stack was freed as part of
    objectspace iteration.

    This change also allows rb_threadptr_root_fiber_release to run without
    EC being available.

commit 339978ef3869acb2ff877451381a80ee4b548bfb
  Author:     John Hawthorn <john@hawthorn.email>
  AuthorDate: 2023-12-23 05:15:07 +0900
  Commit:     John Hawthorn <john@hawthorn.email>
  CommitDate: 2023-12-23 11:07:22 +0900

    Free default_rand_key after freeing Ractors

    Ractor's free iterates through its TLS keys so we need to keep this
    memory available until after Ractors are freed.

    Minimal reproduction:

        RUBY_FREE_AT_EXIT=1 ./miniruby -e rand

commit 697a096c9b0d8c153cb5d99affb6b5673b7c4210
  Author:     John Hawthorn <john@hawthorn.email>
  AuthorDate: 2023-12-16 18:34:03 +0900
  Commit:     John Hawthorn <john@hawthorn.email>
  CommitDate: 2023-12-23 11:07:22 +0900

    Remove EC argument from clean_hooks_check

    This argument doesn't seem used anymore. Since we want to free these
    objects during VM destruction when RUBY_FREE_AT_EXIT is set they must
    work without an EC.

    This avoids a use-after-free running `RUBY_FREE_AT_EXIT=1 ./miniruby -e ''`

commit 24ff13d8da711f8004b92e81e95c051feb8a5ce0
  Author:     git <svn-admin@ruby-lang.org>
  AuthorDate: 2023-12-23 09:35:43 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2023-12-23 09:35:43 +0900

    Update default gems list at 7d7a84e99fca816ec352c95965687d [ci skip]

commit 7d7a84e99fca816ec352c95965687db240fb56d3
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2023-12-23 09:08:54 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2023-12-23 09:34:26 +0900

    Merge RubyGems-3.5.3 and Bundler-2.5.3

commit fa5de8f68d51e4fbc91190061e3ce3817bd68964
  Author:     Koichi Sasada <ko1@atdot.net>
  AuthorDate: 2023-12-23 07:46:56 +0900
  Commit:     Koichi Sasada <ko1@atdot.net>
  CommitDate: 2023-12-23 08:10:41 +0900

    MN: skip waiting on fiber schedulers

    If the Fiber is nonblocking mode, fiber scheduler needs to handle
    IO events.

commit beec3d07c907ec875e05fe2d22cea2263857b499
  Author:     Koichi Sasada <ko1@atdot.net>
  AuthorDate: 2023-12-23 07:45:08 +0900
  Commit:     Koichi Sasada <ko1@atdot.net>
  CommitDate: 2023-12-23 08:10:41 +0900

    MN: skip waiting on `read_nonblock'

    if the IO for `IO#read_nonblock` is not ready, it needs
    to return (or raise) immediately.

commit 2fe9e08578689adec0be8a36d0ae49541551d357
  Author:     Koichi Sasada <ko1@atdot.net>
  AuthorDate: 2023-12-23 07:44:36 +0900
  Commit:     Koichi Sasada <ko1@atdot.net>
  CommitDate: 2023-12-23 08:10:41 +0900

    MN: skip RUBY_DESCRIPTION spec on MN enabled

commit a4b737213eb1d8f352f1f148c27e96a3f09f5d08
  Author:     Koichi Sasada <ko1@atdot.net>
  AuthorDate: 2023-12-23 05:23:53 +0900
  Commit:     Koichi Sasada <ko1@atdot.net>
  CommitDate: 2023-12-23 05:56:02 +0900

    MN: ceil timeout milli seconds

    `hrrel / RB_HRTIME_PER_MSEC` floor the timeout value and it can
    return wrong value by `Mutex#sleep` (return Integer even if
    it should return nil (timeout'ed)).

    This patch ceil the value and the issue was solved.

commit c974ee1abe5df5a4bb97264e608afbd134c77652
  Author:     Koichi Sasada <ko1@atdot.net>
  AuthorDate: 2023-12-23 05:22:52 +0900
  Commit:     Koichi Sasada <ko1@atdot.net>
  CommitDate: 2023-12-23 05:56:02 +0900

    ensure to restart antoher thread

commit bbfc262c994f84801abfb1302cf6142dfee50adf
  Author:     Koichi Sasada <ko1@atdot.net>
  AuthorDate: 2023-12-23 03:57:53 +0900
  Commit:     Koichi Sasada <ko1@atdot.net>
  CommitDate: 2023-12-23 05:56:02 +0900

    MN: fix "raise on close"

    Introduce `thread_io_wait_events()` to make 1 function to call
    `thread_sched_wait_events()`.

    In ``thread_io_wait_events()`, manipulate `waiting_fd` to raise
    an exception when closing the IO correctly.

commit 19d082dcfa393e8a5d0282b872ace587ca5cd49a
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2023-12-23 04:20:45 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2023-12-23 04:24:04 +0900

    RJIT: Distinguish Pointer with Array

    This is more convenient for accessing those fields.

commit 40e3f782dd92749a1fa593ef905d1b75fdd61904
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2023-12-22 21:50:38 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2023-12-22 23:08:10 +0900

    Extract `forwarding_arg_check` function

commit 11c2aa035b0639a2b3550cd8e0b9ef72315f0c2d
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2023-12-22 16:30:46 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2023-12-22 23:08:10 +0900

    Extract `arg_splat` nonterminal symbol

commit 426f2334dd4a926782ffac32ad9c6c01abf220b8
  Author:     Jun Aruga <jaruga@redhat.com>
  AuthorDate: 2023-12-22 22:26:22 +0900
  Commit:     Jun Aruga <junaruga@users.noreply.github.com>
  CommitDate: 2023-12-22 23:06:47 +0900

    .travis.yml: Try another way to be notified.

    I <jaruga@ruby-lang.org> haven't received the notifications since August 2022.
    So, try another way to be notified written on the document below.

    https://docs.travis-ci.com/user/notifications/#configuring-email-notifications

commit e8639098ed78f8f8f7c263d8b6f2d68822945a78
  Author:     Kouhei Yanagita <yanagi@shakenbu.org>
  AuthorDate: 2023-10-29 14:57:50 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2023-12-22 16:15:33 +0900

    [Bug #19977] Fix (nil..nil) === x not to raise TypeError

commit f263e447460eb952738f0318ca4e8dee4f4139a5
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2023-12-22 15:57:32 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2023-12-22 16:00:18 +0900

    RJIT: Avoid retaining unrelated local variables in memory

commit ef4797bb0338aa35dd74290dcfef83cbc288ad58
  Author:     Kouhei Yanagita <yanagi@shakenbu.org>
  AuthorDate: 2023-12-22 15:44:57 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2023-12-22 15:53:41 +0900

    [DOC] Fix NEWS markup

commit 17e351057ea39acbc19fa3f17ba668a3ba31421e
  Author:     TSUYUSATO Kitsune <make.just.on@gmail.com>
  AuthorDate: 2023-12-22 15:03:18 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2023-12-22 15:28:33 +0900

    Add Regexp updates to NEWS.md

commit e364436c5f89fc4ee51706634637893771175d02
  Author:     yui-knk <spiketeika@gmail.com>
  AuthorDate: 2023-12-22 09:32:32 +0900
  Commit:     Yuichiro Kaneko <spiketeika@gmail.com>
  CommitDate: 2023-12-22 15:15:05 +0900

    [DOC] NEWS entries for Parser

commit f3c82df944603a590771c83e1e58c51f83eb63cf
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2023-12-22 14:59:32 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2023-12-22 14:59:33 +0900

    RJIT: Minimize string allocations in InsnCompiler

commit 2e0277b133b9040808f45d0ec9930a0fd7422c3b
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2023-12-22 14:25:08 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2023-12-22 14:46:19 +0900

    RJIT: Make --rjit-trace actually work

commit 4c6f07eeca54df45cbdd1ab83eafc5a9343482d4
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2023-12-22 14:10:19 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2023-12-22 14:10:19 +0900

    RJIT: Update bindgen

commit 64c52cd1c2df840a021dd952b42bddde09534b1b
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2023-12-22 13:57:34 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2023-12-22 14:05:13 +0900

    RJIT: Add --rjit-trace to allow TracePoint during JIT

commit c18edc5b5d03b9abf355038a17956d69e0552228
  Author:     John Hawthorn <john@hawthorn.email>
  AuthorDate: 2023-12-22 09:01:16 +0900
  Commit:     John Hawthorn <john@hawthorn.email>
  CommitDate: 2023-12-22 13:43:01 +0900

    Avoid underflow of rb_yjit_live_iseq_count

    This value is only incremented when rb_iseq_translate_threaded_code is
    called, which doesn't happen for iseqs which result in a syntax error.

    This is easy to hit by running a debug build with RUBY_FREE_AT_EXIT=1,
    but any build and options could underflow this value by running enough
    evals.

commit cae11dd8576d9ddb9bead2e5340677c5d05b03f5
  Author:     Koichi Sasada <ko1@atdot.net>
  AuthorDate: 2023-12-22 12:15:44 +0900
  Commit:     Koichi Sasada <ko1@atdot.net>
  CommitDate: 2023-12-22 12:45:31 +0900

    debug.gem v1.9.1

commit fa0f7522c41bd2a71117b2428bc6fbb0bbcc9699
  Author:     Yuta Saito <kateinoigakukun@gmail.com>
  AuthorDate: 2023-12-22 08:52:20 +0900
  Commit:     Yuta Saito <kateinoigakukun@gmail.com>
  CommitDate: 2023-12-22 11:30:00 +0900

    coroutine/arm64: Skip saving/restoring x30 twice and use `autiasp`

    We don't need to save/restore x30 twice, and we can just use `ret`,
    which uses x30 as return address register instead of explicit `ret <reg>`
    instruction. This also allows us to use `autiasp` instead of `autia1716`
    and we can skip setting SP/LR to x16/x17.

    Also the size of register save area is shrunk by 16 bytes due to the
    removal of extra x30 save/restore.

commit 2d004decde80566c5b004c5b832e8a1ab007965f
  Author:     Yuta Saito <kateinoigakukun@gmail.com>
  AuthorDate: 2023-12-21 15:21:37 +0900
  Commit:     Yuta Saito <kateinoigakukun@gmail.com>
  CommitDate: 2023-12-22 11:30:00 +0900

    coroutine/arm64/Context.S: Append PAC/BTI note section if needed

    Fixes https://bugs.ruby-lang.org/issues/20029

commit 35587150e21175b6a63cd02d406beff5c76f1149
  Author:     Yuta Saito <kateinoigakukun@gmail.com>
  AuthorDate: 2023-12-21 15:19:25 +0900
  Commit:     Yuta Saito <kateinoigakukun@gmail.com>
  CommitDate: 2023-12-22 11:30:00 +0900

    coroutine/arm64/Context.S: Insert `bti c` as BTI landing pad

commit d9e5564ccd0e460b7685b786d21cf386b229e2a9
  Author:     Yuta Saito <kateinoigakukun@gmail.com>
  AuthorDate: 2023-12-21 14:42:39 +0900
  Commit:     Yuta Saito <kateinoigakukun@gmail.com>
  CommitDate: 2023-12-22 11:30:00 +0900

    coroutine/arm64: Sign return address if PAC enabled

commit 9a3c49ee5d6dd3770c21ed8193e7efd64cd81a6e
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2023-12-22 10:45:43 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2023-12-22 10:47:36 +0900

    RJIT: Convert opt_case_dispatch keys with #to_value

    comptime_key is a Ruby object and the value is not valid in machine code.

    This PR also implements `CMP r/m64, imm32 (Mod 01: [reg]+disp8)` that is
    now needed for running mail.gem benchmark.

commit 0c05551f5812f29c24a30cfbcaa60beab22569d0
  Author:     Alan Wu <alanwu@ruby-lang.org>
  AuthorDate: 2023-12-22 10:34:49 +0900
  Commit:     Alan Wu <alanwu@ruby-lang.org>
  CommitDate: 2023-12-22 10:34:49 +0900

    Typo fixes for public headers [ci skip]

commit 009968a700209336eb592ccb83bddcf7b2c17984
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2023-12-22 10:12:40 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2023-12-22 10:12:40 +0900

    RJIT: Avoid incrementing vm_insns_count

    during compilation

commit 3c182776292ecd2a28fea4f7de87a89e64459f9c
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2023-12-22 09:18:30 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2023-12-22 09:47:13 +0900

    RJIT: Clean up unnecessary documentation

commit 18a97affa349b5edbc4829063b752aab1911fa55
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2023-12-22 09:45:37 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2023-12-22 09:45:37 +0900

    RJIT: Fix a wrong comparison in set_local_type

commit 68bcca4c2bfa716b965554057b098cefcba00f66
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2023-12-22 08:45:10 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2023-12-22 08:48:37 +0900

    RJIT: Fix unwanted shadowing in set_local_type

    local_idx should not be overwritten.

commit ffa5f16273f46c97bfca56e4549b0b38b9322d63
  Author:     John Hawthorn <john@hawthorn.email>
  AuthorDate: 2023-12-21 06:54:32 +0900
  Commit:     John Hawthorn <john@hawthorn.email>
  CommitDate: 2023-12-22 08:23:19 +0900

    Make rb_profile_frames return 0 for NULL ec

    When using M:N threads, EC is set to NULL in the shared native thread
    when nothing is scheduled. This previously caused a segfault when we try
    to examine the EC.

    Returning 0 instead means we may miss profiling information, but a
    profiler relying on this isn't thread aware anyways, and observing that
    "nothing" is running is probably correct.

    Fixes [Bug #20017]

    Co-authored-by: Dustin Brown <dbrown9@gmail.com>

commit 78b27ce62a7d6f28c73d6fb4f97b0948859be8e0
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2023-12-22 07:30:55 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2023-12-22 07:32:03 +0900

    RJIT: Streamline RJIT enablement check

    in bootstrap tests so that `make btest-bruby` skips the right tests.

commit c73959cff40ba0f1d71ea6e3fce19b5f287e8494
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2023-12-22 07:24:10 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2023-12-22 07:25:41 +0900

    RJIT: Rename pause/resume to disable/enable

    like YJIT. They don't work in the same way yet, but it's nice to make
    the naming consistent first so that we will not need to rename them
    later.

commit 69bed94cea6fce659c32cb59a1bfccd59f8196c7
  Author:     git <svn-admin@ruby-lang.org>
  AuthorDate: 2023-12-22 07:24:52 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2023-12-22 07:24:52 +0900

    Update default gems list at 82496f2b389278a569fa7680ee6faa [ci skip]

commit 82496f2b389278a569fa7680ee6faa55a97410d7
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2023-12-22 07:01:12 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2023-12-22 07:24:04 +0900

    Merge RubyGems-3.5.2 and Bundler-2.5.2

commit fc549b2b3a65a95a734ee8679293a30284f84622
  Author:     Victor Shepelev <zverok.offline@gmail.com>
  AuthorDate: 2023-12-22 06:12:36 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2023-12-22 06:12:36 +0900

    [DOC] Improve NEWS.md rendering and add missing features (#9308)

    * Fix rendering of the file on docs.ruby-lang.org:
      * More indentation for code;
      * Properly qualified methods to link to docs;
    * Add two minor yet notable changes:
      * Time.new stricter parsing of strings;
      * NoMethodError rendering logic change.

commit e04197aba74e62aae163f0cdc7058861047045a2
  Author:     Victor Shepelev <zverok.offline@gmail.com>
  AuthorDate: 2023-12-22 05:27:18 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2023-12-22 05:27:18 +0900

    [DOC] Fix NoMethodError example of rendering (#9309)

    Fix NoMethodError example of rendering

commit 1f0304218cf00e05a4a126196676ba221ebf91f6
  Author:     John Hawthorn <john@hawthorn.email>
  AuthorDate: 2023-12-21 08:29:03 +0900
  Commit:     John Hawthorn <john@hawthorn.email>
  CommitDate: 2023-12-22 02:17:22 +0900

    Use main_thread->ec from rb_vm_main_ractor_ec

    rb_vm_main_ractor_ec was introduced to allow rb_postponed_job_* to work
    when fired on non-Ruby threads, which have no EC set, and that is its
    only use.

    When RUBY_MN_THREADS=1 is set ractor->threads.running_ec is NULL when
    the shared thread is sleeping. This instead grabs the EC directly from
    the main thread which seems to always be set.

    Fixes [Bug #20016]

    Co-authored-by: Dustin Brown <dbrown9@gmail.com>

commit 1710eb9367d7d11f059a17879e00ef7637265558
  Author:     John Hawthorn <john@hawthorn.email>
  AuthorDate: 2023-12-21 03:37:02 +0900
  Commit:     John Hawthorn <john@hawthorn.email>
  CommitDate: 2023-12-22 02:17:22 +0900

    [DOC] Fix rb_postponed_job_register_once typo

    Co-authored-by: Dustin Brown <dbrown9@gmail.com>

commit e191bf42d2077a025c21888573f8b81688e5ea28
  Author:     Peter Zhu <peter@peterzhu.ca>
  AuthorDate: 2023-12-19 10:55:59 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2023-12-22 00:39:03 +0900

    Fix ary_make_partial_step for compaction

    ary could change embeddedness due to compaction, so we should only get
    the pointer after allocations.

    The included test was crashing with:

        TestArray#test_slice_gc_compact_stress
        ruby/lib/pp.rb:192: [BUG] Segmentation fault at 0x0000000000000038

commit fd4735130e5fdc0a11f970092d5900847a3ce4cf
  Author:     Jean Boussier <jean.boussier@gmail.com>
  AuthorDate: 2023-12-21 20:20:41 +0900
  Commit:     Jean Boussier <jean.boussier@gmail.com>
  CommitDate: 2023-12-21 21:02:25 +0900

    Fix a typo in NEWS.md

commit bcb4706dac321bef018a28c83721609a20143351
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2023-12-21 14:16:09 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2023-12-21 14:16:09 +0900

    Added limitation of bundled gems warning feature with bootsnap

commit 28e3886689c71b22487dd5d0cb62f3b5ed0a77cc
  Author:     git <svn-admin@ruby-lang.org>
  AuthorDate: 2023-12-21 10:26:44 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2023-12-21 10:26:44 +0900

    Update bundled gems list at d587852cf7f660308d1287e85767ad [ci skip]

commit d587852cf7f660308d1287e85767ada3559a3ff9
  Author:     Soutaro Matsumoto <matsumoto@soutaro.com>
  AuthorDate: 2023-12-21 10:26:08 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2023-12-21 10:26:08 +0900

    Bundle RBS 3.4.0 (#9293)

    Bundle RBS 3.4.0 and TypeProf 0.21.9.

commit c28177cd57c99865bbf18e73008ba6fb11f73a2e
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2023-12-21 02:17:19 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2023-12-21 02:17:46 +0900

    RJIT: Print an error message first

    Creating a backtrace can crash if RJIT is triggered by branch_stub_hit.
    In that case, it's useful to at least print the error message.

commit fac7d2c1ab97cfdbb173360879c1fe07f443624b
  Author:     git <svn-admin@ruby-lang.org>
  AuthorDate: 2023-12-20 19:36:35 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2023-12-20 19:36:35 +0900

    Update default gems list at 31959f1f13c0dcbb517469b4cbf29a [ci skip]

commit 31959f1f13c0dcbb517469b4cbf29a637a7c6ee4
  Author:     Stan Lo <stan001212@gmail.com>
  AuthorDate: 2023-12-20 19:04:53 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2023-12-20 19:11:02 +0900

    [ruby/irb] Bump version to v1.11.0
    (https://github.com/ruby/irb/pull/818)

    https://github.com/ruby/irb/commit/7421359b92

commit 4ad1007fd2da863e3afc8bd83b38c512f9ca7fc4
  Author:     Burdette Lamar <BurdetteLamar@Yahoo.com>
  AuthorDate: 2023-12-19 08:26:43 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2023-12-20 19:11:02 +0900

    [ruby/irb] [DOC] Change indexes.rdoc to indexes.md
    (https://github.com/ruby/irb/pull/812)

    * Change indexes.rdoc to indexes.md

    * Change indexes.rdoc to indexes.md

    * Change indexes.rdoc to indexes.md

    https://github.com/ruby/irb/commit/b1cd53cbf7

commit 2793a30b69177e7c7bbf124ccfca7b4f4216ca84
  Author:     Stan Lo <stan001212@gmail.com>
  AuthorDate: 2023-12-18 23:36:55 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2023-12-20 19:11:01 +0900

    [ruby/irb] Warn users about errors in loading RC files
    (https://github.com/ruby/irb/pull/817)

    1. Because `IRB.rc_file` always generates an rc file name, even if the
       file doesn't exist, we should check the file exists before trying to
       load it.
    2. If any type of errors occur while loading the rc file, we should
       warn the user about it.

    https://github.com/ruby/irb/commit/37ffdc6b19

commit 7c2d8198625ca2e38835ad06ab47b4ea3afbc34b
  Author:     Jean Boussier <byroot@ruby-lang.org>
  AuthorDate: 2023-12-20 17:05:44 +0900
  Commit:     Jean Boussier <jean.boussier@gmail.com>
  CommitDate: 2023-12-20 17:28:45 +0900

    Fix a grammar issue in the shape performance warning message

commit 4927f251481df57a209284bb2ad2b237468e7792
  Author:     Koichi Sasada <ko1@atdot.net>
  AuthorDate: 2023-12-20 15:48:49 +0900
  Commit:     Koichi Sasada <ko1@atdot.net>
  CommitDate: 2023-12-20 17:00:55 +0900

    skip `MAP_STACK` on FreeBSD

commit 256f34ab6b221b630e5e4ec8d39e3808e82a3296
  Author:     JP Camara <jp@jpcamara.com>
  AuthorDate: 2023-12-16 12:39:45 +0900
  Commit:     Koichi Sasada <ko1@atdot.net>
  CommitDate: 2023-12-20 16:23:38 +0900

    Hand thread into `thread_sched_wait_events_timeval`

    * When we have the thread already, it saves a lookup

    * `event_wait`, not `kq`

    Clean up the `thread_sched_wait_events_timeval` calls

    * By handling the PTHREAD check inside the function, all the other code can become much simpler and just call the function directly without additional checks

commit 8782e02138e6fe18b6c0dcc29bb877d6cdae57e5
  Author:     JP Camara <jp@jpcamara.com>
  AuthorDate: 2023-12-07 10:01:14 +0900
  Commit:     Koichi Sasada <ko1@atdot.net>
  CommitDate: 2023-12-20 16:23:38 +0900

    KQueue support for M:N threads

    * Allows macOS users to use M:N threads (and technically FreeBSD, though it has not been verified on FreeBSD)

    * Include sys/event.h header check for macros, and include sys/event.h when present

    * Rename epoll_fd to more generic kq_fd (Kernel event Queue) for use by both epoll and kqueue

    * MAP_STACK is not available on macOS so conditionall apply it to mmap flags

    * Set fd to close on exec

    * Log debug messages specific to kqueue and epoll on creation

    * close_invalidate raises an error for the kqueue fd on child process fork. It's unclear rn if that's a bug, or if it's kqueue specific behavior

    Use kq with rb_thread_wait_for_single_fd

    * Only platforms with `USE_POLL` (linux) had changes applied to take advantage of kernel event queues. It needed to be applied to the `select` so that kqueue could be properly applied

    * Clean up kqueue specific code and make sure only flags that were actually set are removed (or an error is raised)

    * Also handle kevent specific errnos, since most don't apply from epoll to kqueue

    * Use the more platform standard close-on-exec approach of `fcntl` and `FD_CLOEXEC`. The io-event gem uses `ioctl`, but fcntl seems to be the recommended choice. It is also what Go, Bun, and Libuv use

    * We're making changes in this file anyways - may as well fix a couple spelling mistakes while here

    Make sure FD_CLOEXEC carries over in dup

    * Otherwise the kqueue descriptor should have FD_CLOEXEC, but doesn't and fails in assert_close_on_exec

commit 7ef90b3978dad057ad6360a94d2d64e8ca5e9c38
  Author:     HParker <HParker@github.com>
  AuthorDate: 2023-12-20 14:12:18 +0900
  Commit:     Yusuke Endoh <mame@ruby-lang.org>
  CommitDate: 2023-12-20 14:36:32 +0900

    Correct free_on_exit env var to free_at_exit

commit 7dca6b53a995a9782026f726c291344b5b8e0ab2
  Author:     Jeremy Evans <code@jeremyevans.net>
  AuthorDate: 2023-12-20 14:30:47 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2023-12-20 14:30:47 +0900

    Add tool/missing-baseruby.bat, used when BASERUBY not available

    Previously, the embedded semicolon in BASERUBY if BASERUBY is
    not available breaks tarball builds without BASERUBY when using
    OpenBSD make, due to the inability to escape MFLAGS correctly.
    This moves the same BASERUBY code into a separate file, avoiding
    the MFLAGS quoting issue.

    BASERUBY must be passed to build-ext because it is required
    by ripper since the introduction of lrama.

    Fixes [Bug #19683]

    Co-authored-by: Nobuyoshi Nakada <nobu@ruby-lang.org>

commit ae2c4d07204dd714a7a5be7697541447b023ea25
  Author:     Mikhail Doronin <mikhail.doronin@thetrainline.com>
  AuthorDate: 2023-12-19 05:13:47 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2023-12-20 13:46:39 +0900

    Revert "[Bug #19831] Remove duplicate library options"

    This reverts commit 5bb946228550c7f171c27725860b153a675404f3.

    Fixes https://bugs.ruby-lang.org/issues/20072

commit 32ecda354f1556edbfdba4723716fa523acbc94d
  Author:     Peter Zhu <peter@peterzhu.ca>
  AuthorDate: 2023-12-19 06:55:19 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2023-12-20 08:29:36 +0900

    Support `GC.auto_compact = :empty` on debug builds

    This commit adds `GC.auto_compact = :empty` which will run
    auto-compaction sorting pages by empty slots so the most amount of
    objects will be moved. This will make it easier to write tests for
    auto-compaction.

commit 3d984366ca809fdcc9320e776705ecd96efa49a0
  Author:     Matt Valentine-House <matt@eightbitraptor.com>
  AuthorDate: 2023-12-20 07:06:50 +0900
  Commit:     Matt Valentine-House <matt@eightbitraptor.com>
  CommitDate: 2023-12-20 07:50:59 +0900

    [PRISM] Correct the jump target for redo in FOR_NODE

commit 371ff808400b079b373e87de9b3deeb6c16f6a23
  Author:     Matt Valentine-House <matt@eightbitraptor.com>
  AuthorDate: 2023-12-19 06:32:25 +0900
  Commit:     Matt Valentine-House <matt@eightbitraptor.com>
  CommitDate: 2023-12-20 07:50:59 +0900

    [PRISM] Fix parameter numbering in For Node

commit f0b86f8c6098edfe47c4735d061e50e017d7e94d
  Author:     BurdetteLamar <burdettelamar@yahoo.com>
  AuthorDate: 2023-12-20 05:32:54 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2023-12-20 07:29:09 +0900

    RDoc for Complex

commit 054f56fd3e5bf84e5443896fd1f4e439c2773c60
  Author:     Koichi Sasada <ko1@atdot.net>
  AuthorDate: 2023-12-20 03:45:41 +0900
  Commit:     Koichi Sasada <ko1@atdot.net>
  CommitDate: 2023-12-20 07:04:32 +0900

    moved object should not have a shape ID

    fix [Bug #19917]

commit 7a0dfdea8c92d2393d624bc7961f36e082c43471
  Author:     Koichi Sasada <ko1@atdot.net>
  AuthorDate: 2023-12-20 06:15:15 +0900
  Commit:     Koichi Sasada <ko1@atdot.net>
  CommitDate: 2023-12-20 07:00:41 +0900

    use `rb_thread_io_blocking_call()` more

    use `rb_thread_io_blocking_call()` instead of
    `rb_thread_io_blocking_region()` more.

    See https://github.com/ruby/ruby/pull/9178#issuecomment-1858711533

commit ec51a3c8183d555b6ccaa37834fac855ded3af88
  Author:     Koichi Sasada <ko1@atdot.net>
  AuthorDate: 2023-12-20 05:25:38 +0900
  Commit:     Koichi Sasada <ko1@atdot.net>
  CommitDate: 2023-12-20 07:00:41 +0900

    declare `rb_thread_io_blocking_call`

commit 2fe5fc176b31ce132e05a91b2c96b4a935e46ceb
  Author:     Koichi Sasada <ko1@atdot.net>
  AuthorDate: 2023-12-20 06:14:51 +0900
  Commit:     Koichi Sasada <ko1@atdot.net>
  CommitDate: 2023-12-20 07:00:41 +0900

    setup `waiting_fd` for `thread_sched_wait_events()`

    `thread_sched_wait_events()` suspend the thread until the target
    fd is ready. Howver, other threads can close the target fd and
    suspended thread should be awake. To support it, setup `waiting_fd`
    before `thread_sched_wait_events()`.

    `rb_thread_io_wake_pending_closer()` should be called before
    `RUBY_VM_CHECK_INTS_BLOCKING()` because it can return this function.

    This patch introduces additional overhead (setup/cleanup `waiting_fd`)
    and maybe we can reduce the overhead.

commit 28a6e4ea9d9379a654a8f7c4b37fa33aa3ccd0b7
  Author:     Peter Zhu <peter@peterzhu.ca>
  AuthorDate: 2023-12-20 04:38:57 +0900
  Commit:     Aaron Patterson <aaron.patterson@gmail.com>
  CommitDate: 2023-12-20 06:09:36 +0900

    Set m_tbl right after allocation

    We should set the m_tbl right after allocation before anything that can
    trigger GC to avoid clone_p from becoming old and needing to fire write
    barriers.

    Co-authored-by: Aaron Patterson <tenderlove@ruby-lang.org>

commit 50d39219a9b5f19a536c02ec47b54b79efa015f5
  Author:     Peter Zhu <peter@peterzhu.ca>
  AuthorDate: 2023-12-20 05:21:28 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2023-12-20 05:21:28 +0900

    Use RICLASS_OWNS_M_TBL_P

    It's more consistent with gc_mark_children.

commit bd91c5127ff30f5a21547e73a493c06fbd6da7ae
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2023-12-20 04:47:27 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2023-12-20 04:47:27 +0900

    YJIT: Add stats option to RubyVM::YJIT.enable (#9297)

commit 084b44e79dd456c9ce09ac06c6faf538160ac6b0
  Author:     BurdetteLamar <burdettelamar@yahoo.com>
  AuthorDate: 2023-12-20 00:19:00 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2023-12-20 04:30:33 +0900

    RDoc for Complex

commit df0bfde2b29b7e8dac333b2a775ab8bff1283a5c
  Author:     Aaron Patterson <tenderlove@ruby-lang.org>
  AuthorDate: 2023-12-19 08:16:31 +0900
  Commit:     Aaron Patterson <aaron.patterson@gmail.com>
  CommitDate: 2023-12-20 01:53:52 +0900

    We need to load builtins so that they work

    Before this commit no methods defined in Ruby were being loaded. For
    example `class` or `tap` methods would not exist.

    [ruby-core:115793] [Bug #20073]

commit 8e6f63df47089361f7988176bb22ed3c96ecf95a
  Author:     Peter Zhu <peter@peterzhu.ca>
  AuthorDate: 2023-12-15 04:15:17 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2023-12-19 23:13:20 +0900

    Implement IO::Buffer on VWA

commit 1822acdf336d53a2c143b29583c3ca21a9a224f4
  Author:     Doug Orleans <door@hey.com>
  AuthorDate: 2023-12-16 09:37:40 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2023-12-19 22:11:11 +0900

    [DOC] remove reference to pre-3.0 splat operator behavior

commit f9a48548cf3ef54fc0a385ccd78c708737055ecc
  Author:     Koichi Sasada <ko1@atdot.net>
  AuthorDate: 2023-12-19 17:32:19 +0900
  Commit:     Koichi Sasada <ko1@atdot.net>
  CommitDate: 2023-12-19 17:59:49 +0900

    restore the stack pointer on finalizer

    When error on finalizer, the exception will be ignored.
    To restart the code, we need to restore the stack pointer.

    fix [Bug #20042]

commit 96e4f42b3d13f37afce1a8c584a56f6d7e98ec23
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2023-12-19 17:06:21 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2023-12-19 17:06:21 +0900

    RJIT: Correct the macro that defines rb_vm_insns_count

commit 8d5af353b2ab6c774a473fdb010dcbe3d4e90f0e
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2023-12-19 15:21:31 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2023-12-19 17:05:19 +0900

    RJIT: Avoid retaining comments unless --rjit-dump-disasm

    This significantly reduces retained objects on RJIT.

commit 8671cd59f78a2bf28d323b6d0c5314e090811a65
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2023-12-19 17:02:38 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2023-12-19 17:02:38 +0900

    RJIT: Correct the type of rb_vm_insns_count

commit edd6581eec59f0139cfff27bccf9e24c9152a6d3
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2023-12-19 17:00:18 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2023-12-19 17:00:18 +0900

    RJIT: Declare rb_vm_insns_count

commit eb872d17524f299bdd023f005da38ffcddffa90a
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2023-12-19 16:49:54 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2023-12-19 16:55:40 +0900

    RJIT: Share rb_vm_insns_count for vm_insns_count

commit dee45ac231afd02797640cb335d86550aa620cbe
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2023-12-19 12:59:43 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2023-12-19 13:48:51 +0900

    [DOC] State MatchData#[] when multiple captures with the same name

commit b5f33ba76f9657228746e079eafb8fa952a9ab8b
  Author:     Yuta Saito <kateinoigakukun@gmail.com>
  AuthorDate: 2023-12-19 11:55:24 +0900
  Commit:     Yuta Saito <kateinoigakukun@gmail.com>
  CommitDate: 2023-12-19 12:40:43 +0900

    signal.c: Fix undefined `reset_sigmask` use on Emscripten

    3c471149910d79745b50389c436f0ed2973e0d91 added a call to `reset_sigmask`
    but the guard condition didn't match with the condition used to define
    `reset_sigmask`.

commit f907a7111c5fd26f54c0e020dd64d6325c3fd08b
  Author:     Burdette Lamar <BurdetteLamar@Yahoo.com>
  AuthorDate: 2023-12-19 11:40:58 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2023-12-19 11:40:58 +0900

    [DOC] RDoc for Complex (#9260)

commit 36b389c206b0d793da45bc73c8a036e1d5c7a72e
  Author:     Yuta Saito <kateinoigakukun@gmail.com>
  AuthorDate: 2023-12-17 23:21:17 +0900
  Commit:     Yuta Saito <kateinoigakukun@gmail.com>
  CommitDate: 2023-12-19 11:13:38 +0900

    [wasm] dln.c: Guard `dladdr` use in symbol incompatibility check

    wasi-libc recently added a family of `dl*` functions[^1], but it still
    doesn't have `dladdr` unlike other platforms. Guard the use of `dladdr`
    with `HAVE_DLADDR` to avoid build failure with the head version of
    wasi-libc.
    The library name is used only for diagnostic purpose if it's not NULL,
    so it's safe to skip it.

    [^1]: https://github.com/WebAssembly/wasi-libc/commit/b85d65528d6e17ae1874c6cc6a6a3ac02e83021a

commit acfd2e9d6447f82913a8e2241349fb9e29afabde
  Author:     git <svn-admin@ruby-lang.org>
  AuthorDate: 2023-12-19 11:13:02 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2023-12-19 11:13:02 +0900

    Update default gems list at 5ea862f26e86be6fabcc938e22bc2d [ci skip]

commit 5ea862f26e86be6fabcc938e22bc2d5c2bbc8341
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2023-12-19 10:56:54 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2023-12-19 11:07:47 +0900

    [ruby/psych] Bump up 5.1.2

    https://github.com/ruby/psych/commit/a9ab74d132

commit b3598f95fa997e667bb9e8003b0284ab2a4db081
  Author:     Alexander Momchilov <alexandermomchilov@gmail.com>
  AuthorDate: 2023-12-18 18:01:01 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2023-12-19 11:07:46 +0900

    [ruby/psych] Use `assert_same` in tests where applicable

    https://github.com/ruby/psych/commit/0dc25a9d6a

commit e6fa1d62faf6ba4b0f3277e2e92e6e60d4330cc8
  Author:     Alexander Momchilov <alexandermomchilov@gmail.com>
  AuthorDate: 2023-12-18 18:00:48 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2023-12-19 11:07:45 +0900

    [ruby/psych] Use `compare_by_identity` instead of `object_id`

    Object IDs became more expensive in Ruby 2.7. Using `Hash#compare_by_identity` let's us get the same effect, without needing to force all these objects to have object_ids assigned to them.

    https://github.com/ruby/psych/commit/df69e4a12e

commit 46085ef970ab50b5e1c7878345a39528823461ac
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2023-12-18 20:22:22 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2023-12-19 10:20:40 +0900

    [DOC] No ducuments for internal library

commit ce436ff3e3cbd6810d7cf83fedbd2b55995ca0b1
  Author:     Peter Zhu <peter@peterzhu.ca>
  AuthorDate: 2023-12-19 03:30:24 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2023-12-19 09:25:37 +0900

    Fix flaky test test_stat_heap

    The test sometimes fails with:

        1) Failure:
        TestGc#test_stat_heap [/tmp/ruby/src/trunk-repeat50/test/ruby/test_gc.rb:169]:
        Expected 33434403 to be <= 33434354.

commit 3c471149910d79745b50389c436f0ed2973e0d91
  Author:     Alan Wu <XrXr@users.noreply.github.com>
  AuthorDate: 2023-12-19 06:37:52 +0900
  Commit:     Alan Wu <XrXr@users.noreply.github.com>
  CommitDate: 2023-12-19 08:19:53 +0900

    Unmask signal before re-raising fatal signal

    On Linux, while the signal handler runs, that signal is masked, so in
    the rb_bug_for_fatal_signal() code path we didn't get the default signal
    action as intended. See signal(7). It worked fine on macOS, though.

    Before:

        $ ./miniruby -e 'Process.kill :SIGSEGV, Process.pid'
        <snip>
        Aborted (core dumped)

    After:

        $ ./miniruby -e 'Process.kill :SIGSEGV, Process.pid'
        <snip>
        Segmentation fault (core dumped)

    Follow-up for 1ac0afab4da "rb_bug_for_fatal_signal: exit with the right
    signal".

commit 11fa76b1b521072c200c78ea023960221ff426d6
  Author:     Alexander Momchilov <alexandermomchilov@gmail.com>
  AuthorDate: 2023-12-18 17:19:02 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2023-12-19 04:51:16 +0900

    compare_by_identity: remove alloc for non-empty Hash

    If a Hash is non-empty, there's no point calling `ar_force_convert_table`. We'll be immediately discarding that new st table, and replacing it with the new `identtable` st table that we're stealing out of `tmp`.

commit b5c6c0122f5b010cb5f43e7a236c4ba2b1d56a2a
  Author:     Alexander Momchilov <alexandermomchilov@gmail.com>
  AuthorDate: 2023-12-18 17:17:44 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2023-12-19 04:51:16 +0900

    compare_by_identity: remove alloc for empty Hash

    For non-empty Hashes, this function needs to rehash all the stored values (using the new `compare` and `hash` functions from `identhash`). It does so by writing into a newly allocated `tmp` Hash, and then transferring ownership of its st table into `self`.

    For empty Hashes, we can skip allocating this `tmp`, because there's nothing to re-hash. We can just modify our new st table's `type` in-place.

commit 893fe30ef2b30525d932d6b1256f717cc60b3311
  Author:     Matt Valentine-House <matt@eightbitraptor.com>
  AuthorDate: 2023-12-19 01:56:01 +0900
  Commit:     Matt Valentine-House <matt@eightbitraptor.com>
  CommitDate: 2023-12-19 04:44:44 +0900

    [PRISM] Fix crash when --parser=prism called with stdin

    [Bug #20071]

    Currently Ruby crashes when the --parser=prism flag is used either with
    no input, or with input that is being redirected from stdin. So all of
    the following will crash

    ruby --parser=prism
    ruby --parser=prism < test_code.rb
    cat test_code.rb | ruby --parser=prism

    This commit checks whether the input is assumed to be from stdin, and
    then processes that as a file.

    This will fix the second and third case above, but will cause a slight
    behavioural changes for the first case - Ruby will treat stdin as an
    empty file in this case and exit, rather than waiting for data to be
    piped into stdin.

commit 4b125b70d8584c6ebf2971d588c5c8a106fffc05
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2023-12-19 04:36:54 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2023-12-19 04:36:55 +0900

    [DOC] Copy Prism release notes to NEWS

commit 71b7a24c244960a581ee881d48ed38f4188364be
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2023-12-19 04:11:50 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2023-12-19 04:11:50 +0900

    [DOC] Clarify what is 3.2

commit 495a237ef35443361144ebc1bd81439c770e90e9
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2023-12-19 03:50:06 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2023-12-19 03:50:14 +0900

    [DOC] Note about yjit_alloc_size in NEWS

    It's a pretty useful feature in 3.3.

commit 6c4b04de5cba36077f86b08d54c4c316f3df1d87
  Author:     Koichi Sasada <ko1@atdot.net>
  AuthorDate: 2023-12-18 21:40:43 +0900
  Commit:     Koichi Sasada <ko1@atdot.net>
  CommitDate: 2023-12-19 02:26:37 +0900

    clear `sched->lock_onwer` at fork

    `sched->lock_owner` can be non-NULL at fork because the timer thread
    can acquire the lock while forking. `lock_owner` information is for
    debugging, so we only need to clear it at fork.

    I hope this patch fixes the following assertion failure:
    ```
    thread_pthread.c:354:thread_sched_lock_:sched->lock_owner == NULL
    ```

commit f35fec771047de15127c0e00d22b9eccd5487f51
  Author:     Peter Zhu <peter@peterzhu.ca>
  AuthorDate: 2023-12-13 00:19:56 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2023-12-19 00:37:21 +0900

    Reset pinned_slots at the beginning of GC

    pinned_slots is not being reset every GC, which causes this assertion to
    fail:

    ```
    Assertion Failed: gc.c:7076:gc_pin:GET_HEAP_PAGE(obj)->pinned_slots <= GET_HEAP_PAGE(obj)->total_slots
    ```

    This commit changes it to reset it at the beginning of every compaction
    GC cycle.

commit f6ad49b87c110b618632a4a258896e3f5673000b
  Author:     Jean Boussier <jean.boussier@gmail.com>
  AuthorDate: 2023-12-18 21:16:20 +0900
  Commit:     Benoit Daloze <eregontp@gmail.com>
  CommitDate: 2023-12-18 21:42:02 +0900

    Use #initialize instead of `initialize` in shape perf warning

    This is more consistent with other messages.

commit b2fc1b054e9c1a04c20c696f6889b6143e9b8592
  Author:     Jean Boussier <byroot@ruby-lang.org>
  AuthorDate: 2023-12-18 18:17:15 +0900
  Commit:     Jean Boussier <jean.boussier@gmail.com>
  CommitDate: 2023-12-18 20:58:08 +0900

    Update `BasicSocket#recv` documentation on return value

    Ref: https://github.com/ruby/ruby/pull/6407

    [Bug #19012]

    `0` is now interpreted as closed connection an not an
    empty packet, as these are very rare and pretty much
    useless.

commit 40fc9b070ca68e0bd1d57e4dd712172e2faeaa2b
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2023-12-18 19:57:45 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2023-12-18 20:17:45 +0900

    [DOC] No document for internal or debug methods

commit baf1403fba01c36b44dbd7bc658fed748ee7bc1e
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2023-12-18 19:52:06 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2023-12-18 20:17:45 +0900

    [DOC] Show `PTY.getpty` as an alias of `PTY.spawn`

    `:nodoc:` directive does not work at method definition in C, and must
    be at the implementation function.  That is, there is no way to make
    one method visible and another method sharing the implementation
    invisible at the same time.

commit 835f1461f7d34941c8163650eb94965533eba029
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2023-12-18 19:51:16 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2023-12-18 20:17:44 +0900

    [DOC] Add document of IO::Buffer#hexdump

commit e9b0b6015ea393af9771ca23f7493c388ef17858
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2023-12-18 19:46:24 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2023-12-18 20:17:44 +0900

    [DOC] Add documents of constants for IO#wait event mask

commit 494e6b54ab37355740f88500b75cb701339b7fd9
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2023-12-18 19:43:52 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2023-12-18 20:17:44 +0900

    [DOC] Add links from `File::Constants` in dir.c to `File` constants

    Due to the bug ruby/rdoc#1067, `rb_file_const` needs `Document-const`
    directives.

commit 9b00b2bfb290f90c572bd3d969dd1f3758ed6eea
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2023-12-18 19:42:57 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2023-12-18 20:17:44 +0900

    [DOC] Add links from `File::Constants` to `File` constants

commit a94f3f206e186b42f49475f003992f909ec1a314
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2023-12-18 14:43:42 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2023-12-18 20:17:44 +0900

    [DOC] Added notes regarding `:nodoc:` in C code

commit 9abaf00c070d00d880e05182bc1f0fba3eba8231
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2023-12-18 12:44:28 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2023-12-18 20:17:43 +0900

    [DOC] documents of aliased methods

commit ba1d1522d35a7dd2595603ead57cd0fa8b21ba8b
  Author:     Jean Boussier <byroot@ruby-lang.org>
  AuthorDate: 2023-12-18 17:59:06 +0900
  Commit:     Jean Boussier <jean.boussier@gmail.com>
  CommitDate: 2023-12-18 18:33:18 +0900

    Make the SHAPE_TOO_COMPLEX performance warning more actionable

    As suggested by Mame, we should try to help users fix the issues
    without having to lookup the meaning of the warning.

commit e8064c6c2c317be78953b4d19226368580af0dca
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2023-12-18 14:16:09 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2023-12-18 14:17:19 +0900

    Shorten the workflow name

    Looking at the name in the list, "Miscellaneous / Miscellaneous checks"
    seems too verbose/repetitive. Let's make it "Misc / Miscellaneous checks".

commit 83194aa27dcadb87a5669c05c8dc96149e8c11e2
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2023-12-18 14:14:23 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2023-12-18 14:15:11 +0900

    Make the check_misc job name more descriptive

    We're going to add check_misc as a required status check, and "checks"
    was a bit too vague for matching the job name.

commit d8978445ae6b9bc0827c55a3721de329ba441b78
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2023-12-18 13:45:09 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2023-12-18 13:45:09 +0900

    Improve YJIT documentation for Ruby 3.3 (#9263)

commit e14dddcaca6eb0a6e55c128ffdceb18681009c49
  Author:     Yusuke Endoh <mame@ruby-lang.org>
  AuthorDate: 2023-12-16 00:25:00 +0900
  Commit:     Yusuke Endoh <mame@ruby-lang.org>
  CommitDate: 2023-12-16 00:25:00 +0900

    Tweak NEWS.md

    * Move `defined?(@var)` optimization into GC section
    * Remove a trailing space.

commit 0601bce6fc57cef5ae22a944b15b8e9fca1ef6ef
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2023-12-18 08:49:06 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2023-12-18 08:49:06 +0900

    [DOC] Add Socket::ResolutionError documentation

commit 71c4a9c38f67dd393d64b4f68110b742a59cf082
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2023-12-18 08:47:59 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2023-12-18 08:47:59 +0900

    [DOC] Correct the location of Addrinfo document

    The document must be placed immediately before the class definition.
    No other statements can be placed in between.

commit e316128e3d3bdd245eb74344df5fa5c2a43eaaf7
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2023-12-18 08:38:59 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2023-12-18 08:38:59 +0900

    [DOC] Stop unintentional references to builtin or standard names

commit 7bfa1c3dc911f5c36ac64d6b4f410e4f12a7d4ca
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2023-12-17 22:37:15 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2023-12-17 22:37:15 +0900

    Revert "[DOC] Make undocumented socket constans nodoc"

    This reverts commit cbda94edd80b0f664eda927f9ce9405b2074633a, because
    `:nodoc:` does not work for constants.

    In the case of `rb_define_const`, RDoc parses the preceeding comment
    as in `"/* definition: comment */"` form.

commit aab74eafdeca6173d82eccc97de628538ff0c6fd
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2023-12-17 21:17:48 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2023-12-17 21:17:48 +0900

    [DOC] Fix Travis-CI condition

    "Not document only" should be honored always.  Also simplified repo
    and branch conditions

commit cbda94edd80b0f664eda927f9ce9405b2074633a
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2023-12-17 20:17:45 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2023-12-17 20:17:45 +0900

    [DOC] Make undocumented socket constans nodoc

commit 557d929ba699f3f30fd17290d42f331f5551a794
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2023-12-17 20:17:05 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2023-12-17 20:17:05 +0900

    [DOC] Utilize COMMENTS.default_proc to add fallback documents

commit 7a60196a8e01e7d1983d29a5c8ab93f2805987ad
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2023-12-17 20:14:41 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2023-12-17 20:14:41 +0900

    Fix ext/socket/constdefs.c dependency [ci skip]

commit e0914ed2679bfdcd5a728b19ca7af0b8bfd27eca
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2023-12-17 20:00:29 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2023-12-17 20:00:29 +0900

    Add `undocumnted` target [ci skip]

commit d7d10f3ee85ecd1a1d59a60b8c35d85602250d87
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2023-12-17 06:45:33 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2023-12-17 06:45:33 +0900

    Adjust rubygems style

commit 8db0de92a8454b449efb243f380f5d2b68c38d7c
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2023-12-17 06:39:16 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2023-12-17 06:39:16 +0900

    Restore tracked_files for ruby core repo

commit ab7f54688b495b3218843e58992b713c3b28011f
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2023-12-17 00:30:00 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2023-12-17 00:30:00 +0900

    Stir the hash value more with encoding index

commit 2f595c744e10f7d5222c477efd50fe168fe9d47e
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2023-12-17 00:21:00 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2023-12-17 00:21:00 +0900

    Adjust styles [ci skip]

commit 40113454b1362554dee83454df76e5892999247f
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2023-12-16 20:40:19 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2023-12-16 21:02:45 +0900

    Use regex instead of hard coded paths

commit ab87cd0baa884797b608013de24ab645cd38999f
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2023-12-16 19:00:42 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2023-12-16 21:02:45 +0900

    We don't use tracked_files in before(:suite). It breaks with release package.

commit ad2a38dce4ac2e28c825080f4724d0ffed805e16
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2023-12-16 16:55:45 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2023-12-16 17:36:47 +0900

    Added simple test script

commit 83bdf127b8ddbb64c941bb9c467c686140b1696b
  Author:     Samuel Giddins <segiddins@segiddins.me>
  AuthorDate: 2023-12-16 15:52:20 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2023-12-16 17:34:45 +0900

    Avoid warning when requiring bigdecimal/util when bigdecimal is in gemfile

commit 6f6b36b7e47d29ff8bc33918265a8bb4148109e8
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2023-12-16 16:39:31 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2023-12-16 16:44:34 +0900

    Added test for sub-feature like bigdecimal/util

commit b710f96b5aaeb6c153e4b1a7e1b46c4521214126
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2023-12-16 13:48:49 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2023-12-16 16:00:12 +0900

    [Bug #20068] Encoding does not matter to empty strings

commit dd49ee152ba4153f5c4cf44896975cf1e0ee739e
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2023-12-16 15:41:43 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2023-12-16 15:41:43 +0900

    Use minimum arguments for Bootsnap

commit f535f53cd6c190e9d362c2d8d3eb73fab700d761
  Author:     git <svn-admin@ruby-lang.org>
  AuthorDate: 2023-12-16 14:52:30 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2023-12-16 14:52:30 +0900

    Update default gems list at 582862754fbbcc521e3d660eba6bfb [ci skip]

commit 582862754fbbcc521e3d660eba6bfb566abf1bc2
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2023-12-16 14:50:20 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2023-12-16 14:51:34 +0900

    [ruby/io-console] Bump up v0.7.1

    https://github.com/ruby/io-console/commit/8ac766d870

commit 80d63fbea57ca5369901ee51fda1577a9ec605e0
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2023-12-16 14:48:30 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2023-12-16 14:49:13 +0900

    [ruby/readline] Bump up v0.0.4

    https://github.com/ruby/readline/commit/7dbc5bd8d9

commit cb636fe7075a260e4d47327764924a3ad10b502a
  Author:     hogelog <konbu.komuro@gmail.com>
  AuthorDate: 2023-12-07 01:05:53 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2023-12-16 14:49:12 +0900

    [ruby/readline] Fix readline-ext gem loading in non Unix-like environments

    https://github.com/ruby/readline/commit/6e1e5d0eb8

commit 20fbdae5fe3d3fa98d4f2fb8c5c8895a238576e5
  Author:     ima1zumi <52617472+ima1zumi@users.noreply.github.com>
  AuthorDate: 2023-11-29 02:00:12 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2023-12-16 14:47:04 +0900

    [ruby/reline] Bump version to 0.4.1
    (https://github.com/ruby/reline/pull/612)

    https://github.com/ruby/reline/commit/8937279e0f

commit 95064832a5f7e93dd35c9d6645e396b9f0f7e891
  Author:     git <svn-admin@ruby-lang.org>
  AuthorDate: 2023-12-16 14:22:10 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2023-12-16 14:22:10 +0900

    Update default gems list at 4fd3c85acdfa942d88d8e9e2ccd17b [ci skip]

commit 4fd3c85acdfa942d88d8e9e2ccd17b8030c2c3b2
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2023-12-16 14:20:16 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2023-12-16 14:20:55 +0900

    [ruby/ipaddr] Bump up v1.2.6

    https://github.com/ruby/ipaddr/commit/247459faa5

commit 70e3cb89907a7e33f2ae17966577cf64bacd575e
  Author:     git <svn-admin@ruby-lang.org>
  AuthorDate: 2023-12-16 14:07:47 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2023-12-16 14:07:47 +0900

    Update default gems list at 8936bb74c66e68f44d2a18564ea0b0 [ci skip]

commit 8936bb74c66e68f44d2a18564ea0b0d5e290cc6e
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2023-12-16 14:02:44 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2023-12-16 14:06:47 +0900

    [ruby/abbrev] Bump up v0.1.2

    https://github.com/ruby/abbrev/commit/b362e8e3b9

commit 3b6828f9679ac2a8cd26d9e68fa042b9c4452d0a
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2023-12-16 14:05:40 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2023-12-16 14:06:37 +0900

    [ruby/syslog] Bump up v0.1.2

    https://github.com/ruby/syslog/commit/f7b29e2199

commit 38e0ba34f48228f59354053a85aaae4dfa88e063
  Author:     git <svn-admin@ruby-lang.org>
  AuthorDate: 2023-12-16 13:11:38 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2023-12-16 13:11:38 +0900

    Update default gems list at 2b3fc0407a9b9527ae5bf806994366 [ci skip]

commit 2b3fc0407a9b9527ae5bf8069943661a061ec0ba
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2023-12-16 13:09:34 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2023-12-16 13:10:38 +0900

    [ruby/securerandom] Bump up v0.3.1

    https://github.com/ruby/securerandom/commit/890d659970

commit 7c1ec8ae5070af95b5acd0283bcc751c07895494
  Author:     git <svn-admin@ruby-lang.org>
  AuthorDate: 2023-12-16 13:01:59 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2023-12-16 13:01:59 +0900

    Update default gems list at 6a79e53823e328281b9e9eee53cd14 [ci skip]

commit 6a79e53823e328281b9e9eee53cd141af28f8548
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2023-12-16 13:00:36 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2023-12-16 13:00:59 +0900

    Rollback to released version numbers of stringio and strscan

commit 775305763a2bedc7885f7e7e5e57327e6ee01f5e
  Author:     git <svn-admin@ruby-lang.org>
  AuthorDate: 2023-12-16 12:49:53 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2023-12-16 12:49:53 +0900

    Update default gems list at 1a244730a9fada79fbfc1b2f478c2f [ci skip]

commit 1a244730a9fada79fbfc1b2f478c2fd8fc108e4a
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2023-12-16 12:46:34 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2023-12-16 12:48:49 +0900

    [ruby/open3] Bump up v0.2.1

    https://github.com/ruby/open3/commit/b890922205

commit 013e1ef514f27823b790dd5e6c55a8bb7f457b58
  Author:     git <svn-admin@ruby-lang.org>
  AuthorDate: 2023-12-16 12:43:35 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2023-12-16 12:43:35 +0900

    Update default gems list at 6c7c4ac407c4eb2f70cd599c78808c [ci skip]

commit 6c7c4ac407c4eb2f70cd599c78808c5cd10b9c13
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2023-12-16 12:39:42 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2023-12-16 12:42:30 +0900

    [ruby/rdoc] Bump up v6.6.2

    https://github.com/ruby/rdoc/commit/895f1affc0

commit d242e8416e99eaee4465e2681210ae8b7ecd6d34
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2023-12-16 12:05:46 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2023-12-16 12:08:51 +0900

    Revert all of commits after Prism 0.19.0 release

      We should bundle released version of Prism for Ruby 3.3.0

commit 122341305ff859bf30b99175bfb9db4b8f6467f5
  Author:     git <svn-admin@ruby-lang.org>
  AuthorDate: 2023-12-16 11:31:02 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2023-12-16 11:31:02 +0900

    Update default gems list at 711e85674e7c98909f5a43b7852ddc [ci skip]

commit 711e85674e7c98909f5a43b7852ddc763beaa744
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2023-12-16 11:13:35 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2023-12-16 11:13:35 +0900

    Pin versions that are RubyGems 2.5.1 and Bundler 2.5.1

commit f4e9336d4347e1086eb00494f90650cf6fde3be0
  Author:     Samuel Giddins <segiddins@segiddins.me>
  AuthorDate: 2023-12-15 18:40:34 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2023-12-16 11:13:20 +0900

    Partly pick commit from https://github.com/rubygems/rubygems/pull/7285

      Refactor vendoring to allow validating vendoring is reproducible

      Helps ensure that unsuspecting diffs to the vendored code arent accidentally introduced

commit d5af5a48a59dffdd0b156d58167e31109d19c491
  Author:     David Rodríguez <deivid.rodriguez@riseup.net>
  AuthorDate: 2023-12-16 01:59:29 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2023-12-16 11:09:50 +0900

    Fix Sinatra warning during specs

    Some specs now print the following warning:

    ```
    /path/to/bundler/tmp/1/gems/base/ruby/3.2.0/gems/sinatra-2.0.8.1/lib/sinatra/base.rb:902: warning: constant Tilt::Cache is deprecated
    ```

    Updating sinatra to latest & greatest fixes it.

    Update other deps too since at it.

commit 7cd4282cc8b4e8b242f082d806549d87964c4f8c
  Author:     David Rodríguez <deivid.rodriguez@riseup.net>
  AuthorDate: 2023-12-14 21:32:36 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2023-12-16 11:07:52 +0900

    [rubygems/rubygems] Fix Bundler daily CI

    A default Bundler copy with vendored net-http is causing a Bundler spec
    to end up loading that copy instead of the copy of Bundler under test.
    This is because of vcr, but we don't really need vcr in the command
    that's failing, so I avoided loading it.

    https://github.com/rubygems/rubygems/commit/304ab6e1b9

commit 0ff34aa13e9340871d5aeb339b5d86c52c7c2ca6
  Author:     David Rodríguez <deivid.rodriguez@riseup.net>
  AuthorDate: 2023-12-15 00:50:50 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2023-12-16 11:07:05 +0900

    [rubygems/rubygems] More improves to default gem home selection for installation

    https://github.com/rubygems/rubygems/commit/966daf7d42

commit 299eb8d1179ed7bea49c50b0fa003bf0724f6fb4
  Author:     David Rodríguez <deivid.rodriguez@riseup.net>
  AuthorDate: 2023-12-15 02:43:35 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2023-12-16 11:06:07 +0900

    [rubygems/rubygems] Improve command suggestion when gems are missing

    Previous attempt to use a full path when the running version is
    different than the one that would be activated by default are different
    was not correct.

    This is because if this error happens in a `bundle exec` context, the
    `Gem.loaded_specs` is cleared because we're in an exec'd process, so
    will be always using a full path in these cases.

    This alternative approach should do what I was expecting.

    https://github.com/rubygems/rubygems/commit/e0bb8bf51b

commit c8e9cd2b8b65e58e48d4ca14203c5a5d08a2d728
  Author:     David Rodríguez <deivid.rodriguez@riseup.net>
  AuthorDate: 2023-12-16 01:02:15 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2023-12-16 11:04:38 +0900

    [rubygems/rubygems] Fix Ruby DSL no longer working as expected

    https://github.com/rubygems/rubygems/commit/f6258e5679

    Co-authored-by: AndrewSwerlick <andrew.swerlick@gmail.com>

commit b8074c2f043d99f6f30ab75ad21cc2c998f49dcf
  Author:     eileencodes <eileencodes@gmail.com>
  AuthorDate: 2023-12-16 01:32:10 +0900
  Commit:     Kevin Newton <kddnewton@gmail.com>
  CommitDate: 2023-12-16 06:23:06 +0900

    [PRISM] Fix incorrect instructions for `default_proc=`

    This is kind of specific and was found via debugging ruby/prism#2061 but
    does not actually fix that issue.

    The change here checks for `!popped` for the additional instructions
    that are normally added for nodes with the `attribute_write` flag.

    I also removed the extra catch table by deleting the
    `ISEQ_COMPILE_DATA(iseq)->catch_except_p = true;` line. I'm...not
    entirely sure why it was added but it doesn't match the upstream
    compiler
    [code](https://github.com/ruby/ruby/blob/92b10f5be7453aceb5863e46ac775a4ddbf83b97/compile.c#L887-L892).

    The changes here unfortunately don't improve the test failures mentioned in
    the linked issue so we still have other issues with instructions for
    hashes.

    Instructions before:

    ```
    "********* Ruby *************"
    == disasm: #<ISeq:<compiled>@<compiled>:1 (1,0)-(34,8)>
    local table (size: 1, argc: 0 [opts: 0, rest: -1, post: 0, block: -1, kw: -1@-1, kwrest: -1])
    [ 1] h@0
    0000 putnil                                                           (  32)[Li]
    0001 putobject                              true
    0003 getconstant                            :Hash
    0005 send                                   <calldata!mid:new, argc:0, ARGS_SIMPLE>, nil
    0008 setlocal                               h@0, 0
    0011 getlocal                               h@0, 0                    (  33)[Li]
    0014 putspecialobject                       1
    0016 send                                   <calldata!mid:lambda, argc:0, FCALL>, block in <compiled>
    0019 send                                   <calldata!mid:default_proc=, argc:1, ARGS_SIMPLE>, nil
    0022 pop
    0023 getlocal                               h@0, 0                    (  34)[Li]
    0026 putobject                              :nope
    0028 send                                   <calldata!mid:[], argc:1, ARGS_SIMPLE>, nil
    0031 leave

    == disasm: #<ISeq:block in <compiled>@<compiled>:33 (33,19)-(33,32)>
    local table (size: 2, argc: 2 [opts: 0, rest: -1, post: 0, block: -1, kw: -1@-1, kwrest: -1])
    [ 2] _@0<Arg>   [ 1] _@1<Arg>
    0000 putobject                              true                      (  33)[LiBc]
    0002 leave                                  [Br]
    true
    "********* PRISM *************"
    == disasm: #<ISeq:<compiled>@<compiled>:31 (31,0)-(33,8)>
    local table (size: 1, argc: 0 [opts: 0, rest: -1, post: 0, block: -1, kw: -1@-1, kwrest: -1])
    [ 1] h@0
    0000 putnil                                                           (  31)[Li]
    0001 putobject                              true
    0003 getconstant                            :Hash
    0005 send                                   <calldata!mid:new, argc:0, ARGS_SIMPLE>, nil
    0008 setlocal                               h@0, 0
    0011 putnil                                                           (  32)[Li]
    0012 getlocal                               h@0, 0
    0015 putspecialobject                       1
    0017 send                                   <calldata!mid:lambda, argc:0, FCALL>, block in <compiled>
    0020 setn                                   2
    0022 send                                   <calldata!mid:default_proc=, argc:1, ARGS_SIMPLE>, nil
    0025 pop
    0026 pop
    0027 getlocal                               h@0, 0                    (  33)[Li]
    0030 putobject                              :nope
    0032 send                                   <calldata!mid:[], argc:1, ARGS_SIMPLE>, nil
    0035 leave                                                            (  31)

    == disasm: #<ISeq:block in <compiled>@<compiled>:32 (32,17)-(32,32)>
    == catch table
    | catch type: redo   st: 0000 ed: 0002 sp: 0000 cont: 0000
    | catch type: next   st: 0000 ed: 0002 sp: 0000 cont: 0002
    |------------------------------------------------------------------------
    local table (size: 2, argc: 2 [opts: 0, rest: -1, post: 0, block: -1, kw: -1@-1, kwrest: -1])
    [ 2] _@0<Arg>   [ 1] _@1<Arg>
    0000 putobject                              true                      (  32)[LiBc]
    0002 leave                                  [Br]
    ```

    Instructions after:

    ```
    "********* Ruby *************"
    == disasm: #<ISeq:<compiled>@<compiled>:1 (1,0)-(34,8)>
    local table (size: 1, argc: 0 [opts: 0, rest: -1, post: 0, block: -1, kw: -1@-1, kwrest: -1])
    [ 1] h@0
    0000 putnil                                                           (  32)[Li]
    0001 putobject                              true
    0003 getconstant                            :Hash
    0005 send                                   <calldata!mid:new, argc:0, ARGS_SIMPLE>, nil
    0008 setlocal                               h@0, 0
    0011 getlocal                               h@0, 0                    (  33)[Li]
    0014 putspecialobject                       1
    0016 send                                   <calldata!mid:lambda, argc:0, FCALL>, block in <compiled>
    0019 send                                   <calldata!mid:default_proc=, argc:1, ARGS_SIMPLE>, nil
    0022 pop
    0023 getlocal                               h@0, 0                    (  34)[Li]
    0026 putobject                              :nope
    0028 send                                   <calldata!mid:[], argc:1, ARGS_SIMPLE>, nil
    0031 leave

    == disasm: #<ISeq:block in <compiled>@<compiled>:33 (33,19)-(33,32)>
    local table (size: 2, argc: 2 [opts: 0, rest: -1, post: 0, block: -1, kw: -1@-1, kwrest: -1])
    [ 2] _@0<Arg>   [ 1] _@1<Arg>
    0000 putobject                              true                      (  33)[LiBc]
    0002 leave                                  [Br]

    "********* PRISM *************"
    == disasm: #<ISeq:<compiled>@<compiled>:31 (31,0)-(33,8)>
    local table (size: 1, argc: 0 [opts: 0, rest: -1, post: 0, block: -1, kw: -1@-1, kwrest: -1])
    [ 1] h@0
    0000 putnil                                                           (  31)[Li]
    0001 putobject                              true
    0003 getconstant                            :Hash
    0005 send                                   <calldata!mid:new, argc:0, ARGS_SIMPLE>, nil
    0008 setlocal                               h@0, 0
    0011 getlocal                               h@0, 0                    (  32)[Li]
    0014 putspecialobject                       1
    0016 send                                   <calldata!mid:lambda, argc:0, FCALL>, block in <compiled>
    0019 send                                   <calldata!mid:default_proc=, argc:1, ARGS_SIMPLE>, nil
    0022 pop
    0023 getlocal                               h@0, 0                    (  33)[Li]
    0026 putobject                              :nope
    0028 send                                   <calldata!mid:[], argc:1, ARGS_SIMPLE>, nil
    0031 leave                                                            (  31)

    == disasm: #<ISeq:block in <compiled>@<compiled>:32 (32,17)-(32,32)>
    local table (size: 2, argc: 2 [opts: 0, rest: -1, post: 0, block: -1, kw: -1@-1, kwrest: -1])
    [ 2] _@0<Arg>   [ 1] _@1<Arg>
    0000 putobject                              true                      (  32)[LiBc]
    0002 leave                                  [Br]
    ```

commit 161787f9beef96c9fa1057b6378fe7e048ac2ecd
  Author:     Matt Valentine-House <matt@eightbitraptor.com>
  AuthorDate: 2023-12-16 05:07:49 +0900
  Commit:     Kevin Newton <kddnewton@gmail.com>
  CommitDate: 2023-12-16 06:15:10 +0900

    [PRISM] Compile CallTargetNode

commit 5b6a4d8c1253fd1ab77c0539d33276fe1856cf24
  Author:     Matt Valentine-House <matt@eightbitraptor.com>
  AuthorDate: 2023-12-14 06:09:39 +0900
  Commit:     Kevin Newton <kddnewton@gmail.com>
  CommitDate: 2023-12-16 06:15:10 +0900

    [PRISM] Compile IndexTargetNode

commit b9542246c92109b9639ee9976ac16f54a8759cfc
  Author:     Gopal Patel <nixme@stillhope.com>
  AuthorDate: 2023-12-16 04:32:12 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2023-12-16 06:14:58 +0900

    [ruby/prism] Fix majority of RBS type mismatches

    https://github.com/ruby/prism/commit/62cc50e41b

commit 2e8cfcac9129ed8680c4b916bc5b4c535ae6e8c8
  Author:     eileencodes <eileencodes@gmail.com>
  AuthorDate: 2023-12-16 03:44:31 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2023-12-16 05:55:13 +0900

    [ruby/prism] String literal hash keys should be frozen

    String literal hash keys can't be mutated by the user so we should mark
    them as frozen. We were seeing instructions for hashes with string
    literal keys using two `putstring` instructions when it should be a
    `putobject` and `putstring`.

    Code example:

    ```ruby
    { "a" => "b" }
    ```

    Instructions before:

    ```
    "********* Ruby *************"
    == disasm: #<ISeq:<compiled>@<compiled>:1 (1,0)-(2,14)>
    0000 putobject                              "a"                       (   2)[Li]
    0002 putstring                              "b"
    0004 newhash                                2
    0006 leave
    "********* PRISM *************"
    == disasm: #<ISeq:<compiled>@<compiled>:1 (1,0)-(1,14)>
    0000 putstring                              "a"                       (   1)[Li]
    0002 putstring                              "b"
    0004 newhash                                2
    0006 leave
    ```

    Instructions after:

    ```
    "********* Ruby *************"
    == disasm: #<ISeq:<compiled>@<compiled>:1 (1,0)-(2,14)>
    0000 putobject                              "a"                       (   2)[Li]
    0002 putstring                              "b"
    0004 newhash                                2
    0006 leave

    "********* PRISM *************"
    == disasm: #<ISeq:<compiled>@<compiled>:1 (1,0)-(1,14)>
    0000 putobject                              "a"                       (   1)[Li]
    0002 putstring                              "b"
    0004 newhash                                2
    0006 leave
    ```

    https://github.com/ruby/prism/commit/b14ae55385

commit 9c9e6d5b91f23c15357d88036382d68ae3c77d97
  Author:     Koichi Sasada <ko1@atdot.net>
  AuthorDate: 2023-12-16 04:39:31 +0900
  Commit:     Koichi Sasada <ko1@atdot.net>
  CommitDate: 2023-12-16 04:45:25 +0900

    [DOC] NEWS entries for C APIs

commit f933cde9390563160d8a12c901e7a408f523c457
  Author:     Martin Emde <martin.emde@gmail.com>
  AuthorDate: 2023-12-16 03:30:14 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2023-12-16 04:36:24 +0900

    [rubygems/rubygems] Let the guards have some space to breathe

    https://github.com/rubygems/rubygems/commit/73f1609715

commit d9b39093e2bac70f121e38f4354a6a58c1b245a3
  Author:     Martin Emde <martin.emde@gmail.com>
  AuthorDate: 2023-12-15 05:42:15 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2023-12-16 04:36:24 +0900

    [rubygems/rubygems] Use a mutex around Checksum::Store @store access

    Not wrapping to_lock since access to it is single threaded and
    read-only at the time of writing the lockfile.

    https://github.com/rubygems/rubygems/commit/3b53aa1b12

commit 1cfe874ef83cdb7776ecf892c470af634532501c
  Author:     Martin Emde <martin.emde@gmail.com>
  AuthorDate: 2023-12-15 05:41:08 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2023-12-16 04:36:24 +0900

    [rubygems/rubygems] Remove test-only & unused methods from Checksum::Store

    https://github.com/rubygems/rubygems/commit/79636dec12

commit 0a31cb1a37f184daa7c2839abd6a827793fdd2f3
  Author:     Ufuk Kayserilioglu <ufuk.kayserilioglu@shopify.com>
  AuthorDate: 2023-12-16 03:03:44 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2023-12-16 03:45:36 +0900

    [ruby/prism] Finish keyword hash node flag refactor by renaming flag

    https://github.com/ruby/prism/commit/7f812389f8

commit b418e5a5800513da7204c0ba7b3a95a2d9ee9a7e
  Author:     Kevin Newton <kddnewton@gmail.com>
  AuthorDate: 2023-12-16 03:18:40 +0900
  Commit:     Kevin Newton <kddnewton@gmail.com>
  CommitDate: 2023-12-16 03:42:19 +0900

    Update error message in test_rubyoptions

commit a604fe42620735f7bd1145e01bdca5398231ffb0
  Author:     Adam Hess <HParker@github.com>
  AuthorDate: 2023-12-15 07:40:37 +0900
  Commit:     Kevin Newton <kddnewton@gmail.com>
  CommitDate: 2023-12-16 03:42:19 +0900

    update message to clarify compiler, not parser

    Co-authored-by: Ufuk Kayserilioglu <ufuk@paralaus.com>

commit 55326a915f25608be1d40ab32baa9fc57762615d
  Author:     HParker <HParker@github.com>
  AuthorDate: 2023-12-08 08:47:36 +0900
  Commit:     Kevin Newton <kddnewton@gmail.com>
  CommitDate: 2023-12-16 03:42:19 +0900

    Introduce --parser runtime flag

    Introduce runtime flag for specifying the parser,

    ```
    ruby --parser=prism
    ```

    also update the description:

    ```
    $ ruby --parser=prism --version
    ruby 3.3.0dev (2023-12-08T04:47:14Z add-parser-runtime.. 0616384c9f) +PRISM [x86_64-darwin23]
    ```

    [Bug #20044]

commit 655c02790ee5aca122d3593fadab5b41a42a1899
  Author:     Burdette Lamar <BurdetteLamar@Yahoo.com>
  AuthorDate: 2023-12-16 03:32:32 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2023-12-16 03:32:32 +0900

    [DOC] RDoc for Complex (#9254)

commit 92b10f5be7453aceb5863e46ac775a4ddbf83b97
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2023-12-16 01:07:06 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2023-12-16 02:11:51 +0900

    [Bug #20062] Fixed numbered parameter syntax error

    At the method definition, the local scope that saves the context of
    the numbered parameters needs to be pushed before saving.

commit 1ac0afab4da1986d6eefd421ca3877afd47d2a77
  Author:     Jean Boussier <byroot@ruby-lang.org>
  AuthorDate: 2023-12-16 01:08:34 +0900
  Commit:     Jean Boussier <jean.boussier@gmail.com>
  CommitDate: 2023-12-16 01:48:43 +0900

    rb_bug_for_fatal_signal: exit with the right signal

    `die()` calls `abort()` which always exit as it `SIGABRT`
    was received.

    This isn't very friendly with systems that automatically
    collect crashes as the `%s` parameter will be changed.

commit c9a9b8036c71974ab938a8bb3d6f095d4a318a8e
  Author:     Koichi Sasada <ko1@atdot.net>
  AuthorDate: 2023-12-15 18:25:12 +0900
  Commit:     Koichi Sasada <ko1@atdot.net>
  CommitDate: 2023-12-16 01:00:01 +0900

    remove `Ractor::Selector` from Ruby level

    `Ractor::Selector` is not approved by Matz so remove it from
    Ruby-level.

    The implementation is used by `Ractor.select` so most of implementation
    was remaind and calling `rb_init_ractor_selector()`, `Ractor::Selector`
    will be defined. I will provide `ractor-selector` gem to try it.

commit 9b4cb69a88163340cac7c0a350eaf18832edb28f
  Author:     Koichi Sasada <ko1@atdot.net>
  AuthorDate: 2023-12-15 18:59:54 +0900
  Commit:     Koichi Sasada <ko1@atdot.net>
  CommitDate: 2023-12-16 01:00:01 +0900

    support `skip` in bootstraptest

commit 5a66ea23d2c244bac5d87a08939419cd300cf4cc
  Author:     Samuel Giddins <segiddins@segiddins.me>
  AuthorDate: 2023-12-14 11:10:49 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2023-12-16 00:32:56 +0900

    [rubygems/rubygems] Use mkdir_p helper in bundler.rb

    Small refactor, no functional change

    https://github.com/rubygems/rubygems/commit/5edb7a1026

commit 474b4c42f4d1c36d94548548e03f6649f2119f67
  Author:     HParker <HParker@github.com>
  AuthorDate: 2023-12-15 05:03:00 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2023-12-16 00:31:15 +0900

    free ractors with ractor_free

    Previously with RUBY_FREE_ON_EXIT, ractors where being xfree-ed which is incorrect since they are not xmalloced.
    Instead we can free ractors with ractor free during shutdown. This change only effects main ractor freeing when RUBY_FREE_ON_EXIT is set.

    Co-authored-by: John Hawthorn <john@hawthorn.email>

commit 049a9bd62f0907caa8d2eca6337cd2542a5c7726
  Author:     eileencodes <eileencodes@gmail.com>
  AuthorDate: 2023-12-14 02:49:37 +0900
  Commit:     Kevin Newton <kddnewton@gmail.com>
  CommitDate: 2023-12-16 00:27:44 +0900

    [PRISM] Fix `compile_prism` when src is a file

    `compile_prism` can take a source and file (and other arguments) or a
    file as the source. `compile` checks if the source is a file and if it
    is converts it. `compile_prism` is now doing the same thing.

    On the Ruby side `compile` handles a file
    [here](https://github.com/ruby/ruby/blob/master/iseq.c#L1159-L1162).

    Before:

    ```
    "********* Ruby *************"
    == disasm: #<ISeq:<compiled>@<compiled>:1 (1,0)-(26,21)>
    local table (size: 1, argc: 0 [opts: 0, rest: -1, post: 0, block: -1, kw: -1@-1, kwrest: -1])
    [ 1] name@0
    0000 putstring                              "Prism"                   (  25)[Li]
    0002 setlocal                               name@0, 0
    0005 putself                                                          (  26)[Li]
    0006 putobject                              "hello, "
    0008 getlocal                               name@0, 0
    0011 dup
    0012 objtostring                            <calldata!mid:to_s, argc:0, FCALL|ARGS_SIMPLE>
    0014 anytostring
    0015 concatstrings                          2
    0017 send                                   <calldata!mid:puts, argc:1, FCALL|ARGS_SIMPLE>, nil
    0020 leave
    hello, Prism

    "********* PRISM *************"
    ./test.rb:13:in `compile_prism': wrong argument type File (expected String) (TypeError)
            from ./test.rb:13:in `<main>'
    make: *** [run] Error 1
    ```

    After:

    ```
    "********* Ruby *************"
    == disasm: #<ISeq:<compiled>@<compiled>:1 (1,0)-(26,21)>
    local table (size: 1, argc: 0 [opts: 0, rest: -1, post: 0, block: -1, kw: -1@-1, kwrest: -1])
    [ 1] name@0
    0000 putstring                              "Prism"                   (  25)[Li]
    0002 setlocal                               name@0, 0
    0005 putself                                                          (  26)[Li]
    0006 putobject                              "hello, "
    0008 getlocal                               name@0, 0
    0011 dup
    0012 objtostring                            <calldata!mid:to_s, argc:0, FCALL|ARGS_SIMPLE>
    0014 anytostring
    0015 concatstrings                          2
    0017 send                                   <calldata!mid:puts, argc:1, FCALL|ARGS_SIMPLE>, nil
    0020 leave

    "********* PRISM *************"
    == disasm: #<ISeq:<compiled>@test_code.rb:24 (24,0)-(25,21)>
    local table (size: 1, argc: 0 [opts: 0, rest: -1, post: 0, block: -1, kw: -1@-1, kwrest: -1])
    [ 1] name@0
    0000 putstring                              "Prism"                   (  24)[Li]
    0002 setlocal                               name@0, 0
    0005 putself                                                          (  25)[Li]
    0006 putobject                              "hello, "
    0008 getlocal                               name@0, 0
    0011 dup
    0012 objtostring                            <calldata!mid:to_s, argc:0, FCALL|ARGS_SIMPLE>
    0014 anytostring
    0015 concatstrings                          2
    0017 send                                   <calldata!mid:puts, argc:1, FCALL|ARGS_SIMPLE>, nil
    0020 leave                                                            (  24)
    ```

    Fixes ruby/prism#1609

commit 20f4f007644b841c71402a5ae64ee5373dc7b91a
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2023-12-15 19:36:07 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2023-12-16 00:26:39 +0900

    [ruby/rdoc] [DOC] nodoc for probably internal methods

    https://github.com/ruby/rdoc/commit/f7dd147a8c

commit e15d690db147fb059a48f87bf639fdf0c006a22b
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2023-12-15 19:35:16 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2023-12-16 00:26:37 +0900

    [ruby/rdoc] [DOC] Add missing documents

    https://github.com/ruby/rdoc/commit/e4c90340d0

commit 578eb02b16218ce842a30bf794bf52a68e680a38
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2023-12-15 19:26:46 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2023-12-16 00:25:53 +0900

    [ruby/rdoc] Require fileutils before using it

    https://github.com/ruby/rdoc/commit/edb2523018

commit b257181ccc9cf46cfcbe085083f3ebffcd8abf09
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2023-12-15 19:20:47 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2023-12-16 00:25:51 +0900

    [ruby/rdoc] Remove unused method `RDoc::Encoding.remove_frozen_string_literal`

    https://github.com/ruby/rdoc/commit/7a8e9a97fa

commit f38814564b1c8d9394ae4568fb0dfd2bbbfe3440
  Author:     Kevin Newton <kddnewton@gmail.com>
  AuthorDate: 2023-12-16 00:07:55 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2023-12-16 00:19:50 +0900

    [ruby/prism] Fix eval parsing depth

    https://github.com/ruby/prism/commit/89bf7a4948

commit fe9b42f024eb3724b0853c914916ea7a97fd30a6
  Author:     Kevin Newton <kddnewton@gmail.com>
  AuthorDate: 2023-12-15 22:48:39 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2023-12-16 00:03:49 +0900

    [ruby/prism] Invalid pinned locals in pattern matching

    https://github.com/ruby/prism/commit/3a67b37a56

commit 1cd4b59e8cf56850a87a56194e7096db63f40204
  Author:     Samuel Giddins <segiddins@segiddins.me>
  AuthorDate: 2023-12-14 11:11:42 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2023-12-15 23:53:10 +0900

    [rubygems/rubygems] Save array allocation for every dependency in Gemfile

    Only need to check for lack of git key when branch option is present

    https://github.com/rubygems/rubygems/commit/ebfca1b389

commit ca7f7c0f516512c7e5b19aa74e05939b27bb37e4
  Author:     Samuel Giddins <segiddins@segiddins.me>
  AuthorDate: 2023-12-15 18:40:34 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2023-12-15 23:48:25 +0900

    [rubygems/rubygems] Refactor vendoring to allow validating vendoring is reproducible

    Helps ensure that unsuspecting diffs to the vendored code arent accidentally introduced

    https://github.com/rubygems/rubygems/commit/7c425d49dd

commit 10a0545b6e0a4ed5eee1edff725f7955b2f26914
  Author:     Burdette Lamar <BurdetteLamar@Yahoo.com>
  AuthorDate: 2023-12-15 23:39:12 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2023-12-15 23:39:12 +0900

    [DOC] RDoc for Complex (#9243)

commit 7cbc08b388cfc6d9bd2023c313165bff37ba2c11
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2023-12-15 21:49:58 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2023-12-15 22:37:38 +0900

    Follow removed conflict files

    After editing a conflict, continue without removed files.

commit 854ff25f4f4a0c1183b742bd5077985236348c57
  Author:     Kevin Newton <kddnewton@gmail.com>
  AuthorDate: 2023-12-15 22:26:33 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2023-12-15 22:26:40 +0900

    [ruby/prism] Add TODO comment

    https://github.com/ruby/prism/commit/885d1d78cb

commit 16830a47830d6e780b7ce649f0247bdddd32f51d
  Author:     TSUYUSATO Kitsune <make.just.on@gmail.com>
  AuthorDate: 2023-12-11 12:29:20 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2023-12-15 22:25:54 +0900

    [ruby/prism] Add an error for `in` keyword in arguments

    Fix https://github.com/ruby/prism/pull/2026

    https://github.com/ruby/prism/commit/c4b41cd477

commit 04f7be612625a51523c7ae546a8774aea1a8fa12
  Author:     Satoshi Tagomori <tagomoris@gmail.com>
  AuthorDate: 2023-12-15 15:57:51 +0900
  Commit:     Yusuke Endoh <mame@ruby-lang.org>
  CommitDate: 2023-12-15 21:36:27 +0900

    loading/testing in different processes for multiple runs

commit 7c72755da8577947f564aeb264a201f62b032996
  Author:     David Rodríguez <deivid.rodriguez@riseup.net>
  AuthorDate: 2023-12-15 06:59:15 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2023-12-15 20:52:38 +0900

    [rubygems/rubygems] Fix `ruby setup.rb` leaving traces in source folder

    It's the `Gem::Installer` below what installs executables, and the code
    being deleted here is now actually creating a `gems/` folder in the root
    of the source repo when running `ruby setup.rb`.

    https://github.com/rubygems/rubygems/commit/0e69a8b0d6

commit 4d5bfa7c3b3f21ed32f32542d66922d0481004bb
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2023-12-15 15:39:14 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2023-12-15 15:39:14 +0900

    Ignore the spcial case of target_cpu

    On Windows, x86_64 is called as x64.

commit 2c2c6bc3fac34b7dd7ecafd08c7f12fc47988799
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2023-12-15 15:19:16 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2023-12-15 15:19:16 +0900

    Fix `ARCH_FLAG` when cross-compiling on macOS

commit 1e5c4026d5c75e6867f6e97de0aeaea55e62d26b
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2023-12-15 14:10:02 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2023-12-15 14:10:02 +0900

    Fix `ARCH_FLAG` when `--with-arch` with single CPU

commit cc9aeec23e260a42fea9bf27835331ff76d24c4a
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2023-12-15 15:14:48 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2023-12-15 15:14:48 +0900

    Explained about test_for_warn_bundled_gems

commit c3ae4b6ae12546a1b5adb33f8789a7bddd4739f1
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2023-12-15 15:06:48 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2023-12-15 15:06:53 +0900

    Revert "[Bug #20060] Properly return matched gem name in case of EXACT"

      This reverts commit 75c40802cb06d83fc2c3d0eca6d904fa41307230.

      This change is now working correctly with warning cases.

commit 202c608248a63979b1f43e9b7970a259d3d5e726
  Author:     git <svn-admin@ruby-lang.org>
  AuthorDate: 2023-12-15 15:05:41 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2023-12-15 15:05:41 +0900

    * append newline at EOF. [ci skip]

commit 8df46d54bf9722ed0ab84f24e5fa48fe2fecfdd5
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2023-12-15 14:49:46 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2023-12-15 15:05:13 +0900

    Added test case of dash gem like net-smtp

commit 9a204fb82e36dc30fc86827234e99ca6f55d442c
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2023-12-15 14:48:10 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2023-12-15 15:05:13 +0900

    Added test case of bootsnap

commit 25a133ba17a0025451befecd4008b18de2c1e190
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2023-12-15 14:40:30 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2023-12-15 15:05:13 +0900

    Added test case of bundle exec

commit 66b82a4430a38dbbee0b69896743b5eed4c5badd
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2023-12-15 14:37:39 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2023-12-15 15:05:13 +0900

    Added test case of bundled gems dependencies

commit 76c1ce4e379535ed92ebc2197563b36bfd8b2beb
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2023-12-15 14:34:56 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2023-12-15 15:05:13 +0900

    Added basic test case of bundled gems warning

commit 8e37cd8a8bd2263c66243a35f25b5e741635c893
  Author:     David Rodríguez <deivid.rodriguez@riseup.net>
  AuthorDate: 2023-12-15 00:02:00 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2023-12-15 15:04:36 +0900

    Fix gem detection for names with dash

commit 6408775b08b3f36d8fee4e694760caffb852ee8a
  Author:     git <svn-admin@ruby-lang.org>
  AuthorDate: 2023-12-15 12:57:40 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2023-12-15 12:57:40 +0900

    Update bundled gems list at b562efdf6d23d056764b334764a030 [ci skip]

commit b562efdf6d23d056764b334764a030eb72ea91a9
  Author:     Shugo Maeda <shugo@ruby-lang.org>
  AuthorDate: 2023-12-15 12:57:03 +0900
  Commit:     Shugo Maeda <shugo@ruby-lang.org>
  CommitDate: 2023-12-15 12:57:03 +0900

    Bump up bundled net-ftp gem version to 0.3.3

commit 406d4bb59905903cf7b9fa62c2d590e963edda5c
  Author:     Koichi Sasada <ko1@atdot.net>
  AuthorDate: 2023-12-15 11:21:39 +0900
  Commit:     Koichi Sasada <ko1@atdot.net>
  CommitDate: 2023-12-15 11:58:43 +0900

    add a test

    proposed at https://bugs.ruby-lang.org/issues/20050#note-5

commit 7ba2506232d3fa6c4e82e3708c0ff746a1a8de5c
  Author:     Koichi Sasada <ko1@atdot.net>
  AuthorDate: 2023-12-15 03:42:40 +0900
  Commit:     Koichi Sasada <ko1@atdot.net>
  CommitDate: 2023-12-15 11:58:43 +0900

    check modifcation while ar->st

    * delete `ar_try_convert` but use `ar_force_convert_table`
      to make program simple.
    * `ar_force_convert_table` checks hash modification while
      calling `#hash` method with the following strategy:

    1. copy keys (and vals) of ar_table
    2. calc hashes from keys
    3. check copied keys and hash's keys. if not matched, repeat from 1

    fix [Bug #20050]

commit 29e99c84ae8059cd308cf1c06be05f62c55cd68d
  Author:     Jeremy Evans <code@jeremyevans.net>
  AuthorDate: 2023-12-15 11:44:13 +0900
  Commit:     Jeremy Evans <code@jeremyevans.net>
  CommitDate: 2023-12-15 11:44:13 +0900

    Remove unused variables in test_call_op_asgn_keywords_mutable

commit b98bd10f255d0afe33ba3c4410dd2c05c61695fb
  Author:     Satoshi Tagomori <tagomoris@gmail.com>
  AuthorDate: 2023-12-15 10:38:33 +0900
  Commit:     Yusuke Endoh <mame@ruby-lang.org>
  CommitDate: 2023-12-15 11:09:31 +0900

    stop warnings from running the test case requiring .so twice

commit cfd91121ad71655ef9cea48450a0027a00a46f8f
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2023-12-15 10:24:06 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2023-12-15 10:24:08 +0900

    Trigger auto-request-review only for master branch

commit 68020516bab1b885942450c48a9708ea2f726f68
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2023-12-15 08:55:14 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2023-12-15 08:55:15 +0900

    [DOC] Reverse-merge YJIT release notes to NEWS

commit 5587bd4b37cc01227ce5546b3350033bb1ef9775
  Author:     Jemma Issroff <jemmaissroff@gmail.com>
  AuthorDate: 2023-12-15 06:44:38 +0900
  Commit:     Jemma Issroff <jemmaissroff@gmail.com>
  CommitDate: 2023-12-15 07:11:54 +0900

    [PRISM] Implement safe navigation in CallNodes

    This commit implements safe navigation for CallNodes,
    CallAndWriteNodes and CallOperatorWriteNodes

commit 39c072d6f7846a99f64e52090a320576715325c5
  Author:     Victor Shepelev <zverok.offline@gmail.com>
  AuthorDate: 2023-12-15 06:33:33 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2023-12-15 06:33:33 +0900

    [DOC] Enhance docs for WeakMap and WeakKeyMap (#9160)

    Enhance docs for WeakMap and WeakKeyMap

    * WeakKeyMap: more class-level explanations, more details
      on #getkey, fix a slight bug in code of #delete example;
    * WeekMap: a bit more detailed class- and method-level docs.

commit 570d7b2c3e2ee39e07548dfe242b684ec794789d
  Author:     Victor Shepelev <zverok.offline@gmail.com>
  AuthorDate: 2023-12-15 06:01:48 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2023-12-15 06:01:48 +0900

    [DOC] Adjust some new features wording/examples. (#9183)

    * Reword Range#overlap? docs last paragraph.

    * Docs: add explanation about Queue#freeze

    * Docs: Add :rescue event docs for TracePoint

    * Docs: Enhance Module#set_temporary_name documentation

    * Docs: Slightly expand Process::Status deprecations

    * Fix MatchData#named_captures rendering glitch

    * Improve Dir.fchdir examples

    * Adjust Refinement#target docs

commit d3deb1b8232a303dd40909e32f939bad3b24a8af
  Author:     Kevin Newton <kddnewton@gmail.com>
  AuthorDate: 2023-12-15 05:25:54 +0900
  Commit:     Kevin Newton <kddnewton@gmail.com>
  CommitDate: 2023-12-15 05:26:01 +0900

    [prism] Fix build with no asserts

commit 08c2c4f922916bd7882813feab68c7c12b89bcbd
  Author:     git <svn-admin@ruby-lang.org>
  AuthorDate: 2023-12-15 05:07:47 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2023-12-15 05:07:47 +0900

    Update default gems list at 8bbe835cd872a3af411cb6a950e275 [ci skip]

commit 8bbe835cd872a3af411cb6a950e2751c02060f3f
  Author:     Kevin Newton <kddnewton@gmail.com>
  AuthorDate: 2023-12-15 05:06:09 +0900
  Commit:     Kevin Newton <kddnewton@gmail.com>
  CommitDate: 2023-12-15 05:06:09 +0900

    Bump prism to version 0.19.0

commit d07fdc5edee219bbbd6262f909d636a509793cca
  Author:     Ufuk Kayserilioglu <ufuk.kayserilioglu@shopify.com>
  AuthorDate: 2023-12-15 03:15:30 +0900
  Commit:     Jemma Issroff <jemmaissroff@gmail.com>
  CommitDate: 2023-12-15 04:08:37 +0900

    [PRISM] Fix keyword hash handling in method calls

    * Start using the renamed `PM_KEYWORD_HASH_NODE_FLAGS_SYMBOL_KEYS` flag
    to check if all keys of the keyword hash node are symbols.
    * For arguments passed as a hash, start marking them as `KW_SPLAT_MUT` only if the number of entries in the hash is greater than 1 (which is what the old compiler used to do).

commit 295d97ab4dc826a4c2b812d254a6607c87534ed7
  Author:     Kevin Newton <kddnewton@gmail.com>
  AuthorDate: 2023-12-14 01:34:05 +0900
  Commit:     Kevin Newton <kddnewton@gmail.com>
  CommitDate: 2023-12-15 04:06:26 +0900

    Pattern matching

commit 019fff3a8656cadad93ba8d6db476428bd8d7a5e
  Author:     Kevin Newton <kddnewton@gmail.com>
  AuthorDate: 2023-12-15 02:48:25 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2023-12-15 03:54:46 +0900

    [ruby/prism] Fix parse result for nesting pattern matching

    https://github.com/ruby/prism/commit/ee6fc9ee87

commit 5a66832952fa1ee971406b797605f72cead6e9c4
  Author:     eileencodes <eileencodes@gmail.com>
  AuthorDate: 2023-12-15 02:20:24 +0900
  Commit:     Jemma Issroff <jemmaissroff@gmail.com>
  CommitDate: 2023-12-15 03:48:38 +0900

    [Prism] Fix cvar or assignment instructions

    The instructions for `PM_CLASS_VARIABLE_OR_WRITE_NODE` were incorrect as
    they were missing a `putnil`, a `defined`, and a `branchunless`.

    I verified this is fixed via the instructions and running the following:
    `RUBY_ISEQ_DUMP_DEBUG=prism make test/csv/interface/test_read_write.rb`.

    These new instructions can't go in the defined function because
    `defined?(@@fop ||= 1)` should return "assignment" not "class variable".

    Instructions before:

    ```
    "********* Ruby *************"
    == disasm: #<ISeq:<compiled>@<compiled>:1 (1,0)-(30,11)>
    0000 putnil                                                           (  30)[Li]
    0001 defined                                class variable, :@@foo, true
    0005 branchunless                           14
    0007 getclassvariable                       :@@foo, <is:0>
    0010 dup
    0011 branchif                               20
    0013 pop
    0014 putobject                              1
    0016 dup
    0017 setclassvariable                       :@@foo, <is:0>
    0020 leave

    "********* PRISM *************"
    == disasm: #<ISeq:<compiled>@<compiled>:29 (29,0)-(29,11)>
    0000 getclassvariable                       :@@foo, <is:0>            (  29)[Li]
    0003 dup
    0004 branchif                               13
    0006 pop
    0007 putobject                              1
    0009 dup
    0010 setclassvariable                       :@@foo, <is:0>
    0013 leave
    ```

    Instructions after:

    ```
    "********* Ruby *************"
    == disasm: #<ISeq:<compiled>@<compiled>:1 (1,0)-(30,11)>
    0000 putnil                                                           (  30)[Li]
    0001 defined                                class variable, :@@foo, true
    0005 branchunless                           14
    0007 getclassvariable                       :@@foo, <is:0>
    0010 dup
    0011 branchif                               20
    0013 pop
    0014 putobject                              1
    0016 dup
    0017 setclassvariable                       :@@foo, <is:0>
    0020 leave

    "********* PRISM *************"
    == disasm: #<ISeq:<compiled>@<compiled>:29 (29,0)-(29,11)>
    0000 putnil                                                           (  29)[Li]
    0001 defined                                class variable, :@@foo, true
    0005 branchunless                           14
    0007 getclassvariable                       :@@foo, <is:0>
    0010 dup
    0011 branchif                               20
    0013 pop
    0014 putobject                              1
    0016 dup
    0017 setclassvariable                       :@@foo, <is:0>
    0020 leave
    ```

    Fixes ruby/prism#2064

commit 7ac93e99a3db30ed41cbbe95df1d7be9a790b9cb
  Author:     Jemma Issroff <jemmaissroff@gmail.com>
  AuthorDate: 2023-12-14 02:17:22 +0900
  Commit:     Jemma Issroff <jemmaissroff@gmail.com>
  CommitDate: 2023-12-15 03:45:41 +0900

    [PRISM] Account for multiple anonymous locals

    This commit adjusts the local table size to be consistent regardless
    of the number of anonymous locals.

commit 01f21d57297f1e6820a6a374ccf9c432c6178038
  Author:     Ufuk Kayserilioglu <ufuk.kayserilioglu@shopify.com>
  AuthorDate: 2023-12-14 07:14:18 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2023-12-15 03:05:54 +0900

    [ruby/prism] Fix the implementation of the flag on keyword hash nodes

    The previous implementation was incorrect since it was just checking for all keys in assoc nodes to be static literals but the actual check is that all keys in assoc nodes must be symbol nodes.

    This commit fixes that implementation, and, also, aliases the flag to `PM_KEYWORD_HASH_NODE_FLAGS_SYMBOL_KEYS` so that ruby/ruby can start using the new flag name.

    I intend to later change the real flag name to `PM_KEYWORD_HASH_NODE_FLAGS_SYMBOL_KEYS` and remove the alias.

    https://github.com/ruby/prism/commit/f5099c79ce

commit c5e3d6da9cc7199128218711b89df45c8bf7c6f1
  Author:     Peter Zhu <peter@peterzhu.ca>
  AuthorDate: 2023-12-14 04:09:27 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2023-12-15 02:22:38 +0900

    Implement Write Barriers on IO::Buffer

    Benchmark:

    ```
    require "benchmark"

    puts(Benchmark.measure do
      ary = 1_000_000.times.map { IO::Buffer.for("") }

      10.times { GC.start(full_mark: false) }
    end)
    ```

    Before:

    ```
    14.330119   0.051497  14.381616 ( 14.445106)
    ```

    After:

    ```
    7.481152   0.040166   7.521318 (  7.535209)
    ```

commit 157e6c8a512968dc9f82d7f81606eeb3266cf6bb
  Author:     Jemma Issroff <jemmaissroff@gmail.com>
  AuthorDate: 2023-12-14 20:58:50 +0900
  Commit:     Jemma Issroff <jemmaissroff@gmail.com>
  CommitDate: 2023-12-15 01:46:54 +0900

    [PRISM] Check for static literal, excluding array, hash, range

commit e71f0117137c30db1dd694aa2c91c82174fa05df
  Author:     Jemma Issroff <jemmaissroff@gmail.com>
  AuthorDate: 2023-12-14 06:41:45 +0900
  Commit:     Jemma Issroff <jemmaissroff@gmail.com>
  CommitDate: 2023-12-15 01:46:54 +0900

    [PRISM] Fix bugs in compiling optional keyword parameters

    This PR fixes two bugs when compiling optional keyword parameters:
    - It moves keyword parameter compilation to STEP 5 in the parameters
    sequence, where the rest of compilation happens. This is important
    because keyword parameter compilation relies on the value of
    body->param.keyword->bits_start which gets set in an earlier step
    - It compiles array and hash values for keyword parameters, which
    it didn't previously

commit 3658798dbb60fe55beaebc157ba43c8fe617c4a0
  Author:     TSUYUSATO Kitsune <make.just.on@gmail.com>
  AuthorDate: 2023-12-15 01:30:22 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2023-12-15 01:39:05 +0900

    [ruby/prism] Make equality operators non-associative

    Fix https://github.com/ruby/prism/pull/2073

    https://github.com/ruby/prism/commit/0f747d9240

commit 8e1c148fd90b2c32044ef310a0a312bca89c6fea
  Author:     Jemma Issroff <jemmaissroff@gmail.com>
  AuthorDate: 2023-12-15 00:19:31 +0900
  Commit:     Jemma Issroff <jemmaissroff@gmail.com>
  CommitDate: 2023-12-15 01:14:45 +0900

    [PRISM] Use frozen flag on StringNode

commit a18819e65fa2dd3135909df81534937dadafb6ab
  Author:     Jeremy Evans <code@jeremyevans.net>
  AuthorDate: 2023-12-13 09:48:26 +0900
  Commit:     Jeremy Evans <code@jeremyevans.net>
  CommitDate: 2023-12-15 01:13:43 +0900

    Fix op asgn method calls passing mutable keyword splats

    When passing the keyword splat to [], it cannot be mutable, because
    mutating the keyword splat inside [] would result in changes to the
    keyword splat passed to []=.

commit 247ce712fcf93d28ceb359b66dfcf8f76e2c731d
  Author:     Burdette Lamar <BurdetteLamar@Yahoo.com>
  AuthorDate: 2023-12-15 01:09:17 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2023-12-15 01:09:17 +0900

    [DOC] RDoc for Complex (#9231)

commit a79a1d30289b326c8b6c6deb00f1431c693a4b50
  Author:     David Rodríguez <deivid.rodriguez@riseup.net>
  AuthorDate: 2023-12-14 22:16:59 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2023-12-15 00:04:22 +0900

    [rubygems/rubygems] Upgrade vendored libraries

    To match the versions that will be included in final ruby release.

    https://github.com/rubygems/rubygems/commit/84394919fb

commit 912016f626fab3e79e3ef8d9da53d1b148c8b5bf
  Author:     Peter Zhu <peter@peterzhu.ca>
  AuthorDate: 2023-12-14 04:25:19 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2023-12-14 22:52:32 +0900

    Call obj_free for T_DATA, T_FILE objects on exit

    Previously, T_DATA and T_FILE objects did not have their instance
    variables freed on exit which would be reported as a memory leak with
    RUBY_FREE_ON_EXIT. This commit changes it to use obj_free which also
    frees the generic instance variables.

    Co-authored-by: Alan Wu <XrXr@users.noreply.github.com>

commit e3631277c37861d5e99fbefd8bd3eeefc0120825
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2023-12-14 21:13:29 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2023-12-14 21:22:49 +0900

    Removed duplicated LICENSE files

commit 612616925b3d5247748b8df98a13a70f74f8b4c3
  Author:     Vít Ondruch <vondruch@redhat.com>
  AuthorDate: 2023-12-09 00:38:51 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2023-12-14 21:22:49 +0900

    [rubygems/rubygems] Allow "default_user_install" to be overridden.

    For Ruby re-distributors, automatic user-install might be the right
    default. Therefore printing warning about installing into user directory
    is not always desirable. Let the default_user_install method be
    customizable.

    https://github.com/rubygems/rubygems/commit/2320dba544

commit 45b511433d652c46d5652ab295367f41341697af
  Author:     David Rodríguez <deivid.rodriguez@riseup.net>
  AuthorDate: 2023-12-13 22:42:21 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2023-12-14 21:22:48 +0900

    [rubygems/rubygems] Improve install advice when some gems are not found

    This problem is quite specific to our dev environment, but I guess the
    fix could be handy for other situations.

    After merging a change to treat default gems as regular gems, I get this
    when trying to run `rubocop` on our repo:

    ```
    $ bin/rubocop  --only Performance/RegexpMatch
    Could not find json-2.6.3 in locally installed gems
    Run `bundle install --gemfile /Users/deivid/code/rubygems/rubygems/tool/bundler/lint_gems.rb` to install missing gems.
    ```

    However, when running the suggested command, nothing changes and I still
    get the same error:

    ```
    $ bundle install --gemfile /Users/deivid/code/rubygems/rubygems/tool/bundler/lint_gems.rb
    Using ast 2.4.2
    Using bundler 2.4.10
    Using json 2.6.3
    Using parallel 1.23.0
    Using racc 1.7.1
    Using parser 3.2.2.3
    Using rainbow 3.1.1
    Using regexp_parser 2.8.1
    Using rexml 3.2.5
    Using rubocop-ast 1.29.0
    Using ruby-progressbar 1.13.0
    Using unicode-display_width 2.4.2
    Using rubocop 1.52.1
    Using rubocop-performance 1.14.2
    Bundle complete! 2 Gemfile dependencies, 14 gems now installed.
    Use `bundle info [gemname]` to see where a bundled gem is installed.

    $ bin/rubocop  --only Performance/RegexpMatch
    Could not find json-2.6.3 in locally installed gems
    Run `bundle install --gemfile /Users/deivid/code/rubygems/rubygems/tool/bundler/lint_gems.rb` to install missing gems.
    ```

    The problem is that our `bin/rubocop` script uses the development
    version of Bundler (which has the change causing the problem), but the
    advice recommands the default version of Bundler, which does not yet
    have the change.

    This commit changes the advice to recommend to use the same version of
    Bundler that run into the problem in the first place.

    So in the above situation you now get:

    ```
    $ bin/rubocop  --only Performance/RegexpMatch
    Could not find json-2.6.3 in locally installed gems
    Run `/Users/deivid/code/rubygems/rubygems/bundler/exe/bundle install --gemfile /Users/deivid/code/rubygems/rubygems/tool/bundler/lint_gems.rb` to install missing gems.
    ```

    And running that fixes the problem:

    ```
    $ /Users/deivid//rubygems/rubygems/bundler/exe/bundle install --gemfile /Users/deivid/code/rubygems/rubygems/tool/bundler/lint_gems.rb
    Fetching gem metadata from https://rubygems.org/.........
    Fetching json 2.6.3
    Installing json 2.6.3 with native extensions
    Bundle complete! 2 Gemfile dependencies, 14 gems now installed.
    Use `bundle info [gemname]` to see where a bundled gem is installed.
    ```

    https://github.com/rubygems/rubygems/commit/10a9588c6d

commit d718654bb1b6b440b664fe6f35424360b13bab6e
  Author:     David Rodríguez <deivid.rodriguez@riseup.net>
  AuthorDate: 2023-12-13 05:32:17 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2023-12-14 21:22:48 +0900

    [rubygems/rubygems] Remove extension building sync stuff no longer present in RubyGems

    https://github.com/rubygems/rubygems/commit/59a85388b9

commit 41095f4de058c1a9d571c3c7e745c748d6c07cbc
  Author:     David Rodríguez <deivid.rodriguez@riseup.net>
  AuthorDate: 2023-12-13 05:49:12 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2023-12-14 21:22:48 +0900

    [rubygems/rubygems] RubyGems > 3.2.0.rc.1 is now always provided

    https://github.com/rubygems/rubygems/commit/929b521f3a

commit 778438d423dac10d1a63f826cfc4dc18ca4c0b66
  Author:     David Rodríguez <deivid.rodriguez@riseup.net>
  AuthorDate: 2023-12-13 05:28:57 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2023-12-14 21:22:48 +0900

    [rubygems/rubygems] Gem::Specification always has `default_stubs` now

    https://github.com/rubygems/rubygems/commit/30db1eb4a5

commit 5cf6f7f8859a0418bbbe2b608a88557d4f06e098
  Author:     David Rodríguez <deivid.rodriguez@riseup.net>
  AuthorDate: 2023-12-13 05:21:35 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2023-12-14 21:22:48 +0900

    [rubygems/rubygems] Remove more methods now defined in all RubyGems versions

    https://github.com/rubygems/rubygems/commit/e015200ffa

commit 7564038864bcf7c3cfb2f602e318e9beae17b2f7
  Author:     David Rodríguez <deivid.rodriguez@riseup.net>
  AuthorDate: 2023-12-13 05:17:28 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2023-12-14 21:22:48 +0900

    [rubygems/rubygems] Remove check only necessary for ancient RubyGems

    https://github.com/rubygems/rubygems/commit/ffa2f03489

commit 04dd2a8aae84f58009d230304029cf4af9a6d296
  Author:     David Rodríguez <deivid.rodriguez@riseup.net>
  AuthorDate: 2023-12-13 05:15:38 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2023-12-14 21:22:48 +0900

    [rubygems/rubygems] This patch should be no longer needed

    https://github.com/rubygems/rubygems/commit/1139e90931

commit b45c1523a89133daa31c483e97f7d28593bb7b01
  Author:     David Rodríguez <deivid.rodriguez@riseup.net>
  AuthorDate: 2023-12-13 05:06:20 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2023-12-14 21:22:48 +0900

    [rubygems/rubygems] Gem::Specification.find_all_by_name is always defined now

    https://github.com/rubygems/rubygems/commit/1d61c7686b

commit b300f5a0e1b75dfd27d58890521a1085d44284b3
  Author:     David Rodríguez <deivid.rodriguez@riseup.net>
  AuthorDate: 2023-12-14 05:23:07 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2023-12-14 21:22:48 +0900

    [rubygems/rubygems] Revert "Improve default gem handling"

    This reverts commit https://github.com/rubygems/rubygems/commit/091b4fcf2b99.

    https://github.com/rubygems/rubygems/commit/dcade3235f

commit a10c11a66bae7ec4bfb56d0ccfe74a0c6681fc77
  Author:     Matt Valentine-House <matt@eightbitraptor.com>
  AuthorDate: 2023-12-13 23:40:34 +0900
  Commit:     Jemma Issroff <jemmaissroff@gmail.com>
  CommitDate: 2023-12-14 21:01:19 +0900

    [PRISM] Add anon KW args to the block local table

commit e51f9e9f75cc1dde9234836fa92077d71b3c5141
  Author:     Satoshi Tagomori <tagomoris@gmail.com>
  AuthorDate: 2023-12-08 15:06:12 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2023-12-14 17:39:42 +0900

    rb_ext_resolve_symbol: C API to resolve and return externed symbols [Feature #20005]

    This is a C API for extensions to resolve and get function symbols of other extensions.
    Extensions can check the expected symbol is correctly loaded and accessible, and
    use it if it is available.
    Otherwise, extensions can raise their own error to guide users to setup their
    environments correctly and what's missing.

commit 8a37df8c8bc0311c4822ee989087d212af2bf73f
  Author:     Satoshi Tagomori <tagomoris@gmail.com>
  AuthorDate: 2023-12-07 20:38:53 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2023-12-14 17:39:42 +0900

    dln_symbol: make dln_sym accessible Ruby internally

    The symbol resolved by dln_symbol will eventually be passed to
    extensions. The error handling of dln_sym is also separated into
    dln_sym_func because the new call resolving symbols will not raise
    LoadError.

commit 35a6b69f6c3cda7afd84c686978cf7ac79f68e04
  Author:     git <svn-admin@ruby-lang.org>
  AuthorDate: 2023-12-14 16:39:19 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2023-12-14 16:39:19 +0900

    Update bundled gems list at 1b1d5e757e81ec243062a8919ddc76 [ci skip]

commit 1b1d5e757e81ec243062a8919ddc76d017c34a54
  Author:     Shugo Maeda <shugo@ruby-lang.org>
  AuthorDate: 2023-12-14 16:38:39 +0900
  Commit:     Shugo Maeda <shugo@ruby-lang.org>
  CommitDate: 2023-12-14 16:38:39 +0900

    Bump up bundled net-ftp gem version to 0.3.2

commit 2c5e2ce2cce851eef7f6bacf1b2cd0fb3e0ae405
  Author:     git <svn-admin@ruby-lang.org>
  AuthorDate: 2023-12-14 15:51:54 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2023-12-14 15:51:54 +0900

    Update bundled gems list at 26145a27f6b960bd607cdd2f9680eb [ci skip]

commit 26145a27f6b960bd607cdd2f9680eba14f84ac1a
  Author:     Shugo Maeda <shugo@ruby-lang.org>
  AuthorDate: 2023-12-14 15:51:12 +0900
  Commit:     Shugo Maeda <shugo@ruby-lang.org>
  CommitDate: 2023-12-14 15:51:12 +0900

    Bump up bundled net-ftp gem version to 0.3.1

commit b7e89d4b175a88be333134066b595d1e34c33fd3
  Author:     Kevin Newton <kddnewton@gmail.com>
  AuthorDate: 2023-12-14 11:35:42 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2023-12-14 11:43:32 +0900

    [ruby/prism] Fix hash pattern rest

    https://github.com/ruby/prism/commit/43c4232cfc

commit 74b6e70ef4cf1e625ff968ebf3e62dc9a0760ac1
  Author:     Kazuhiro NISHIYAMA <zn@mbf.nifty.com>
  AuthorDate: 2023-12-14 09:54:23 +0900
  Commit:     Kazuhiro NISHIYAMA <zn@mbf.nifty.com>
  CommitDate: 2023-12-14 09:54:23 +0900

    Fold a long line [ci skip]

commit beefce1444adafac484bb69b625de2b30e7e80d2
  Author:     Drew Stevenson <drew@soona.co>
  AuthorDate: 2023-12-01 13:35:33 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2023-12-14 09:06:05 +0900

    [rubygems/rubygems] Warn for duplicate meta data links

    Match order of METADATA_LINK_KEYS to order used by rubygems.org in Links model.
    Add missing download_uri key.

    https://github.com/rubygems/rubygems/commit/d2922cd6e9

commit d7dad644658697a05949b66e736a34fb772771de
  Author:     John Hawthorn <john@hawthorn.email>
  AuthorDate: 2023-12-13 13:57:02 +0900
  Commit:     John Hawthorn <john@hawthorn.email>
  CommitDate: 2023-12-14 08:26:52 +0900

    Unlock freelist before assigning

    Co-authored-by: Matthew Draper <matthew@trebex.net>

commit c1f4bfd41fa7e1fa23ef6803349ac009debdf61f
  Author:     Martin Emde <martin.emde@gmail.com>
  AuthorDate: 2023-12-14 06:46:04 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2023-12-14 07:50:45 +0900

    [rubygems/rubygems] Revert "Merge pull request #7167 from nevinera/add-json-output-option-to-bundle-outdated"

    This reverts commit https://github.com/rubygems/rubygems/commit/a4ac5116b8ea, reversing
    changes made to https://github.com/rubygems/rubygems/commit/8a6b180d0ae5.

    https://github.com/rubygems/rubygems/commit/a1efe4015d

commit 5a0cbc934428b3babdce6f5d014c30afcb84e567
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2023-12-13 16:38:15 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2023-12-14 07:48:08 +0900

    Detect bootsnap from all frames

commit 8b0c62696203daba815fa4e6d1c08dc143b3cc04
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2023-12-12 16:04:49 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2023-12-14 07:48:08 +0900

    Skip warning feature with Bootsnap

      Bootsnap modified full feature path to require. We can't handle it for
      warning correctly.

commit 75c40802cb06d83fc2c3d0eca6d904fa41307230
  Author:     Akira Matsuda <ronnie@dio.jp>
  AuthorDate: 2023-12-14 02:30:04 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2023-12-14 07:47:56 +0900

    [Bug #20060] Properly return matched gem name in case of EXACT

    this follows up 4e6861d3376eb7857d2b0a947c97b6fec8e5bf37

commit baf2ec2ca8127cd610a3681a1e84ebcb404fe8f2
  Author:     Samuel Giddins <segiddins@segiddins.me>
  AuthorDate: 2023-12-13 20:46:10 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2023-12-14 07:00:26 +0900

    [rubygems/rubygems] Use match? when regexp match data is unused

    Improved performance / reduced allocations

    https://github.com/rubygems/rubygems/commit/b04726c9a7

commit b266890dab38d12ad52288d5edf60f885ae5b8ce
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2023-12-14 06:29:37 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2023-12-14 06:29:37 +0900

    YJIT: Add --yjit-disable to help and reorder it (#9230)

commit 7f4b271a61a11b0254304b78db72fd2c954a4370
  Author:     Martin Emde <martin.emde@gmail.com>
  AuthorDate: 2023-12-14 04:15:51 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2023-12-14 05:28:37 +0900

    [rubygems/rubygems] Store Checksum::Store indexed by spec.lock_name

    https://github.com/rubygems/rubygems/commit/34d6c6c72f

commit 14c7895c21bee44934336a9a9ea94aefc5cc7879
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2023-12-14 04:50:35 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2023-12-14 04:50:35 +0900

    Fix a typo in yjit.md

commit 31c0ea20e5492925ac971991937e30524da5043d
  Author:     Ufuk Kayserilioglu <ufuk.kayserilioglu@shopify.com>
  AuthorDate: 2023-12-13 08:47:07 +0900
  Commit:     Jemma Issroff <jemmaissroff@gmail.com>
  CommitDate: 2023-12-14 04:15:09 +0900

    [PRISM] Add a test with a non-static-literal hash key

commit 6aa26af683616cf908f0251dbb8ffde380e0c314
  Author:     Samuel Giddins <segiddins@segiddins.me>
  AuthorDate: 2023-12-13 22:01:24 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2023-12-14 04:02:24 +0900

    [rubygems/rubygems] Add 3.4 as a supported ruby version

    Since ruby trunk will be 3.4 very soon

    https://github.com/rubygems/rubygems/commit/36dd9a35dc

commit 110dbf62acc307ea2e3ce57ddaa89fc734a715c5
  Author:     eileencodes <eileencodes@gmail.com>
  AuthorDate: 2023-12-13 05:52:53 +0900
  Commit:     Jemma Issroff <jemmaissroff@gmail.com>
  CommitDate: 2023-12-14 03:42:17 +0900

    [Prism] Fix InterpolatedMatchLastLine Instructions

    I looked at this at RubyConf with Kevin, and we noticed that there was a
    `putobject` empty string missing from the instructions. I just got back
    around to implementing this and pushing a PR and while doing that
    noticed that we also have a `getspecial` when we want a `getglobal`.

    This change adds the `putobject` instruction and replaces the
    `getspecial` with a `getglobal`. If we look at the parsetree for the
    following code:

    ```ruby
    $pit = '.oo'; if /"#{$pit}"/mix; end
    ```

    We can see it has a `NODE_GVAR` and the [Ruby
    compiler](https://github.com/ruby/ruby/blob/a4b43e92645e46ee5a8c9af42d3de57cd052e87c/compile.c#L10024-L10030) shows that should
    use `getglobal.

    ```
     @ NODE_SCOPE (id: 14, line: 1, location: (1,0)-(22,36))
     +- nd_tbl: (empty)
     +- nd_args:
     |   (null node)
     +- nd_body:
         @ NODE_BLOCK (id: 12, line: 22, location: (22,0)-(22,36))
         +- nd_head (1):
         |   @ NODE_GASGN (id: 0, line: 22, location: (22,0)-(22,12))*
         |   +- nd_vid: :$pit
         |   +- nd_value:
         |       @ NODE_STR (id: 1, line: 22, location: (22,7)-(22,12))
         |       +- nd_lit: ".oo"
         +- nd_head (2):
             @ NODE_IF (id: 11, line: 22, location: (22,14)-(22,36))*
             +- nd_cond:
             |   @ NODE_MATCH2 (id: 10, line: 22, location: (22,14)-(22,36))
             |   +- nd_recv:
             |   |   @ NODE_DREGX (id: 2, line: 22, location: (22,17)-(22,31))
             |   |   +- nd_lit: "\""
             |   |   +- nd_next->nd_head:
             |   |   |   @ NODE_EVSTR (id: 4, line: 22, location: (22,19)-(22,26))
             |   |   |   +- nd_body:
             |   |   |       @ NODE_GVAR (id: 3, line: 22, location: (22,21)-(22,25))
             |   |   |       +- nd_vid: :$pit
             |   |   +- nd_next->nd_next:
             |   |       @ NODE_LIST (id: 7, line: 22, location: (22,26)-(22,27))
             |   |       +- as.nd_alen: 1
             |   |       +- nd_head:
             |   |       |   @ NODE_STR (id: 6, line: 22, location: (22,26)-(22,27))
             |   |       |   +- nd_lit: "\""
             |   |       +- nd_next:
             |   |           (null node)
             |   +- nd_value:
             |       @ NODE_GVAR (id: 9, line: 22, location: (22,14)-(22,36))
             |       +- nd_vid: :$_
             +- nd_body:
             |   @ NODE_BEGIN (id: 8, line: 22, location: (22,32)-(22,32))
             |   +- nd_body:
             |       (null node)
             +- nd_else:
                 (null node)
    ```

    I'm struggling with writing a failing test, but the before/after
    instructions show that `getglobal` is correct here. I compared the
    instructions for the  other `InterpolatedMatchLastLine` node tests
    and they also used `getglobal`. I've edited the existing
    `InterpolatedLastMatchLineNode` test so that it will use that instruction when
    copied out of the test. Without the quotes it thinks it's just a
    `MatchLastLineNode`.

    Incorrect instructions:

    ```
    "********* Ruby *************"
    == disasm: #<ISeq:<compiled>@<compiled>:1 (1,0)-(22,36)>
    0000 putstring                              ".oo"                     (  22)[Li]
    0002 setglobal                              :$pit
    0004 putobject                              "\""
    0006 getglobal                              :$pit
    0008 dup
    0009 objtostring                            <calldata!mid:to_s, argc:0, FCALL|ARGS_SIMPLE>
    0011 anytostring
    0012 putobject                              "\""
    0014 toregexp                               7, 3
    0017 getglobal                              :$_
    0019 send                                   <calldata!mid:=~, argc:1, ARGS_SIMPLE>, nil
    0022 branchunless                           30
    0024 jump                                   26
    0026 putnil
    0027 jump                                   31
    0029 pop
    0030 putnil
    0031 leave

    "********* PRISM *************"
    == disasm: #<ISeq:<compiled>@<compiled>:21 (21,0)-(21,36)>
    0000 putstring                              ".oo"                     (  21)[Li]
    0002 setglobal                              :$pit
    0004 putobject                              "\""
    0006 getglobal                              :$pit
    0008 dup
    0009 objtostring                            <calldata!mid:to_s, argc:0, FCALL|ARGS_SIMPLE>
    0011 anytostring
    0012 putobject                              "\""
    0014 toregexp                               7, 3
    0017 getspecial                             0, 0
    0020 send                                   <calldata!mid:=~, argc:1, ARGS_SIMPLE>, nil
    0023 branchunless                           31
    0025 jump                                   27
    0027 putnil
    0028 jump                                   32
    0030 pop
    0031 putnil
    0032 leave
    ```

    Fixed instructions:

    ```
    == disasm: #<ISeq:<compiled>@<compiled>:1 (1,0)-(22,36)>
    0000 putstring                              ".oo"                     (  22)[Li]
    0002 setglobal                              :$pit
    0004 putobject                              "\""
    0006 getglobal                              :$pit
    0008 dup
    0009 objtostring                            <calldata!mid:to_s, argc:0, FCALL|ARGS_SIMPLE>
    0011 anytostring
    0012 putobject                              "\""
    0014 toregexp                               7, 3
    0017 getglobal                              :$_
    0019 send                                   <calldata!mid:=~, argc:1, ARGS_SIMPLE>, nil
    0022 branchunless                           30
    0024 jump                                   26
    0026 putnil
    0027 jump                                   31
    0029 pop
    0030 putnil
    0031 leave

    "********* PRISM *************"
    == disasm: #<ISeq:<compiled>@<compiled>:21 (21,0)-(21,36)>
    0000 putstring                              ".oo"                     (  21)[Li]
    0002 setglobal                              :$pit
    0004 putobject                              "\""
    0006 getglobal                              :$pit
    0008 dup
    0009 objtostring                            <calldata!mid:to_s, argc:0, FCALL|ARGS_SIMPLE>
    0011 anytostring
    0012 putobject                              "\""
    0014 toregexp                               7, 3
    0017 getglobal                              :$_
    0019 send                                   <calldata!mid:=~, argc:1, ARGS_SIMPLE>, nil
    0022 branchunless                           30
    0024 jump                                   26
    0026 putnil
    0027 jump                                   31
    0029 pop
    0030 putnil
    0031 leave
    ```

commit ea4a4c302cf1733ce6c84ffb641ab2c43846f7de
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2023-12-14 03:28:19 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2023-12-14 03:28:20 +0900

    [PRISM] Fix a -Wformat-zero-length warning

    ../prism_compile.c: In function ‘pm_compile_node’:
    ../prism_compile.c:2330:20: warning: zero-length gnu_printf format string [-Wformat-zero-length]
     2330 |             rb_bug("");
          |                    ^~

commit 02528f647d4d217a574eb2518dbb925c937dded6
  Author:     John Hawthorn <john@hawthorn.email>
  AuthorDate: 2023-12-13 11:34:14 +0900
  Commit:     John Hawthorn <john@hawthorn.email>
  CommitDate: 2023-12-14 03:20:11 +0900

    [PRISM] Use xcalloc for iseq id table

    We use xfree on the other end, so we need to use a form of xmalloc here.

    Co-authored-by: Matthew Draper <matthew@trebex.net>

commit b55de590f3344dcedaafba8bcf2a249c9f0c4fc5
  Author:     John Hawthorn <john@hawthorn.email>
  AuthorDate: 2023-12-13 11:32:18 +0900
  Commit:     John Hawthorn <john@hawthorn.email>
  CommitDate: 2023-12-14 03:20:11 +0900

    [PRISM] Fix st_table memory leak

    Co-authored-by: Matthew Draper <matthew@trebex.net>

commit a3b48ac9ad8a5d4eb7ae6c3d4fe9d040361daa7a
  Author:     Alan Wu <XrXr@users.noreply.github.com>
  AuthorDate: 2023-12-14 02:11:49 +0900
  Commit:     Aaron Patterson <aaron.patterson@gmail.com>
  CommitDate: 2023-12-14 02:43:09 +0900

    Fix memory leak in Hash#compare_by_identity

    We didn't free the old ST before overwriting it which caused a leak.
    Found with RUBY_FREE_ON_EXIT.

    Co-authored-by: Peter Zhu <peter@peterzhu.ca>

commit cc86fa8416b571e2d833157b852dee31a0d2f731
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2023-12-14 02:38:18 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2023-12-14 02:40:54 +0900

    Skip an unstable test on MinGW

    This test fails fairly frequently on MinGW:
    https://github.com/ruby/ruby/actions/runs/7195712496/job/19598924253#step:11:168
    https://github.com/ruby/ruby/actions/runs/7191246799/job/19585627182#step:11:168

    and we aren't actively working on stabilizing tests for MinGW.

commit 0f1c7e3bcb2ee0cb38d228ba0d23f52ceef5623c
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2023-12-14 02:36:06 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2023-12-14 02:36:06 +0900

    RJIT: Just skip generating code for aarch64/arm64 (#9221)

commit c83a648fc827ac1430bd1f08f5af19f7174e02aa
  Author:     tomoya ishida <tomoyapenguin@gmail.com>
  AuthorDate: 2023-12-14 02:05:30 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2023-12-14 02:05:35 +0900

    [ruby/irb] Remove unused lvar in mesure command test
    (https://github.com/ruby/irb/pull/814)

    https://github.com/ruby/irb/commit/320178b120

commit a4b43e92645e46ee5a8c9af42d3de57cd052e87c
  Author:     David Rodríguez <deivid.rodriguez@riseup.net>
  AuthorDate: 2023-12-13 21:03:00 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2023-12-14 00:47:43 +0900

    [rubygems/rubygems] Add missing resolv, timeout, and net-protocol licenses

    https://github.com/rubygems/rubygems/commit/00694651a3

commit f8ddcecbdf34b8d33ed4311b34d498d4ff380a3e
  Author:     Peter Zhu <peter@peterzhu.ca>
  AuthorDate: 2023-12-13 00:45:59 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2023-12-14 00:39:06 +0900

    [Bug #20061] Clear mark bits when rb_free_on_exit

    When compiling with cppflags=-DRGENGC_CHECK_MODE, the following crashes:

    ```
    $ RUBY_FREE_ON_EXIT=1 ./miniruby -e 0
    -e: [BUG] obj_free: RVALUE_MARKED(0x0000000103570020 [3LM    ] T_CLASS (anon)) != FALSE
    ```

    This commit clears the mark bits when rb_free_on_exit is enabled.

commit 0d53dba7ce900387397610c060cfa24758fc806a
  Author:     Jeremy Evans <code@jeremyevans.net>
  AuthorDate: 2023-12-13 09:58:20 +0900
  Commit:     Jeremy Evans <code@jeremyevans.net>
  CommitDate: 2023-12-14 00:05:21 +0900

    Make String#chomp! raise ArgumentError for 2+ arguments if string is empty

    String#chomp! returned nil without checking the number of passed
    arguments in this case.

commit c42e4a38e9839fe3380566727304f3fd75a6506a
  Author:     Jeremy Evans <code@jeremyevans.net>
  AuthorDate: 2023-12-09 09:39:41 +0900
  Commit:     Jeremy Evans <code@jeremyevans.net>
  CommitDate: 2023-12-14 00:05:21 +0900

    Fix tool/ln_sr.rb passing 2 arguments to String#chomp!

    I'm guessing String#sub! was desired here.

commit 9eba7a08920102747eb9dceeedd8d7c080515aac
  Author:     Matt Valentine-House <matt@eightbitraptor.com>
  AuthorDate: 2023-12-12 07:35:13 +0900
  Commit:     Jemma Issroff <jemmaissroff@gmail.com>
  CommitDate: 2023-12-13 23:33:07 +0900

    [PRISM] Break nodes should add an entry to the parent catch table

commit cb8a9851ca4e78795900cde2fb1147ec3a1192d7
  Author:     Matt Valentine-House <matt@eightbitraptor.com>
  AuthorDate: 2023-12-12 00:33:52 +0900
  Commit:     Jemma Issroff <jemmaissroff@gmail.com>
  CommitDate: 2023-12-13 23:33:07 +0900

    [PRISM] Remove errant NOP when redo_label is set

commit 9267dbdd7ad1f41116a89c2ce044b776274afc44
  Author:     Matt Valentine-House <matt@eightbitraptor.com>
  AuthorDate: 2023-12-12 00:27:46 +0900
  Commit:     Jemma Issroff <jemmaissroff@gmail.com>
  CommitDate: 2023-12-13 23:33:07 +0900

    [PRISM] Generate instruction for when redo_label is set

commit f390c51b15c470590a416d0def51ea1cca1bd74b
  Author:     Ufuk Kayserilioglu <ufuk.kayserilioglu@shopify.com>
  AuthorDate: 2023-12-13 08:37:50 +0900
  Commit:     Jemma Issroff <jemmaissroff@gmail.com>
  CommitDate: 2023-12-13 22:16:11 +0900

    [PRISM] Use `PM_KEYWORD_HASH_NODE_FLAGS_STATIC_KEYS` flag in compiler

commit 798a89fae1d7da1c0dd4282e9e16ab8bbf993b55
  Author:     Jemma Issroff <jemmaissroff@gmail.com>
  AuthorDate: 2023-12-13 05:56:03 +0900
  Commit:     Jemma Issroff <jemmaissroff@gmail.com>
  CommitDate: 2023-12-13 22:11:45 +0900

    [PRISM] If receiver on CallNode is SelfNode, use FCALL flags

commit 1ad991c54d7d890527050a54899265da21a677c2
  Author:     eileencodes <eileencodes@gmail.com>
  AuthorDate: 2023-12-13 04:24:00 +0900
  Commit:     Jemma Issroff <jemmaissroff@gmail.com>
  CommitDate: 2023-12-13 22:11:21 +0900

    [PRISM] Fix attrset edge cases

    In some cases code may look like an attrset ID but should actually
    return the value of the method, not the passed values.

    In ruby/prism#2051 a flag was added when we have a attribute write call.
    I used this flag to add the proper instructions when we have a real
    attrset instead of using `rb_is_attrset_id` which was kind of hacky
    anyway.

    The value that should be returned in the newly added test is 42, not 2.
    Previously the changes we had made returned 2.

    Related to ruby/prism#1715

commit 36ca99b343ee8847beb4b7e0be112f75af64109f
  Author:     Alex Koval <al3xander.koval@gmail.com>
  AuthorDate: 2023-12-13 19:39:48 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2023-12-13 21:17:57 +0900

    [ruby/prism] fix typo in docs

    https://github.com/ruby/prism/commit/d7fbc09345

commit 745ab3e4c748ebf3b22278d7ad33c7abcf1f6016
  Author:     tomoya ishida <tomoyapenguin@gmail.com>
  AuthorDate: 2023-12-13 20:06:21 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2023-12-13 20:06:26 +0900

    [ruby/irb] Warn and do nothing if block is passed to measure command
    (https://github.com/ruby/irb/pull/813)

    https://github.com/ruby/irb/commit/e79a90a1e6

commit a7ad9f38367b729d49db78e7cbe13922d3ff70ee
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2023-12-13 16:18:35 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2023-12-13 17:30:48 +0900

    We need only one line for detecting caller gem name

commit e282d7b880c3ac394ad8d41bde858c4534fb3188
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2023-12-13 17:05:11 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2023-12-13 17:05:12 +0900

    Avoid warning --jit when only YJIT is enabled

commit 75f4a687ed54e3b1863ba1767c666a0bea809c8a
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2023-12-13 16:28:22 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2023-12-13 16:28:22 +0900

    Fix a typo for `RJIT_TARGET_OK` (#8222)

commit 20a09387d163b6d4ec77d1859f1cac480991ce9e
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2023-12-13 16:24:07 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2023-12-13 16:24:19 +0900

    Skip a GC test for RJIT

    It randomly fails like this:
    https://github.com/ruby/ruby/actions/runs/7191443542/job/19586164973

commit f49097c84281b41aa581d9f89fec48dd77877c00
  Author:     git <svn-admin@ruby-lang.org>
  AuthorDate: 2023-12-13 15:12:18 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2023-12-13 15:12:18 +0900

    Update default gems list at 5f5f8dbbb6a7861e9c591ad0914994 [ci skip]

commit 5f5f8dbbb6a7861e9c591ad09149944a5adf5a71
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2023-12-13 15:04:13 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2023-12-13 15:11:21 +0900

    [ruby/resolv] Bump up 0.3.0

    https://github.com/ruby/resolv/commit/22153c2a45

commit a66d083bbfa251fa49ebf08830257bab8954ec5c
  Author:     git <svn-admin@ruby-lang.org>
  AuthorDate: 2023-12-13 14:59:13 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2023-12-13 14:59:13 +0900

    Update default gems list at 39023792dbded9250040224accda18 [ci skip]

commit 39023792dbded9250040224accda18c0db14c5bc
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2023-12-13 14:55:10 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2023-12-13 14:58:25 +0900

    [ruby/io-console] Bump up 0.7.0

    https://github.com/ruby/io-console/commit/3e5586e632

commit caef4e98cb6161d22934f6a9069d394e938e9e01
  Author:     git <svn-admin@ruby-lang.org>
  AuthorDate: 2023-12-13 14:43:52 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2023-12-13 14:43:52 +0900

    Update default gems list at 06edde22f462f736c16ae9038b015f [ci skip]

commit 06edde22f462f736c16ae9038b015fcdbd100716
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2023-12-13 14:42:37 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2023-12-13 14:42:58 +0900

    [ruby/io-nonblock] Bump up 0.3.0

    https://github.com/ruby/io-nonblock/commit/501e2ffea3

commit 02f0aa6137eeca3fffc06d108def03efde94f001
  Author:     git <svn-admin@ruby-lang.org>
  AuthorDate: 2023-12-13 14:11:39 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2023-12-13 14:11:39 +0900

    Update default gems list at 5cabe1e9cc6829d1918c65bf29c4ba [ci skip]

commit 5cabe1e9cc6829d1918c65bf29c4ba8217cc466d
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2023-12-13 14:05:21 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2023-12-13 14:10:54 +0900

    [ruby/io-wait] Bump up 0.3.1

    https://github.com/ruby/io-wait/commit/5ec3db36c8

commit 8a8fd32e13749d2b158dc9bf76d38f039f677f55
  Author:     git <svn-admin@ruby-lang.org>
  AuthorDate: 2023-12-13 14:02:01 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2023-12-13 14:02:01 +0900

    Update default gems list at 12c775c94249b57dadfda0c2de9568 [ci skip]

commit 12c775c94249b57dadfda0c2de9568398ae6cfd6
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2023-12-13 13:58:24 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2023-12-13 14:01:16 +0900

    [ruby/etc] Bump up 1.4.3

    https://github.com/ruby/etc/commit/743c26086d

commit ac939d9ca3164a748c656ea7f33c356d7b91b0f9
  Author:     David Rodríguez <deivid.rodriguez@riseup.net>
  AuthorDate: 2023-12-11 21:19:45 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2023-12-13 13:02:22 +0900

    [rubygems/rubygems] Improve default gem handling

    If a gem is specified in the Gemfile (or resolved as a transitive
    dependency), it's always resolved from remote/installed sources. Default
    gems are only used as a fallback for gems not included in the bundle.

    I believe this leads to more consistent behavior and more portable apps,
    since all gems will be installed to the configured bundle path,
    regardless of whether they are default gems or not.

    https://github.com/rubygems/rubygems/commit/091b4fcf2b

commit 1a7aa5560f1a9967e320f71b7e8e8ee748151168
  Author:     David Rodríguez <deivid.rodriguez@riseup.net>
  AuthorDate: 2023-12-11 21:05:42 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2023-12-13 13:02:22 +0900

    [rubygems/rubygems] Refactor `bundle info`

    https://github.com/rubygems/rubygems/commit/0e919eaa87

commit 70428247c673987c6613396f55a8ab5651d27fe4
  Author:     David Rodríguez <deivid.rodriguez@riseup.net>
  AuthorDate: 2023-12-11 20:41:58 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2023-12-13 13:02:21 +0900

    [rubygems/rubygems] Remove dead code

    https://github.com/rubygems/rubygems/commit/fad186df39

commit 6b3c9cebe94cdd0d5f97877642689baed8a35327
  Author:     David Rodríguez <deivid.rodriguez@riseup.net>
  AuthorDate: 2023-12-08 07:59:36 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2023-12-13 12:59:23 +0900

    Normalize bundler bindir

    This makes bundler consistent with all other gems, and makes the default
    installation of Bundler in the release package look like any other
    bundler installation.

    Before (on preview3, for example), Bundler executable is installed at:

    lib/ruby/gems/3.3.0+0/gems/bundler-2.5.0.dev/libexec/bundle

    Now it's installed in the standard location:

    lib/ruby/gems/3.3.0+0/gems/bundler-2.5.0.dev/exe/bundle

commit 866b6fcd69c85cd00118324942886d92a3bb2a0f
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2023-12-13 11:51:59 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2023-12-13 12:16:55 +0900

    RubyGems 3.5+ will use vendored net-http

commit 5015481e537ab3dd34c184ed4ef20521c5b4f43d
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2023-12-13 11:28:02 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2023-12-13 12:16:55 +0900

    Removed duplicated LICENSE file

commit befbcfd90c4fbbdc3cc3fa3a083ff6868a2bfb02
  Author:     Vít Ondruch <vondruch@redhat.com>
  AuthorDate: 2023-12-12 22:47:15 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2023-12-13 12:16:55 +0900

    [rubygems/rubygems] Explain the 3 states `options[:user_install]` can have.

    This was issue previously, so hopefully this comment tries to state this
    explicitly for future readers.

    https://github.com/rubygems/rubygems/commit/8ccd830f85

commit 1fa5dd883e286a768a9dfa82ef3de562fcdabd01
  Author:     Vít Ondruch <vondruch@redhat.com>
  AuthorDate: 2023-12-12 22:37:30 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2023-12-13 12:16:55 +0900

    [rubygems/rubygems] Test if the user dir is used for auto user installation

    This is mainly to align this test case with the
    `test_process_options_does_not_fallback_to_user_install_when_gem_home_
    not_writable_and_no_user_install`, where the `install_dir` is checked
    already.

    https://github.com/rubygems/rubygems/commit/02b1884b61

commit 402fd96ddc401cf35bced8d394c44df98d6fc466
  Author:     Vít Ondruch <vondruch@redhat.com>
  AuthorDate: 2023-12-12 22:38:45 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2023-12-13 12:16:55 +0900

    [rubygems/rubygems] Make sure `--no-user-install` is respected for auto user installation

    The `options[:user_install]` might have three states:
    * `true`: `--user-install`
    * `false`: `--no-user-install` and
    * `nil`: option was not specified

    However, this had not been respected previously and the `false` and `nil`
    were treated the same. This could lead to auto user installation despite
    `--no-user-install` being specified on the command line.

    Fixes https://github.com/rubygems/rubygems/pull/7237

    https://github.com/rubygems/rubygems/commit/9281545474

commit 844759ccdbf9400796259888d613597585ad697a
  Author:     David Rodríguez <deivid.rodriguez@riseup.net>
  AuthorDate: 2023-12-13 01:13:47 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2023-12-13 12:16:55 +0900

    [rubygems/rubygems] Add a spec to cover what vendoring timeout fixes

    https://github.com/rubygems/rubygems/commit/2662e45d75

commit 5323935f5799772cf5d18e4e5a2dcce914b4c6bd
  Author:     David Rodríguez <deivid.rodriguez@riseup.net>
  AuthorDate: 2023-12-13 01:13:30 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2023-12-13 12:16:55 +0900

    [rubygems/rubygems] Remove no longer needed gem install during test

    https://github.com/rubygems/rubygems/commit/bdb78d8289

commit 20d99a2f5fde15a21f1232078389ea83cb71cb33
  Author:     David Rodríguez <deivid.rodriguez@riseup.net>
  AuthorDate: 2023-07-05 01:49:04 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2023-12-13 12:16:55 +0900

    [rubygems/rubygems] Resolv needs vendoring too

    https://github.com/rubygems/rubygems/commit/cdfc6923e4

commit f188a41afee554e46ea2125f22e7d989afc52be0
  Author:     David Rodríguez <deivid.rodriguez@riseup.net>
  AuthorDate: 2023-07-05 01:34:01 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2023-12-13 12:16:55 +0900

    [rubygems/rubygems] Use vendored timeout from RubyGems

    https://github.com/rubygems/rubygems/commit/cfc5018c54

commit a7c9163b5d87c0420e54cd75668bceb8f39a578a
  Author:     David Rodríguez <deivid.rodriguez@riseup.net>
  AuthorDate: 2023-07-01 04:22:32 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2023-12-13 12:16:55 +0900

    [rubygems/rubygems] Vendor timeout in RubyGems too

    https://github.com/rubygems/rubygems/commit/e2e7440ede

commit 90317472e87692fff1c864d129d60130dc3bab2c
  Author:     David Rodríguez <deivid.rodriguez@riseup.net>
  AuthorDate: 2023-01-30 05:28:29 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2023-12-13 12:16:55 +0900

    [rubygems/rubygems] Use vendored net-http in Bundler

    https://github.com/rubygems/rubygems/commit/0d758e8926

commit ce924ce1fb029f19fd34a43f2012a485f4f62b53
  Author:     David Rodríguez <deivid.rodriguez@riseup.net>
  AuthorDate: 2023-01-30 05:24:11 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2023-12-13 12:16:55 +0900

    [rubygems/rubygems] Vendor net-http and net-protocol in RubyGems

    https://github.com/rubygems/rubygems/commit/99d91c9ed2

commit 6cefad77042ee3277488f56e8046c53f5313a82f
  Author:     David Rodríguez <deivid.rodriguez@riseup.net>
  AuthorDate: 2023-11-11 05:48:25 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2023-12-13 12:16:55 +0900

    [rubygems/rubygems] Avoid loading artifice when not necessary

    https://github.com/rubygems/rubygems/commit/ef97ad37bd

commit 7d5d2eef78d57bfac75b68c08e4bf5ce3d633a01
  Author:     David Rodríguez <deivid.rodriguez@riseup.net>
  AuthorDate: 2023-11-11 03:39:48 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2023-12-13 12:16:55 +0900

    [rubygems/rubygems] Load hax.rb before anything when `BUNDLER_IGNORE_DEFAULT_GEM` set

    https://github.com/rubygems/rubygems/commit/111bd11c36

commit 8d1a2036643faecf55b9c09d6b788d1cd3b1f064
  Author:     David Rodríguez <deivid.rodriguez@riseup.net>
  AuthorDate: 2023-01-30 05:28:11 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2023-12-13 12:16:55 +0900

    [rubygems/rubygems] Require `rubygems/request` where it's used

    https://github.com/rubygems/rubygems/commit/73b9498658

commit 196c24620e95e1c0412732cf14f1ccb441cf224f
  Author:     Jemma Issroff <jemmaissroff@gmail.com>
  AuthorDate: 2023-12-13 03:40:05 +0900
  Commit:     Jemma Issroff <jemmaissroff@gmail.com>
  CommitDate: 2023-12-13 12:00:50 +0900

    [PRISM] Correctly parse non-base 10 integers in Prism

    This commit passes an `end` to rb_int_parse_cstr which allows us
    to correctly parse non-base 10 integers which are enclosed in
    parenthesis. Prior to this commit, we were getting a putobject nil
    when compiling `(0o0)` for example.

commit a2994c300b9620b0b226c8373f15627eead65d43
  Author:     KJ Tsanaktsidis <ktsanaktsidis@zendesk.com>
  AuthorDate: 2023-12-12 08:57:26 +0900
  Commit:     KJ Tsanaktsidis <kj@kjtsanaktsidis.id.au>
  CommitDate: 2023-12-13 11:35:05 +0900

    Add changelog entry for [Feature #20057]

commit a8d2d93aff8d50adc914dfc24c09cfe28643501b
  Author:     KJ Tsanaktsidis <ktsanaktsidis@zendesk.com>
  AuthorDate: 2023-12-11 13:22:42 +0900
  Commit:     KJ Tsanaktsidis <kj@kjtsanaktsidis.id.au>
  CommitDate: 2023-12-13 11:35:05 +0900

    Add a test case for preregistering with different data

    We want to make sure that if preregister is called with different data,
    that the postponed job table is updated.

commit 15d14e2f396c10366902aefaca99ee73c10cd556
  Author:     KJ Tsanaktsidis <ktsanaktsidis@zendesk.com>
  AuthorDate: 2023-12-11 13:09:05 +0900
  Commit:     KJ Tsanaktsidis <kj@kjtsanaktsidis.id.au>
  CommitDate: 2023-12-13 11:35:05 +0900

    Simplify implementation of tracepoint tests

    With the latest version of the postponed job patchset merged, we don't
    actually need to go through the contortions of keeping the data in a
    global variable; we can just update `data` with multiple calls to
    rb_postponed_job_preregister.

commit 4eefab592ac068acfd06fb9422f75a7786fbb855
  Author:     KJ Tsanaktsidis <ktsanaktsidis@zendesk.com>
  AuthorDate: 2023-12-11 13:00:43 +0900
  Commit:     KJ Tsanaktsidis <kj@kjtsanaktsidis.id.au>
  CommitDate: 2023-12-13 11:35:05 +0900

    Refactor local variable names in postponed_job methods

    Just removes the unneeded `prereg_` prefix from a few local var names.

commit 626daa73ec244fa5a159dff31199bd336ec4ac8c
  Author:     KJ Tsanaktsidis <ktsanaktsidis@zendesk.com>
  AuthorDate: 2023-12-11 12:52:47 +0900
  Commit:     KJ Tsanaktsidis <kj@kjtsanaktsidis.id.au>
  CommitDate: 2023-12-13 11:35:05 +0900

    Small doc improvements for rb_postponed_job API

commit e96f6126f27c097d8148da143bb18edbe4180a61
  Author:     Ufuk Kayserilioglu <ufuk.kayserilioglu@shopify.com>
  AuthorDate: 2023-12-13 08:54:01 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2023-12-13 09:21:42 +0900

    [ruby/prism] Fix hash deopt based on contents

    The previous implementation of hash deopt was based on clearing the static literal flag on a hash node if the element that was being added was an array, hash or range node, or if the element was not a static literal in the first place.

    However, this is not correct. First of all, the elements added to a hash node will primarily be assoc nodes, but never array, hash or range nodes. Secondly, the static literal flag is set on assoc nodes, only if the value in an assoc node is a static literal, so the key is never checked. As a result, the static literal flag on a hash node would never be cleared if the key wasn't a static literal.

    This commit fixes this by clearing the static literal flag if:
    1. the element is not an assoc node,
    2. the element is an assoc node, but the key is not a static literal, or
    3. the element is an assoc node, the key is a static literal, but assoc node (and thus the value in assoc node) is not a static literal.

    https://github.com/ruby/prism/commit/7f67109b36

commit 2350c7946275cd570cc1d7cd892abc16ac68a92c
  Author:     Peter Zhu <peter@peterzhu.ca>
  AuthorDate: 2023-12-12 03:23:26 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2023-12-13 08:47:58 +0900

    Use xfree for IO::Buffer

    Since IO::Buffer is allocated using TypedData_Make_Struct, it must use
    xfree to free the buffer otherwise it will cause more major GC to run.

    Example:

    ```
    10.times do
      1_000_000.times { IO::Buffer.new(0) }

      puts "oldmalloc_increase_bytes: #{GC.stat(:oldmalloc_increase_bytes)}, major_gc_count: #{GC.stat(:major_gc_count)}"
    end
    ```

    Before:

    ```
    oldmalloc_increase_bytes: 14904176, major_gc_count: 3
    oldmalloc_increase_bytes: 2399424, major_gc_count: 5
    oldmalloc_increase_bytes: 5204640, major_gc_count: 6
    oldmalloc_increase_bytes: 2199936, major_gc_count: 7
    oldmalloc_increase_bytes: 34199936, major_gc_count: 7
    oldmalloc_increase_bytes: 24223360, major_gc_count: 8
    oldmalloc_increase_bytes: 5967616, major_gc_count: 9
    oldmalloc_increase_bytes: 37967616, major_gc_count: 9
    oldmalloc_increase_bytes: 9689792, major_gc_count: 10
    oldmalloc_increase_bytes: 41689792, major_gc_count: 10
    ```

    After:

    ```
    oldmalloc_increase_bytes: 117392, major_gc_count: 2
    oldmalloc_increase_bytes: 26128, major_gc_count: 2
    oldmalloc_increase_bytes: 71600, major_gc_count: 2
    oldmalloc_increase_bytes: 117072, major_gc_count: 2
    oldmalloc_increase_bytes: 17296, major_gc_count: 2
    oldmalloc_increase_bytes: 62768, major_gc_count: 2
    oldmalloc_increase_bytes: 108240, major_gc_count: 2
    oldmalloc_increase_bytes: 153712, major_gc_count: 2
    oldmalloc_increase_bytes: 53936, major_gc_count: 2
    oldmalloc_increase_bytes: 99408, major_gc_count: 2
    ```

commit 18a5b6b7e9c06cc3205ee0d2681a2adf6a52baaa
  Author:     BurdetteLamar <burdettelamar@yahoo.com>
  AuthorDate: 2023-12-13 06:05:19 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2023-12-13 07:32:59 +0900

    [DOC] RDoc for Complex

commit 9f77eb1f5a1e52a32b249abaef990e50c31e2ecc
  Author:     Alan Wu <alanwu@ruby-lang.org>
  AuthorDate: 2023-12-13 07:24:17 +0900
  Commit:     Alan Wu <alanwu@ruby-lang.org>
  CommitDate: 2023-12-13 07:24:17 +0900

    Remove unused macros

commit d4bbee7475269972cf56ebd3b5e4dc9905789663
  Author:     Alan Wu <XrXr@users.noreply.github.com>
  AuthorDate: 2023-12-13 07:10:14 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2023-12-13 07:10:14 +0900

    YJIT: Fix off-by-one in Kernel#send type handling (#9212)

    Previously, if the method ID argument happens to be on one below the top
    of the stack, we didn't overwrite the type of the stack slot, which
    leaves an incorrect type for the stack slot. The included script tripped
    asserts both with and without --yjit-verify-ctx.

commit 6e491cae5da769c38bfc88bc28aa1af8ec1705df
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2023-12-13 06:01:09 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2023-12-13 06:01:09 +0900

    Move --repeat-count=2 job to macos-arm-oss (#9208)

commit a6526342f3fbd94abc44cc4e99eda0943a61271f
  Author:     eileencodes <eileencodes@gmail.com>
  AuthorDate: 2023-12-13 03:44:33 +0900
  Commit:     Jemma Issroff <jemmaissroff@gmail.com>
  CommitDate: 2023-12-13 05:15:02 +0900

    [PRISM] Fix segv with regex once flag

    When you have an interpolated regex with a `once` flag and local
    variable is outside the block created by the `once` flag, Prism would
    see a segv. This is because it was not taking the depth into account.

    To fix this, we need to add 1 to the `local_depth_offset` on the
    `scope`.

    Fixes: ruby/prism#2047

commit 1572322e17caf2f0900f02099d21245b81554a28
  Author:     David Rodríguez <deivid.rodriguez@riseup.net>
  AuthorDate: 2023-12-13 04:49:25 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2023-12-13 04:49:25 +0900

    Sync with upstream rubygems (#9206)

commit 0366c424e59b65fed953aa2148eaf14cb90bb6d3
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2023-12-13 04:45:47 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2023-12-13 04:45:48 +0900

    Remove a duplicated job

    This was first added in b481b673d75, but 197e91f357 added
    -DUNIVERSAL_PARSER to the Compilers workflow as well.

    Given the nature of this test and the fact that it also runs make
    test-all besides make test, I think it's better to keep only the
    Compilers one.

commit fd7decbf04f58438c04fa09fb325b16fbbec40c4
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2023-12-13 04:19:00 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2023-12-13 04:19:02 +0900

    Allow syncing tool/bundler

commit 43ede3f26cda8c2a4dfbce9a44b0b6aa06281cd7
  Author:     Matt Valentine-House <matt@eightbitraptor.com>
  AuthorDate: 2023-12-13 01:23:50 +0900
  Commit:     Jemma Issroff <jemmaissroff@gmail.com>
  CommitDate: 2023-12-13 03:46:36 +0900

    [PRISM] Compile NextNode arguments

commit d1cf793adce7f797a3cd03594c539729c0099ec8
  Author:     Stan Lo <stan001212@gmail.com>
  AuthorDate: 2023-12-13 03:46:03 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2023-12-13 03:46:07 +0900

    [ruby/irb] Remove documents about deprecated/WIP features and some
    slight adjustments
    (https://github.com/ruby/irb/pull/811)

    https://github.com/ruby/irb/commit/6a9193e88b

commit b9dfe04a73b9b4b9a3d3e96a3418a8d105e5c63a
  Author:     Jemma Issroff <jemmaissroff@gmail.com>
  AuthorDate: 2023-12-13 01:08:40 +0900
  Commit:     Jemma Issroff <jemmaissroff@gmail.com>
  CommitDate: 2023-12-13 03:45:21 +0900

    [PRISM] Implementing forwarding of args for ForwardingSuperNode

    ForwardingSuperNodes need to actually forward any applicable
    arguments. This commit implements that logic, by using the data
    stored on the local iseq about the parameters to forward the
    appropriate arguments.

commit 68753e44083f7d4d171f66aa092b35ccb41a66f6
  Author:     Jemma Issroff <jemmaissroff@gmail.com>
  AuthorDate: 2023-12-12 23:40:16 +0900
  Commit:     Jemma Issroff <jemmaissroff@gmail.com>
  CommitDate: 2023-12-13 03:45:21 +0900

    [PRISM] Allow rest parameter to be `*`

    Prior to this commit, if a rest parameters was `*`, we did not add
    it to the locals table correctly. This commit fixes that.

commit f61df27b4ca73a31401ebe0357a3b7de947128e8
  Author:     Kevin Newton <kddnewton@gmail.com>
  AuthorDate: 2023-12-13 03:43:54 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2023-12-13 03:43:59 +0900

    [ruby/prism] Use new flag setters for attribute write

    https://github.com/ruby/prism/commit/1e07832778

commit 06e2fbb8260022de8532d2e940fc69e8ea413679
  Author:     Kouhei Yanagita <yanagi@shakenbu.org>
  AuthorDate: 2023-11-22 18:12:23 +0900
  Commit:     Aaron Patterson <aaron.patterson@gmail.com>
  CommitDate: 2023-12-13 02:36:37 +0900

    [Bug #19114] Fix for multiple calls of TracePoint#enable

commit 1f22245ed5004ef097e192aec157b34409214a2a
  Author:     Ufuk Kayserilioglu <ufuk.kayserilioglu@shopify.com>
  AuthorDate: 2023-12-12 07:30:50 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2023-12-13 02:35:53 +0900

    [ruby/prism] Start using flag macros/methods exclusively

    https://github.com/ruby/prism/commit/5f05a6fe83

commit bdb38dd9f22accfddc8d0a5e211c74b6a06faf51
  Author:     Ufuk Kayserilioglu <ufuk.kayserilioglu@shopify.com>
  AuthorDate: 2023-12-12 07:28:03 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2023-12-13 02:35:52 +0900

    [ruby/prism] Add methods for setting/unsetting and macros for testing a flags

    https://github.com/ruby/prism/commit/e5f37d1407

commit 67940b135cae091f0f13d2c531b2ef33660e82fc
  Author:     David Rodríguez <deivid.rodriguez@riseup.net>
  AuthorDate: 2023-12-13 00:43:24 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2023-12-13 02:16:19 +0900

    [rubygems/rubygems] Bump rake version used by tests

    And make it easier to update next time.

    https://github.com/rubygems/rubygems/commit/1ea4bfa5d8

commit 278ce27ee4063dec5b8967563d58e32ea087a380
  Author:     Kevin Newton <kddnewton@gmail.com>
  AuthorDate: 2023-12-13 00:39:41 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2023-12-13 00:55:54 +0900

    [ruby/prism] Flag for attribute write on calls

    https://github.com/ruby/prism/commit/465731969c

commit 2f1d6da8c45590bf3461ed4bf051a4e1009eaf85
  Author:     Jeremy Evans <code@jeremyevans.net>
  AuthorDate: 2023-12-13 00:34:53 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2023-12-13 00:34:53 +0900

    Fix op asgn calls with keywords

    Examples of such calls:

    ```ruby
    obj[kw: 1] += fo
    obj[**kw] &&= bar
    ```

    Before this patch, literal keywords would segfault in the compiler,
    and keyword splat usage would result in TypeError.

    This handles all cases I can think of:

    * literal keywords
    * keyword splats
    * combined with positional arguments
    * combined with regular splats
    * both with and without blocks
    * both popped and non-popped cases

    This also makes sure that to_hash is only called once on the keyword
    splat argument, instead of twice, and make sure it is called before
    calling to_proc on a passed block.

    Fixes [Bug #20051]

    Co-authored-by: Nobuyoshi Nakada <nobu@ruby-lang.org>

commit f671c5d1791d14a44902cfe672ae6b457d1592e9
  Author:     Martin Emde <martin.emde@gmail.com>
  AuthorDate: 2023-12-12 09:40:07 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2023-12-13 00:26:01 +0900

    [rubygems/rubygems] Make RubyDsl a little easier to read; avoid a Hash sometimes

    https://github.com/rubygems/rubygems/commit/2dca83722b

commit f466afa1768f437d5ee79444f35d65bc6e5374e8
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2023-11-09 22:29:44 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2023-12-12 23:57:27 +0900

    [PRISM] Do not hide syntactically required parentheses within macros

    It makes code formatters confused when auto indenting.

commit 185b7e92a37548255fcc8c5ab08b72abeadaf74e
  Author:     Peter Zhu <peter@peterzhu.ca>
  AuthorDate: 2023-12-09 05:18:07 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2023-12-12 23:01:21 +0900

    Make WeakKeyMap safe for compaction during allocation

    During allocation, the table may not have been allocated yet which would
    crash in the st_foreach.

commit 33cf8f640bab35c463186ef0856689c22559fbeb
  Author:     Peter Zhu <peter@peterzhu.ca>
  AuthorDate: 2023-12-09 05:17:51 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2023-12-12 23:01:21 +0900

    Make WeakMap safe for compaction during allocation

    During allocation, the table may not have been allocated yet which would
    crash in the st_foreach.

commit d313c82f797852037012138284d4e49fdaf284c4
  Author:     Ufuk Kayserilioglu <ufuk.kayserilioglu@shopify.com>
  AuthorDate: 2023-12-12 05:28:58 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2023-12-12 22:05:09 +0900

    [ruby/prism] Update tests and snapshots

    https://github.com/ruby/prism/commit/0663e2bcfa

commit 43229d531ff77cd9f8414e75141fcf54fafb22c4
  Author:     Ufuk Kayserilioglu <ufuk.kayserilioglu@shopify.com>
  AuthorDate: 2023-12-12 05:26:51 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2023-12-12 22:05:09 +0900

    [ruby/prism] Start `KeywordHashNode`s with `STATIC_KEYS` set, until hit an element that should clear it

    https://github.com/ruby/prism/commit/7c7c486507

commit 25b9a0cbc86da562e765e4fac27bb28311646971
  Author:     Ufuk Kayserilioglu <ufuk.kayserilioglu@shopify.com>
  AuthorDate: 2023-12-12 05:26:06 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2023-12-12 22:05:08 +0900

    [ruby/prism] Add `STATIC_KEYS` flag for `KeywordHashNode`

    https://github.com/ruby/prism/commit/aa83de39c1

commit d1c25605f671c85b1088cb8021d815a89b629dbf
  Author:     Martin Emde <martin.emde@gmail.com>
  AuthorDate: 2023-12-12 08:31:15 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2023-12-12 21:40:17 +0900

    [rubygems/rubygems] Resolve `ruby file: ".ruby-version"` relative to Gemfile

    https://github.com/rubygems/rubygems/commit/0cbbaed8a5

commit 28a9a4275ce334ed50a582d8c781b40ce46a74ec
  Author:     Stan Lo <stan001212@gmail.com>
  AuthorDate: 2023-12-12 20:27:20 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2023-12-12 20:27:39 +0900

    [ruby/irb] Remove trailing space

    This is required to fix ruby/ruby's CI

    https://github.com/ruby/irb/commit/3c77213209

commit 35990cb38c0c77ddcd0b1f914b4fea5c13e12f39
  Author:     Burdette Lamar <BurdetteLamar@Yahoo.com>
  AuthorDate: 2023-12-12 19:34:34 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2023-12-12 19:34:38 +0900

    [ruby/irb] [DOC] RDoc for module IRB
    (https://github.com/ruby/irb/pull/738)

    [DOC] RDoc for module IRB

    https://github.com/ruby/irb/commit/f3a0626298

commit 25711e7063060920d14e42a530da6f7198926629
  Author:     KJ Tsanaktsidis <kj@kjtsanaktsidis.id.au>
  AuthorDate: 2023-12-09 10:30:39 +0900
  Commit:     KJ Tsanaktsidis <kj@kjtsanaktsidis.id.au>
  CommitDate: 2023-12-12 18:05:21 +0900

    Partially revert "Set AI_ADDRCONFIG when making getaddrinfo(3) calls"

    This _partially_ reverts commit
    d2ba8ea54a4089959afdeecdd963e3c4ff391748, but for UDP sockets only.

    With TCP sockets (and other things which use `rsock_init_inetsock`), the
    order of operations is to call `getaddrinfo(3)` with AF_UNSPEC, look at
    the returned addresses, pick one, and then call `socket(2)` with the
    family for that address (i.e. AF_INET or AF_INET6).

    With UDP sockets, however, this is reversed; `UDPSocket.new` takes an
    address family as an argument, and then calls `socket(2)` with that
    family. A subsequent call to UDPSocket#connect will then call
    `getaddrinfo(3)` with that family.

    The problem here is that...

    * If you are in a networking situation that _only_ has loopback addrs,
    * And you want to look up a name like "localhost" (or NULL)
    * And you pass AF_INET or AF_INET6 as the ai_family argument to
      getaddrinfo(3),
    * And you pass AI_ADDRCONFIG to the hints argument as well,

    then glibc on Linux will not return an address. This is because
    AI_ADDRCONFIG is supposed to return addresses for families we actually
    have an address for and could conceivably connect to, but also is
    documented to explicitly ignore localhost in that situation.

    It honestly doesn't make a ton of sense to pass AI_ADDRCONFIG if you're
    explicitly passing the address family anyway, because you're not looking
    for "an address for this name we can connect to"; you're looking for "an
    IPv(4|6) address for this name". And the original glibc bug that
    d2ba8ea5 was supposed to work around was related to parallel issuance of
    A and AAAA queries, which of course won't happen if an address family is
    explicitly specified.

    So, we fix this by not passing AI_ADDRCONFIG for calls to
    `rsock_addrinfo` that we also pass an explicit family to (i.e. for
    UDPsocket).

    [Bug #20048]

commit f64485af7eb8a1bbaabbf59434592b6e6a0299d0
  Author:     git <svn-admin@ruby-lang.org>
  AuthorDate: 2023-12-12 15:58:23 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2023-12-12 15:58:23 +0900

    Update bundled gems list as of 2023-12-12

commit e411bd5b3684bfa5c654290059e9207a9596aad7
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2023-12-12 14:41:09 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2023-12-12 15:40:44 +0900

    [ruby/securerandom] [DOC] Satisfy RDoc coverage

    https://github.com/ruby/securerandom/commit/ddf2672e47

commit dbd704ae6f0e0fdcefa2007ce1c06f7021c8e830
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2023-12-12 14:11:51 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2023-12-12 15:40:43 +0900

    [ruby/securerandom] [DOC] Add documents of methods and constants

    https://github.com/ruby/securerandom/commit/9a99978135

commit cb93d10ae559b0cf0f0935ddc1cc50dda65c6df8
  Author:     Yusuke Endoh <mame@ruby-lang.org>
  AuthorDate: 2023-12-12 15:35:59 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2023-12-12 15:36:10 +0900

    [ruby/securerandom] [DOC] Improve the document about reproducibility of uuid_v7

    https://github.com/ruby/securerandom/pull/19/files#r1329476195

    https://github.com/ruby/securerandom/commit/156cbb8448

commit f49af3c969eb7ba9937514a229b49e5b7d91f0f1
  Author:     Jeremy Evans <code@jeremyevans.net>
  AuthorDate: 2023-12-12 10:34:52 +0900
  Commit:     Jeremy Evans <code@jeremyevans.net>
  CommitDate: 2023-12-12 15:31:16 +0900

    Make Dir#chdir never yield args, and return block return value

    If no block is given, return 0 instead of nil for consistency
    with Dir.chdir and Dir.fchdir.

commit 9f0065a077f00a077f507461846234c52509ce90
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2023-12-12 14:12:08 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2023-12-12 14:12:08 +0900

    Initialize interrupt queue before signal handlers (#9196)

commit 1e5c8afb151c0121e83657fb6061d0e3805d30f6
  Author:     Martin Emde <martin.emde@gmail.com>
  AuthorDate: 2023-12-12 10:16:37 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2023-12-12 11:39:57 +0900

    [rubygems/rubygems] Ensure that the lockfile mtime is not altered on frozen install

    https://github.com/rubygems/rubygems/commit/6847709ee0

commit 6b3abcf4622c6ae39ddfd5b21c2387f177f82e0d
  Author:     NARUSE, Yui <naruse@airemix.jp>
  AuthorDate: 2023-12-11 16:01:04 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2023-12-12 11:22:40 +0900

    fix regexp pattern of diff

commit e223dde3295cc59415c289305fd8d706d46cd2e9
  Author:     Samuel Giddins <segiddins@segiddins.me>
  AuthorDate: 2023-08-31 07:21:20 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2023-12-12 11:10:53 +0900

    [rubygems/rubygems] Allow bundle pristine to run in parallel

    Also fix running when BUNDLE_NO_INSTALL happens to be set, same as with install/update commands

    https://github.com/rubygems/rubygems/commit/a555fd6ccd

commit 305f66b859c0fd123c95db74700d8b2c13fe2fe2
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2023-12-12 11:06:27 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2023-12-12 11:06:27 +0900

    Save $VERBOSE properly

commit 73b43fffa163e11ce9e7e8880631acb870ac1695
  Author:     Yusuke Endoh <mame@ruby-lang.org>
  AuthorDate: 2023-12-12 10:31:14 +0900
  Commit:     Yusuke Endoh <mame@ruby-lang.org>
  CommitDate: 2023-12-12 10:31:37 +0900

    Prevent a warning: assigned but unused variable - status

commit 207dcf07e1e1359ca87590c8c22867024f20ae03
  Author:     Yusuke Endoh <mame@ruby-lang.org>
  AuthorDate: 2023-12-12 10:30:12 +0900
  Commit:     Yusuke Endoh <mame@ruby-lang.org>
  CommitDate: 2023-12-12 10:31:37 +0900

    Prevent a warning: method redefined

commit cfb8494d5473b3695ac40aa6a9891284603bfc89
  Author:     Yusuke Endoh <mame@ruby-lang.org>
  AuthorDate: 2023-12-12 10:29:26 +0900
  Commit:     Yusuke Endoh <mame@ruby-lang.org>
  CommitDate: 2023-12-12 10:31:37 +0900

    Prevent warning: possibly useless use of a literal in void context

commit 0c287df3bc4c1a7aed3279e20590ecf628722b4d
  Author:     Yusuke Endoh <mame@ruby-lang.org>
  AuthorDate: 2023-12-12 10:28:19 +0900
  Commit:     Yusuke Endoh <mame@ruby-lang.org>
  CommitDate: 2023-12-12 10:31:37 +0900

    Prevent a warning: setting Encoding.default_external

commit 535eb4de1109f5b8a8bde063dacc4c6fabf2322c
  Author:     Yusuke Endoh <mame@ruby-lang.org>
  AuthorDate: 2023-12-12 10:26:06 +0900
  Commit:     Yusuke Endoh <mame@ruby-lang.org>
  CommitDate: 2023-12-12 10:31:37 +0900

    Remove unused statement

    ... to disable a warning: assigned but unused variable - expected

commit 6414f260fc64878dc32f6899f5cecfac9908d26d
  Author:     Franz Liedke <franz@develophp.org>
  AuthorDate: 2023-12-04 17:15:58 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2023-12-12 10:08:20 +0900

    [rubygems/rubygems] Refactor: Wrap filesystem access

    https://github.com/rubygems/rubygems/commit/119d4bdc09

commit 0653fb026cd2203158b7af1e8b9608911dce2860
  Author:     Franz Liedke <franz@develophp.org>
  AuthorDate: 2023-12-03 04:03:39 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2023-12-12 10:08:20 +0900

    [rubygems/rubygems] Refactor: Move filesystem access into Definition class

    https://github.com/rubygems/rubygems/commit/2720da2659

commit 0ec88b54f34ee0b0197f963ad6a98a2390a91de7
  Author:     Franz Liedke <franz@develophp.org>
  AuthorDate: 2023-12-03 03:54:44 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2023-12-12 10:08:19 +0900

    [rubygems/rubygems] bundle lock: Always touch the lockfile

    https://github.com/rubygems/rubygems/commit/fd2e71dfdb

commit 8c2480c9edf7d20505a8c3491ec84a3fdd77bd2e
  Author:     David Rodríguez <deivid.rodriguez@riseup.net>
  AuthorDate: 2023-12-12 05:30:12 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2023-12-12 10:04:57 +0900

    Unlock tilt since we no longer support Ruby 2.6

commit a848c070d28fd8c836e3bf06c4b73cf7d293a290
  Author:     David Rodríguez <deivid.rodriguez@riseup.net>
  AuthorDate: 2023-12-12 05:31:37 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2023-12-12 10:04:57 +0900

    [rubygems/rubygems] Remove doc not adding much value

    https://github.com/rubygems/rubygems/commit/c241a88962

commit 0e05392dccaaf4f9a0ce66228fd64dbd96b62227
  Author:     Martin Emde <martin.emde@gmail.com>
  AuthorDate: 2023-12-09 04:25:23 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2023-12-12 10:04:57 +0900

    [rubygems/rubygems] Make tests compatible with paths that contain a + char

    https://github.com/rubygems/rubygems/commit/3355c80c90

commit 3b9ea6648fcc110769c27686ebdc51fbbf1798c8
  Author:     Martin Emde <martin.emde@gmail.com>
  AuthorDate: 2023-12-09 02:44:10 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2023-12-12 10:04:57 +0900

    [rubygems/rubygems] Use StringIO 3.1.0 in tests to work with ruby 3.3.0

    https://github.com/rubygems/rubygems/commit/8a936d733d

commit 0b24c71a5a30a7d38976f6d0c20e71d9399adb02
  Author:     David Rodríguez <deivid.rodriguez@riseup.net>
  AuthorDate: 2023-12-08 07:25:44 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2023-12-12 10:04:57 +0900

    [rubygems/rubygems] Improve enabling bundled gems warnings

    https://github.com/rubygems/rubygems/commit/7be5b40ca9

commit a06bf001b29bba77e71ba270f73469d9c9b4b0f0
  Author:     David Rodríguez <deivid.rodriguez@riseup.net>
  AuthorDate: 2023-12-07 22:51:22 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2023-12-12 10:04:57 +0900

    [rubygems/rubygems] Remove non-transparent requirement added to prerelease gems

    I think we can safely assume these days that all RubyGems and Bundler
    versions that will ever bundle a new gem created in 2023 support
    prereleases.

    So this non transparent requirement is not necessary.

    In my opinion, it should be the gem author to explicitly add this
    constraint, not RubyGems.

    https://github.com/rubygems/rubygems/commit/b165e6d725

commit b37288c047681e02615b5b484fb265b394ddc612
  Author:     Vít Ondruch <vondruch@redhat.com>
  AuthorDate: 2023-12-08 22:03:07 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2023-12-12 10:04:56 +0900

    [rubygems/rubygems] Make the "auto-user-install" logic easier to follow

    https://github.com/rubygems/rubygems/commit/4b4d9c0106

commit c032dfb5cbd844a8474a1397e65b4e04203d0ddd
  Author:     David Rodríguez <deivid.rodriguez@riseup.net>
  AuthorDate: 2023-12-12 01:28:10 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2023-12-12 10:04:56 +0900

    [rubygems/rubygems] Fix installing from source when same bundler version already a default gem

    https://github.com/rubygems/rubygems/commit/620119308e

commit 23289ad45bcf67e218352503958e2d788fbb6c2c
  Author:     David Rodríguez <deivid.rodriguez@riseup.net>
  AuthorDate: 2023-12-12 01:22:54 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2023-12-12 10:04:56 +0900

    [rubygems/rubygems] Extract some common strings to variables

    https://github.com/rubygems/rubygems/commit/48bc573310

commit a811ebf3d5113971b6dc62a8c56053bca1a1d49b
  Author:     David Rodríguez <deivid.rodriguez@riseup.net>
  AuthorDate: 2023-12-08 06:49:14 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2023-12-12 10:04:56 +0900

    [rubygems/rubygems] Revert missing extensions patch

    https://github.com/rubygems/rubygems/commit/4016c6c024

commit 38348502b5429703e418cf4634e405ce77fd4bbc
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2023-12-12 09:39:13 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2023-12-12 09:39:13 +0900

    [DOC] Update description about shared library suffix

    Loading an extension library with ".dll" suffix on Windows was very
    old behavior, and the suffix must be ".so" since 2004.  See commits
    removing DLEXT2 181a3a2af5df88d145b73a060d51fe437c8c4ad4 and
    b76ad15ed0da636161de0243c547ee1e6fc95681.

    Instead, use macOS as an example, which uses ".bundle".

commit 4eca329d29a98209df401aa97d55b9fb8684ba1b
  Author:     Alan Wu <XrXr@users.noreply.github.com>
  AuthorDate: 2023-12-12 08:55:24 +0900
  Commit:     Alan Wu <XrXr@users.noreply.github.com>
  CommitDate: 2023-12-12 09:21:08 +0900

    Skip a YJIT test on RJIT

commit 9cb0ad863c0781062388fe1bb2a5d279dc29e734
  Author:     Alan Wu <XrXr@users.noreply.github.com>
  AuthorDate: 2023-12-12 07:41:27 +0900
  Commit:     Alan Wu <XrXr@users.noreply.github.com>
  CommitDate: 2023-12-12 09:21:08 +0900

    YJIT: Fix missing arity check for splat calls to methods with optionals

    Previously, for splat callsites that land in methods with optional
    parameters, we didn't reject the case where the caller supplies too many
    arguments. Accepting those calls previously caused YJIT to construct
    corrupted control frames, which leads to crashes if the callee uses
    certain stack walking methods such as Kernel#raise and String#gsub (for
    setting up the frame-local `$~`).

    Example crash in a debug build:

        Assertion Failed: ../vm_core.h:1375:VM_ENV_FLAGS:FIXNUM_P(flags)

commit 47553094740ee17f2490fcb29893cac653c0b5dd
  Author:     Alan Wu <XrXr@users.noreply.github.com>
  AuthorDate: 2023-12-12 07:37:39 +0900
  Commit:     Alan Wu <XrXr@users.noreply.github.com>
  CommitDate: 2023-12-12 09:21:08 +0900

    YJIT: Rename helper function and correct counter name

    Counter::guard_send_iseq_has_rest_and_splat_not_equal was using
    jump-if-lesser-than, so wasn't checking for equality. Rename function
    because moving is destructive in Rust, which is confusing for this function
    which doesn't modify the array.

commit 9765ada69c34eb1c21855d145c2c6d752b8839b0
  Author:     Kazuhiro NISHIYAMA <zn@mbf.nifty.com>
  AuthorDate: 2023-12-12 08:47:18 +0900
  Commit:     Kazuhiro NISHIYAMA <znz@users.noreply.github.com>
  CommitDate: 2023-12-12 09:14:11 +0900

    Fix NoMethodError on fail

    ```
    .../tool/lib/colorize.rb:56:in `resolve_color': undefined method `gsub' for an instance of Symbol (NoMethodError)

        color.gsub(/\b[a-z][\w ]+/) do |n|
             ^^^^^
            from .../tool/lib/colorize.rb:47:in `decorate'
            from .../tool/lib/test/unit.rb:1012:in `block in failed'
    ```

commit 505715ddf17e004d184c0b71afb40a31e2e8c98e
  Author:     Samuel Giddins <segiddins@segiddins.me>
  AuthorDate: 2023-09-19 10:51:15 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2023-12-12 08:14:58 +0900

    [rubygems/rubygems] Fewer allocations in gem installation

    For now, on a small rails app I have hanging around:

    ```
    ==> memprof.after.txt <==
    Total allocated: 872.51 MB (465330 objects)
    Total retained:  40.48 kB (326 objects)

    ==> memprof.before.txt <==
    Total allocated: 890.79 MB (1494026 objects)
    Total retained:  40.40 kB (328 objects)
    ```

    Not a huge difference in memory usage, but it's a drastic improvement
    in total number of allocations.

    Additionally, this will pay huge dividends once
    https://github.com/ruby/zlib/pull/61 is merged, as it will allow us to
    completely avoid allocations in the repeated calls to readpartial,
    which currently accounts for most of the memory usage shown above.

    https://github.com/rubygems/rubygems/commit/f78d45d927

commit 4a94ce8569c9399bd286d943ff35f6f3a25ed1b6
  Author:     hogelog <konbu.komuro@gmail.com>
  AuthorDate: 2023-12-12 07:13:54 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2023-12-12 07:13:54 +0900

    [DOC] Fix RDoc to match actual Kenrel.require behavior (#9180)

commit 69d60cc67ba0d7cf9318ccafa9d4c625103e955d
  Author:     Jemma Issroff <jemmaissroff@gmail.com>
  AuthorDate: 2023-12-12 05:17:48 +0900
  Commit:     Jemma Issroff <jemmaissroff@gmail.com>
  CommitDate: 2023-12-12 07:04:46 +0900

    [PRISM] Properly compile MultiTargetNodes within parameters

    If there are MultiTargetNodes within parameters, we need to
    iterate over them and compile them individually correctly, once
    the locals are all in the correct spaces. We need to add one
    getlocal for the hidden variable, and then can recurse into the
    MultiTargetNodes themselves

commit 5c8e1911ca19bc3d346db5ae6314cc8957e9339a
  Author:     Jemma Issroff <jemmaissroff@gmail.com>
  AuthorDate: 2023-12-12 04:46:24 +0900
  Commit:     Jemma Issroff <jemmaissroff@gmail.com>
  CommitDate: 2023-12-12 07:04:46 +0900

    [PRISM] Fixed rest in MultiTargetNodes

commit aaeccc2924d34e2c012df0cd482ca66a9d7297c4
  Author:     Jemma Issroff <jemmaissroff@gmail.com>
  AuthorDate: 2023-12-12 04:17:02 +0900
  Commit:     Jemma Issroff <jemmaissroff@gmail.com>
  CommitDate: 2023-12-12 07:04:46 +0900

    [PRISM] Correctly implemented forwarding parameters in methods

commit 85ad5be9ee7597f6a550d66c90dc4fdd5a15f923
  Author:     Jemma Issroff <jemmaissroff@gmail.com>
  AuthorDate: 2023-12-07 00:05:14 +0900
  Commit:     Jemma Issroff <jemmaissroff@gmail.com>
  CommitDate: 2023-12-12 07:04:46 +0900

    [PRISM] Restructure parameters on ScopeNodes

    This commit completely restructures how we handle parameters. The
    motivation for this commit was the fix compilation of MultiTargetNodes
    within parameters, including nested MultiTargetNodes. A subsequent
    commit will actually do the compilation for the MultiTargetNodes.

    This commit's main accomplishment is restructuring the locals table
    and how we account for it on the ScopeNode, specifically with regards
    to hidden variables.

    It has multiple steps, all commented within the code, to calculate
    the locals table correctly and compile the parameters:
    - Step 1: Caculate the table size for the locals
    - Step 2: Populate iv index table and local table
    - Step 3: Fill in parameter names of MultiTargetNodes on local table
    - Step 4: Fill in method body locals on local table
    - Step 5: Compile any locals

commit e1d995a96cf99387ce1798904c3051ba11e43d18
  Author:     Burdette Lamar <BurdetteLamar@Yahoo.com>
  AuthorDate: 2023-12-12 05:38:16 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2023-12-12 05:38:16 +0900

    [DOC] Complex doc (#9185)

commit 687d29f93ce45bd6721fc06530015a147e4057f0
  Author:     Koichi Sasada <ko1@atdot.net>
  AuthorDate: 2023-12-11 07:40:22 +0900
  Commit:     Koichi Sasada <ko1@atdot.net>
  CommitDate: 2023-12-12 02:59:10 +0900

    try modified tests.

    debug.gem 1.9.0 has a test issue so try modified one.
    ref: https://github.com/ruby/debug/commit/d4feeae32b69b4f88c94fecfc7a283b475eec4de

commit fb935350707ce14b2f678612dae4cae079fd163c
  Author:     Jemma Issroff <jemmaissroff@gmail.com>
  AuthorDate: 2023-12-12 02:14:21 +0900
  Commit:     Jemma Issroff <jemmaissroff@gmail.com>
  CommitDate: 2023-12-12 02:53:47 +0900

    [PRISM] Define and use a pm_add_ensure_iseq

    Prior to this commit, we were using `add_ensure_iseq` which compiled
    a node as if it was a CRuby node. This commit defines
    `pm_add_ensure_iseq` which compiles the Prism node appropriately.

commit 3f25c08fa598ba48da8bb504aabe93a4a4c2d486
  Author:     Maxime Chevalier-Boisvert <maxime.chevalierboisvert@shopify.com>
  AuthorDate: 2023-12-12 02:52:47 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2023-12-12 02:52:47 +0900

    YJIT: implement call fuzzer script (#9129)

    * YJIT: implement call fuzzer script

    Attempt to detect bugs in YJIT call implementation.

    * Add basic checks for rest, kwrest. Impprove formatting.

    * Refactor call fuzzer to make it more powerful and maintainable

    Compute checksum of arguments

    * Fix checksum computation. Add useless locals as sussged by Alan.

    * Add some useless if statements

    * Add arguments of different types

    * Pass object arguments as well. Force different shapes.

    * Compute fuzzing time/speed

    * Make use of block param

commit 4095e7d2be0ef6426e0cb75a53472f6dc1e5a0af
  Author:     Kevin Newton <kddnewton@gmail.com>
  AuthorDate: 2023-12-11 23:30:24 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2023-12-12 01:34:55 +0900

    [ruby/prism] Regexp terminator escapes

    https://github.com/ruby/prism/commit/42a48a2ba9

commit c65de63913487caf26a281cb5c3be112f87a23a1
  Author:     Kevin Newton <kddnewton@gmail.com>
  AuthorDate: 2023-12-11 23:12:54 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2023-12-12 01:34:41 +0900

    [ruby/prism] Handle a non-interpolated dsym spanning a heredoc

    https://github.com/ruby/prism/commit/b23136ebfd

commit 261e8f28a0ccc6119fe38189a55388520969d8ff
  Author:     Kevin Newton <kddnewton@gmail.com>
  AuthorDate: 2023-12-11 22:50:59 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2023-12-12 01:34:27 +0900

    [ruby/prism] Correct escapes when ctrl+meta+escape

    https://github.com/ruby/prism/commit/ee68b17c01

commit e186cebe420367947b89a5221491429452d724d5
  Author:     Martin Emde <martin.emde@gmail.com>
  AuthorDate: 2023-12-09 05:13:49 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2023-12-12 00:40:08 +0900

    [rubygems/rubygems] Override initialize in bundle rubygems_ext for NameTuple

    https://github.com/rubygems/rubygems/commit/f63ce682d2

commit b673b5b4329d020b19907142f291c8ecd69e95e0
  Author:     Kevin Newton <kddnewton@gmail.com>
  AuthorDate: 2023-12-08 23:57:31 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2023-12-12 00:32:31 +0900

    [ruby/prism] Split up CallNode in target position

    In this commit we're splitting up the call nodes that were in target
    positions (that is, for loop indices, rescue error captures, and
    multi assign targets).

    Previously, we would simply leave the call nodes in place. This had
    the benefit of keeping the AST relatively simple, but had the
    downside of not being very explicit. If a static analysis tool wanted
    to only look at call nodes, it could easily be confused because the
    method would have 1 fewer argument than it would actually be called
    with.

    This also brings some consistency to the AST. All of the nodes in
    a target position are now *TargetNode nodes. These should all be
    treated the same, and the call nodes can now be treated the same.

    Finally, there is benefit to memory. Because being in a target
    position ensures we don't have some fields, we can strip down the
    number of fields on these nodes.

    So this commit introduces two new nodes: CallTargetNode and
    IndexTargetNode. For CallTargetNode we get to drop the opening_loc,
    closing_loc, arguments, and block. Those can never be present. We
    also get to mark their fields as non-null, so they will always be
    seen as present.

    The IndexTargetNode keeps around most of its fields but gets to
    drop both the name (because it will always be []=) and the
    message_loc (which was always super confusing because it included
    the arguments by virtue of being inside the []).

    Overall, this adds complexity to the AST at the expense of memory
    savings and explicitness. I believe this tradeoff is worth it in
    this case, especially because these are very much not common nodes
    in the first place.

    https://github.com/ruby/prism/commit/3ef71cdb45

commit c69d1367a7994c70f956fc6486568823e8fa5812
  Author:     Jemma Issroff <jemmaissroff@gmail.com>
  AuthorDate: 2023-12-09 06:17:07 +0900
  Commit:     Jemma Issroff <jemmaissroff@gmail.com>
  CommitDate: 2023-12-11 23:47:59 +0900

    [PRISM] Fix ElseNode within CaseNode

    The logic within the consequent for the CaseNodes in popped cases
    was incorrect as it wouldn't emit consequent instructions for a
    popped CaseNode. This commit fixes that.

commit 0562c246ebdf071dfb85b2f7904574d38fee14f7
  Author:     Ufuk Kayserilioglu <ufuk.kayserilioglu@shopify.com>
  AuthorDate: 2023-12-07 08:36:00 +0900
  Commit:     Jemma Issroff <jemmaissroff@gmail.com>
  CommitDate: 2023-12-11 23:47:33 +0900

    Add handling of implicit hash arguments

    Arguments that are passed as a hash need special consideration since in certain case they are not treated as keyword arguments. For example, if a call is passing `"a" => 1` as an argument, this will be turned into an implicit hash argument and not a keyword argument.

    The existing compiler checks to see if all hash nodes can be treated as keyword arguments. If they can, then it will treat them as keyword arguments. If not, then it will treat them as implicit hash arguments.

    This commit implements the same logic inside the Prism compiler.

commit 48cb70fee95dcdcf5f9eef2ef40c3adfecc214fa
  Author:     TSUYUSATO Kitsune <make.just.on@gmail.com>
  AuthorDate: 2023-12-11 12:44:33 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2023-12-11 22:36:37 +0900

    [ruby/prism] Fix parsing unterminated empty string `"`

    Fix https://github.com/ruby/prism/pull/2034

    https://github.com/ruby/prism/commit/8280e577fa

commit a860e3605c53e708d3cb06e2080ff73b58de4b22
  Author:     TSUYUSATO Kitsune <make.just.on@gmail.com>
  AuthorDate: 2023-12-11 14:10:57 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2023-12-11 22:34:48 +0900

    [ruby/prism] Fix to parse a (endless-)range with binary operators

    Fix https://github.com/ruby/prism/pull/2022
    Fix https://github.com/ruby/prism/pull/2030

    https://github.com/ruby/prism/commit/b78d8b6525

commit 1ab91b12fa5f7e98bba2e59e2f40b57004d9acf1
  Author:     Daisuke Aritomo <osyoyu@osyoyu.com>
  AuthorDate: 2023-12-09 13:13:53 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2023-12-11 20:07:36 +0900

    [rubygems/rubygems] Stream output from ext builds when --verbose

    Uses Open3.popen2e in place of Open3.capture2e in Gem::Ext::Builder.
    This change aims to stream stdout/stderr of ext builds when in verbose
    mode, instead of printing everything at once when the build completes.

    Nice for debugging gem builds that consumes longer times.

    https://github.com/rubygems/rubygems/commit/dcdcb5adda

commit 655aacc43a2ae263c9b71429232853d16df028d5
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2023-12-11 15:48:51 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2023-12-11 16:51:46 +0900

    Use dedicated functions to check terminators

commit 980255cb7bfc9ea1ed105ff641ec44b751deced6
  Author:     git <svn-admin@ruby-lang.org>
  AuthorDate: 2023-12-11 15:58:43 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2023-12-11 15:58:43 +0900

    Update bundled gems list as of 2023-12-10

commit e5e53ee173170d2ed354be45f20852359452b45a
  Author:     Hsing-Hui Hsu <hsing-hui.hsu@webflow.com>
  AuthorDate: 2023-12-11 04:08:25 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2023-12-11 08:56:37 +0900

    docs(compar.c): change class name in example

commit 91b0d5fa38f8f48a62ac9d10b50f0d65856fc897
  Author:     Burdette Lamar <BurdetteLamar@Yahoo.com>
  AuthorDate: 2023-12-11 00:22:22 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2023-12-11 00:22:22 +0900

    [DOC] RDoc for Complex (#9181)

commit d9dbcd848f4903921d985cec570d46a4c601073c
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2023-12-10 00:14:10 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2023-12-10 20:43:47 +0900

    Add bright colors and multiple attributes [ci skip]

    Not only:
    ```
    $ ruby colorize.rb fail foo
    ```

    Also:
    ```
    $ ruby colorize.rb 'bright_blue;bold' foo
    ```

commit 0096d6a809085820a0532f755b4fedd631c7e3f1
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2023-12-09 23:58:21 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2023-12-10 20:43:44 +0900

    Extract configuration and lookup methods [ci skip]

commit c4c39082af3520cd96aefc2219a7037865f3f710
  Author:     Koichi Sasada <ko1@atdot.net>
  AuthorDate: 2023-12-10 01:47:14 +0900
  Commit:     Koichi Sasada <ko1@atdot.net>
  CommitDate: 2023-12-10 15:39:06 +0900

    add `flags` to `rb_postponed_job_preregister`

    for future extensions.

commit f8effa209adb3ce050c100ffaffe6f3cc1508185
  Author:     KJ Tsanaktsidis <kj@kjtsanaktsidis.id.au>
  AuthorDate: 2023-11-19 20:54:57 +0900
  Commit:     Koichi Sasada <ko1@atdot.net>
  CommitDate: 2023-12-10 15:00:37 +0900

    Change the semantics of rb_postponed_job_register

    Our current implementation of rb_postponed_job_register suffers from
    some safety issues that can lead to interpreter crashes (see bug #1991).
    Essentially, the issue is that jobs can be called with the wrong
    arguments.

    We made two attempts to fix this whilst keeping the promised semantics,
    but:
      * The first one involved masking/unmasking when flushing jobs, which
        was believed to be too expensive
      * The second one involved a lock-free, multi-producer, single-consumer
        ringbuffer, which was too complex

    The critical insight behind this third solution is that essentially the
    only user of these APIs are a) internal, or b) profiling gems.

    For a), none of the usages actually require variable data; they will
    work just fine with the preregistration interface.

    For b), generally profiling gems only call a single callback with a
    single piece of data (which is actually usually just zero) for the life
    of the program. The ringbuffer is complex because it needs to support
    multi-word inserts of job & data (which can't be atomic); but nobody
    actually even needs that functionality, really.

    So, this comit:
      * Introduces a pre-registration API for jobs, with a GVL-requiring
        rb_postponed_job_prereigster, which returns a handle which can be
        used with an async-signal-safe rb_postponed_job_trigger.
      * Deprecates rb_postponed_job_register (and re-implements it on top of
        the preregister function for compatability)
      * Moves all the internal usages of postponed job register
        pre-registration

commit aecbd66742f43ccfcac04ca4143fcc68ad834320
  Author:     KJ Tsanaktsidis <kj@kjtsanaktsidis.id.au>
  AuthorDate: 2023-11-19 20:54:01 +0900
  Commit:     Koichi Sasada <ko1@atdot.net>
  CommitDate: 2023-12-10 15:00:37 +0900

    Add RUBY_ATOMIC_{PTR_,}FETCH macros for atomic loads

    This can already be emulated by doing an atomic fetch_add of zero, but
    this is more explicit.

    [Bug #19994]

commit 6e8ad7497e459a1e64a3fdb4ab92d52546cff58c
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2023-12-10 13:55:19 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2023-12-10 13:55:19 +0900

    Move `DOT_WAIT` before including Makefile that is using it [ci skip]

commit 130268e264f59c037eda31205c6e2223cffafbbe
  Author:     Stan Lo <stan001212@gmail.com>
  AuthorDate: 2023-12-10 13:21:41 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2023-12-10 13:21:46 +0900

    [ruby/irb] Simplify show_source's super calculation
    (https://github.com/ruby/irb/pull/807)

    https://github.com/ruby/irb/commit/2cccc448de

commit 04eb1b6f2630a07b3a4140e593a4973493a71b92
  Author:     Alex Koval <al3xander.koval@gmail.com>
  AuthorDate: 2023-12-09 21:58:39 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2023-12-10 12:06:36 +0900

    [ruby/prism] fix: escape newline

    https://github.com/ruby/prism/commit/a28b427dcc

commit f64357540eabad0f1bfaa6be60710d153325b064
  Author:     Jeremy Evans <code@jeremyevans.net>
  AuthorDate: 2023-12-08 05:16:09 +0900
  Commit:     Jeremy Evans <code@jeremyevans.net>
  CommitDate: 2023-12-10 06:15:47 +0900

    Ensure super(**kw, &block) calls kw.to_hash before block.to_proc

    Similar as previous commit, but handles the super case with
    explicit arguments.

commit a950f230788d51e13d16596e37cb77e4cc6e2311
  Author:     Jeremy Evans <code@jeremyevans.net>
  AuthorDate: 2023-11-09 08:56:53 +0900
  Commit:     Jeremy Evans <code@jeremyevans.net>
  CommitDate: 2023-12-10 06:15:47 +0900

    Ensure f(**kw, &block) calls kw.to_hash before block.to_proc

    Previously, block.to_proc was called first, by vm_caller_setup_arg_block.
    kw.to_hash was called later inside CALLER_SETUP_ARG or setup_parameters_complex.

    This adds a splatkw instruction that is inserted before sends with
    ARGS_BLOCKARG and KW_SPLAT and without KW_SPLAT_MUT. This is not needed in the
    KW_SPLAT_MUT case, because then you know the value is a hash, and you don't
    need to call to_hash on it.

    The splatkw instruction checks whether the second to top block is a hash,
    and if not, replaces it with the value of calling to_hash on it (using
    rb_to_hash_type).  As it is always before a send with ARGS_BLOCKARG and
    KW_SPLAT, second to top is the keyword splat, and top is the passed block.

commit c0b6ea7c8b5dc6e48ecf6e14e1dbd135d079f0fc
  Author:     KJ Tsanaktsidis <kj@kjtsanaktsidis.id.au>
  AuthorDate: 2023-12-09 08:55:12 +0900
  Commit:     Jeremy Evans <code@jeremyevans.net>
  CommitDate: 2023-12-10 05:49:51 +0900

    Add a fudge factor to the GC compaction move up/down tests

    There seems to be another manifestation of bug #20021, where some of the
    compaction tests are failing on i686 for unrelated PR's because of fake
    "live" references to moved objects on the machine stack.

    We _could_ solve this by counting how many objects are pinned during
    compaction, but doing that involves pushing down the mark & pin bitset
    merge into gc_compact_plane and out of gc_compact_page, which I thought
    was pretty ugly.

    Now that we've solved bug #20022 though, we're able to compact
    arbitrarily many objects with GC.verify_compaction_references, so the
    number of objects we're moving is now 50,000 instead of 500. Since
    that's now much larger than the number of objects likely to be pinned, I
    think it's safe enough to just add a fudge-factor to the tests.

    Any _other_ change in GC.verify_compaction_references that breaks
    compaction is now highly likely to break the assertion by more than 10
    objects, since it's operating on so many more in the first place.

    [Bug #20021]

commit 9e09e5aa3af03a42cf6ef59da2779b0a5d5a6505
  Author:     John Hawthorn <john@hawthorn.email>
  AuthorDate: 2023-12-10 04:33:36 +0900
  Commit:     John Hawthorn <john@hawthorn.email>
  CommitDate: 2023-12-10 05:01:29 +0900

    Fix test of GVL instrumentation on Ractor sleeping

    It seems that the Ractor sleep GVL event arrives very slightly after the
    value becomes available and other threads wake (which makes sense) so we
    need a little additional time to ensure we end up in a consisteny state.

commit b2ad4fec1a369e1cbd0c65d52062946a4fbfb84b
  Author:     John Hawthorn <john@hawthorn.email>
  AuthorDate: 2023-12-09 14:16:02 +0900
  Commit:     John Hawthorn <john@hawthorn.email>
  CommitDate: 2023-12-10 02:31:41 +0900

    Add missing GVL hooks for M:N threads and ractors

commit 88d9a4d58af5c41a3258761dd6d0ea405fe47c07
  Author:     git <svn-admin@ruby-lang.org>
  AuthorDate: 2023-12-09 17:35:02 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2023-12-09 17:35:02 +0900

    Update default gems list at edb8fc24d4a51e58f283a6e7fd1b18 [ci skip]

commit edb8fc24d4a51e58f283a6e7fd1b18b43739fa05
  Author:     Yusuke Endoh <mame@ruby-lang.org>
  AuthorDate: 2023-12-09 17:31:39 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2023-12-09 17:34:08 +0900

    [ruby/error_highlight] Bump version

    https://github.com/ruby/error_highlight/commit/942a723d32

commit 07734b51c66756c4a7a512ebb4736763542d99f3
  Author:     Victor Shepelev <zverok.offline@gmail.com>
  AuthorDate: 2023-12-09 13:54:33 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2023-12-09 13:54:33 +0900

    [DOC] Small fixes for documentation rendering

    Mostly just fixing RDoc's incorrect treatment of `+`

commit 1cbe114d1cf57dc47b4bbc6780f424647dd906d9
  Author:     eileencodes <eileencodes@gmail.com>
  AuthorDate: 2023-12-09 05:00:48 +0900
  Commit:     Aaron Patterson <aaron.patterson@gmail.com>
  CommitDate: 2023-12-09 05:45:40 +0900

    [PRISM] Fix `PM_CALL_NODE` assignment

    This PR fixes ruby/prism#1963. Array and variable assignment was broken
    for call nodes. The change checks if the `method_id` is related to
    assignment and if is adds a `putnil`, `setn` and a `pop`.

    The incorrect instructions meant that in some cases (demonstrated in
    tests) the wrong value would be returned.

    I verified that this fixes the test mentioned in the issue
    (run: `RUBY_ISEQ_DUMP_DEBUG=prism make test/-ext-/st/test_numhash.rb`)

    Incorrect instructions:

    ```
    "********* Ruby *************"
    == disasm: #<ISeq:<compiled>@<compiled>:1 (1,0)-(4,10)>
    0000 putnil                                                           (   4)[Li]
    0001 putself
    0002 send                                   <calldata!mid:tbl, argc:0, FCALL|VCALL|ARGS_SIMPLE>, nil
    0005 putself
    0006 send                                   <calldata!mid:i, argc:0, FCALL|VCALL|ARGS_SIMPLE>, nil
    0009 putself
    0010 send                                   <calldata!mid:j, argc:0, FCALL|VCALL|ARGS_SIMPLE>, nil
    0013 setn                                   3
    0015 send                                   <calldata!mid:[]=, argc:2, ARGS_SIMPLE>, nil
    0018 pop
    0019 leave

    "********* PRISM *************"
    == disasm: #<ISeq:<compiled>@<compiled>:3 (3,0)-(3,10)>
    0000 putself                                                          (   3)[Li]
    0001 send                                   <calldata!mid:tbl, argc:0, FCALL|VCALL|ARGS_SIMPLE>, nil
    0004 putself
    0005 send                                   <calldata!mid:i, argc:0, FCALL|VCALL|ARGS_SIMPLE>, nil
    0008 putself
    0009 send                                   <calldata!mid:j, argc:0, FCALL|VCALL|ARGS_SIMPLE>, nil
    0012 send                                   <calldata!mid:[]=, argc:2, ARGS_SIMPLE>, nil
    0015 leave
    ```

    Fixed instructions:

    ```
    "********* Ruby *************"
    == disasm: #<ISeq:<compiled>@<compiled>:1 (1,0)-(4,10)>
    0000 putnil                                                           (   4)[Li]
    0001 putself
    0002 send                                   <calldata!mid:tbl, argc:0, FCALL|VCALL|ARGS_SIMPLE>, nil
    0005 putself
    0006 send                                   <calldata!mid:i, argc:0, FCALL|VCALL|ARGS_SIMPLE>, nil
    0009 putself
    0010 send                                   <calldata!mid:j, argc:0, FCALL|VCALL|ARGS_SIMPLE>, nil
    0013 setn                                   3
    0015 send                                   <calldata!mid:[]=, argc:2, ARGS_SIMPLE>, nil
    0018 pop
    0019 leave

    "********* PRISM *************"
    == disasm: #<ISeq:<compiled>@<compiled>:3 (3,0)-(3,10)>
    0000 putnil                                                           (   3)[Li]
    0001 putself
    0002 send                                   <calldata!mid:tbl, argc:0, FCALL|VCALL|ARGS_SIMPLE>, nil
    0005 putself
    0006 send                                   <calldata!mid:i, argc:0, FCALL|VCALL|ARGS_SIMPLE>, nil
    0009 putself
    0010 send                                   <calldata!mid:j, argc:0, FCALL|VCALL|ARGS_SIMPLE>, nil
    0013 setn                                   3
    0015 send                                   <calldata!mid:[]=, argc:2, ARGS_SIMPLE>, nil
    0018 pop
    0019 leave
    ```

    Fixes ruby/prism#1963

commit 9e7ca2c3c9d2fbdcdf7f3b6c0b8c63b2dbb08ebe
  Author:     BurdetteLamar <burdettelamar@yahoo.com>
  AuthorDate: 2023-12-09 05:02:14 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2023-12-09 05:13:11 +0900

    RDoc for Complex

commit 98e3552cfb80d4d3a8176d9969ea4956adee93d5
  Author:     Kevin Newton <kddnewton@gmail.com>
  AuthorDate: 2023-12-09 00:10:43 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2023-12-09 03:59:52 +0900

    [ruby/prism] Add necessary encoding flags for symbols and regex

    This doesn't actually fix the encodings for symbols and regex,
    unfortunately. But I wanted to get this change in because it is
    the last AST change we're going to make before 3.3 is released.

    So, if consumers want, they can start to check these flags to
    determine the encoding, even though it will be wrong. Then once we
    actually set them correctly, everything should work.

    https://github.com/ruby/prism/commit/9b35f7e891

commit a94a2eea34a7d6e1bd0e97b5a3bc73adcfcbcb31
  Author:     Benoit Daloze <eregontp@gmail.com>
  AuthorDate: 2023-01-05 22:52:13 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2023-12-09 02:01:23 +0900

    [rubygems/rubygems] Upstream RubyGems changes from TruffleRuby

    https://github.com/rubygems/rubygems/commit/749a508968

commit 365c6cc2269e6d0293be5cc4b96fae4ef80c7f19
  Author:     git <svn-admin@ruby-lang.org>
  AuthorDate: 2023-12-09 01:50:31 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2023-12-09 01:50:31 +0900

    Update default gems list at f2c13ff9e8646ea1f05498707c8e97 [ci skip]

commit f2c13ff9e8646ea1f05498707c8e972379456883
  Author:     Schneems <richard.schneeman+foo@gmail.com>
  AuthorDate: 2023-12-09 01:41:23 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2023-12-09 01:49:33 +0900

    [ruby/syntax_suggest] v2.0.0

    https://github.com/ruby/syntax_suggest/commit/53b2a1b03c

commit a54eb9c6f9c12816f6befefd3828b78689076549
  Author:     Kevin Newton <kddnewton@gmail.com>
  AuthorDate: 2023-12-08 23:40:26 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2023-12-08 23:40:32 +0900

    [ruby/prism] A couple of small dot enhancements

    https://github.com/ruby/prism/commit/5642a57f39

commit 0166040939fd9057a7fb724e290fbe6c9cc036c2
  Author:     Aaron Patterson <tenderlove@ruby-lang.org>
  AuthorDate: 2023-12-08 09:37:24 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2023-12-08 23:35:26 +0900

    [ruby/prism] Hashes need to deoptimize based on their contents

    If a hash has children that are not "basic" types of objects, then we
    can't consider the hash to be a static literal.

    Fixes: #2015

    https://github.com/ruby/prism/commit/ca2523137d

commit 892b5f10d52bacaf8c6b430d0e9a95dc0ea36834
  Author:     Kevin Newton <kddnewton@gmail.com>
  AuthorDate: 2023-12-08 23:26:30 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2023-12-08 23:34:34 +0900

    [ruby/prism] More closely match CRuby error messages

    https://github.com/ruby/prism/commit/1ed07a0c6d

commit 0204523fe7ccafba30a4d2465946095f2603c7eb
  Author:     Benoit Daloze <eregontp@gmail.com>
  AuthorDate: 2023-12-07 06:44:37 +0900
  Commit:     Benoit Daloze <eregontp@gmail.com>
  CommitDate: 2023-12-08 21:59:40 +0900

    Improve Fiber#kill docs and simplify the NEWS entry to let the documentation explain

commit 7d052774bd176d013eaffecd55f6999ab31c5f68
  Author:     git <svn-admin@ruby-lang.org>
  AuthorDate: 2023-12-08 21:38:28 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2023-12-08 21:38:28 +0900

    Update default gems list at 49cdf063d6275151075ffd94c3d013 [ci skip]

commit 49cdf063d6275151075ffd94c3d013f6c19b31f7
  Author:     Akinori MUSHA <knu@idaemons.org>
  AuthorDate: 2023-12-08 21:36:12 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2023-12-08 21:37:30 +0900

    [ruby/set] Bump version to 1.0.4

    https://github.com/ruby/set/commit/efc8c8c9f5

commit cc9826503d989df877adbcd94d39a6ff78d0b785
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2023-12-08 20:25:04 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2023-12-08 20:25:04 +0900

    Revert "Skip to warn like 'bigdecimal/util' feature."

    This reverts commit 8f6cf72e661e36410848c1451335fd28a32cecdf.

commit f2c84c48842d47e7612c78d0627542b596945586
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2023-12-08 15:33:13 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2023-12-08 16:01:01 +0900

    Pick commit from https://github.com/rubygems/rubygems/pull/7085

      Co-authored-by: Samuel Giddins <segiddins@segiddins.me>

commit dab30b4d71efa40220a340e1ef7936824b6cc6c6
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2023-12-08 15:32:25 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2023-12-08 16:01:01 +0900

    Pick commit from https://github.com/rubygems/rubygems/pull/7227

      Co-authored-by: David Rodríguez <deivid.rodriguez@riseup.net>

commit 01a2a0abc6a7deac27d66819531d53ceb7855c6a
  Author:     David Rodríguez <deivid.rodriguez@riseup.net>
  AuthorDate: 2023-12-08 02:11:56 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2023-12-08 16:01:01 +0900

    [rubygems/rubygems] Migrate documentation to be generated with nronn

    https://github.com/rubygems/rubygems/commit/55281f0eaa

commit 1c3aa4b97709676f2a254d0047d061e6bdff0472
  Author:     David Rodríguez <deivid.rodriguez@riseup.net>
  AuthorDate: 2023-12-08 03:22:20 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2023-12-08 16:01:01 +0900

    [rubygems/rubygems] Add extra blank line to `bundle outdated` docs

    If it's not there, when migrating to `nronn`, generated man page is
    messed up.

    https://github.com/rubygems/rubygems/commit/7161347648

commit dc64a04a12e25cb98aa24ccbd8a57f6aa5a43d65
  Author:     David Rodríguez <deivid.rodriguez@riseup.net>
  AuthorDate: 2023-12-08 06:51:14 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2023-12-08 16:01:01 +0900

    [rubygems/rubygems] Revert "Merge pull request #7148 from Paul-Bob/improvement/include_response_body_on_fetch_http_error"

    This reverts commit https://github.com/rubygems/rubygems/commit/e5a4fd9eb617, reversing
    changes made to https://github.com/rubygems/rubygems/commit/c5a5363b0c98.

    https://github.com/rubygems/rubygems/commit/e21c45c4c3

commit 8f6cf72e661e36410848c1451335fd28a32cecdf
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2023-12-08 15:57:08 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2023-12-08 15:57:08 +0900

    Skip to warn like 'bigdecimal/util' feature.

commit 64e985333f4fa7e4ba06454ef50c41e56a22768d
  Author:     David Rodríguez <deivid.rodriguez@riseup.net>
  AuthorDate: 2023-12-08 05:35:47 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2023-12-08 15:55:15 +0900

    Improve bundled gems warnings for subfeatures

    Before, when requiring "bigdecimal/math" in a Bundler context:

    > /Users/deivid/.asdf/installs/ruby/3.3.0-dev/lib/ruby/3.3.0+0/bigdecimal/math.rb:2: warning: bigdecimal was loaded from the standard library, but will no longer be part of the default gems since Ruby 3.4.0. Add bigdecimal to your Gemfile or gemspec.

    After:

    > foo.rb:1: warning: bigdecimal/math is found in bigdecimal, which will no longer be part of the default gems since Ruby 3.4.0. Add bigdecimal to your Gemfile or gemspec.

commit a530dfef2be3934decd975100585e3978ef49173
  Author:     David Rodríguez <deivid.rodriguez@riseup.net>
  AuthorDate: 2023-12-08 05:30:26 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2023-12-08 15:55:15 +0900

    Improve bundled gem warnings

    Before, when requiring "bigdecimal" in a Bundler context:

    > foo.rb:1: warning: bigdecimal which will no longer be part of the default gems since Ruby 3.4.0. Add bigdecimal to your Gemfile or gemspec.

    After:

    > foo.rb:1: warning: bigdecimal was loaded from the standard library, but will no longer be part of the default gems since Ruby 3.4.0. Add bigdecimal to your Gemfile or gemspec.

commit d61af5c49a9cc65c7009b9d2036bf43a527e8036
  Author:     David Rodríguez <deivid.rodriguez@riseup.net>
  AuthorDate: 2023-12-08 05:29:25 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2023-12-08 15:55:15 +0900

    The SINCE and WARNED hashes take gem names, not features

commit 4817166e54ad98f9b3e9d06e9e8c7ccff992a957
  Author:     Samuel Giddins <segiddins@segiddins.me>
  AuthorDate: 2023-10-21 09:56:22 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2023-12-08 15:09:51 +0900

    [rubygems/rubygems] Extract generate_index command to rubygems-generate_index gem

    So generate_index can be implemented with dependencies, such as the compact index

    Took this approach from feedback in https://github.com/rubygems/rubygems/pull/6853

    Running `gem generate_index` by default will use an installed rubygems-generate_index, or install and then use the command from the gem

    Apply suggestions from code review

    https://github.com/rubygems/rubygems/commit/fc1cb9bc9e

    Co-authored-by: Hiroshi SHIBATA <hsbt@ruby-lang.org>

commit 0166d56f2bb062ddf56a0e7757849da68b66fe62
  Author:     Martin Emde <martin.emde@gmail.com>
  AuthorDate: 2023-12-08 13:18:09 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2023-12-08 14:51:03 +0900

    [rubygems/rubygems] Don't memoize in NameTuple lock_name

    The result of this is already memoized and no other NameTuple
    methods memoize.

    https://github.com/rubygems/rubygems/commit/b7cce0c64a

commit 51ab9ebca18f3b9a0b8f2bfc420454983259c600
  Author:     卜部昌平 <shyouhei@ruby-lang.org>
  AuthorDate: 2023-12-08 13:14:19 +0900
  Commit:     卜部昌平 <shyouhei@ruby-lang.org>
  CommitDate: 2023-12-08 13:17:56 +0900

    [ci skip] comment for commit be1bbd5b7d40ad863ab35097765d3754726bbd54

commit 352a885a0f1a4d4576c686301ee71ea887a345e5
  Author:     Koichi Sasada <ko1@atdot.net>
  AuthorDate: 2023-11-17 02:29:11 +0900
  Commit:     Koichi Sasada <ko1@atdot.net>
  CommitDate: 2023-12-08 13:16:19 +0900

    Thread specific storage APIs

    This patch introduces thread specific storage APIs
    for tools which use `rb_internal_thread_event_hook` APIs.

    * `rb_internal_thread_specific_key_create()` to create a tool specific
      thread local storage key and allocate the storage if not available.
    * `rb_internal_thread_specific_set()` sets a data to thread and tool
      specific storage.
    * `rb_internal_thread_specific_get()` gets a data in thread and tool
      specific storage.

    Note that `rb_internal_thread_specific_get|set(thread_val, key)`
    can be called without GVL and safe for async signal and safe for
    multi-threading (native threads). So you can call it in any internal
    thread event hooks. Further more you can call it from other native
    threads. Of course `thread_val` should be living while accessing the
    data from this function.

    Note that you should not forget to clean up the set data.

commit 9b7a964318d04beb82680ff1d0c6eb571f4b8b5e
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2023-12-07 20:04:33 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2023-12-08 12:53:47 +0900

    [Bug #19877] Flip-flop needs to be direct condition

commit 8bb90f4d771d287644a3cf21bdda26c637f091e2
  Author:     Yuji Yaginuma <yuuji.yaginuma@gmail.com>
  AuthorDate: 2023-12-08 11:10:14 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2023-12-08 12:25:43 +0900

    [rubygems/rubygems] Use `Minitest::TestTask` in a template file for `minitest`

    `minitest` has introduced a rake task for running test on 5.16.0.
    https://github.com/minitest/minitest/blob/master/History.rdoc#5160--2022-06-14-

    This has some tasks related to running tests and it's useful for
    `minitest` user I think.
    https://github.com/minitest/minitest#rake-tasks-

    This PR changed to use the task in a template file for `minitest`

    https://github.com/rubygems/rubygems/commit/7a86d13062

commit ac5fd58700b5576bfdd89ffe06dd4302b6721e5f
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2023-12-08 07:53:05 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2023-12-08 07:53:05 +0900

    YJIT: Fix on-stack ISEQ comparison for auto_compact (#9164)

commit 2755cb1b2fbc4a5f08ca56345b5945bd452da74e
  Author:     David Rodríguez <deivid.rodriguez@riseup.net>
  AuthorDate: 2023-12-08 06:10:33 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2023-12-08 07:29:33 +0900

    [rubygems/rubygems] Use modern hashes consistently

    https://github.com/rubygems/rubygems/commit/bb66253f2c

commit 9d696aa20461d94c2d32e1e474bd036ade20c94d
  Author:     Aaron Patterson <tenderlove@ruby-lang.org>
  AuthorDate: 2023-12-06 07:07:50 +0900
  Commit:     Aaron Patterson <aaron.patterson@gmail.com>
  CommitDate: 2023-12-08 07:07:09 +0900

    Support method calls inside `defined?`

    This commit supports all kinds of method calls (including methods with
    parameters) inside `defined?` calls.

commit f76881c9af4256d984c0cd59bc1f6929134eded0
  Author:     BurdetteLamar <burdettelamar@yahoo.com>
  AuthorDate: 2023-12-08 05:36:37 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2023-12-08 06:34:41 +0900

    RDoc for Complex

commit 6816e8efcff3be75f8020cd1b0ea57d3cd664bbc
  Author:     Adam Hess <adamhess1991@gmail.com>
  AuthorDate: 2023-10-13 03:15:53 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2023-12-08 05:52:35 +0900

    Free everything at shutdown

    when the RUBY_FREE_ON_EXIT environment variable is set, manually free memory at shutdown.

    Co-authored-by: Nobuyoshi Nakada <nobu@ruby-lang.org>
    Co-authored-by: Peter Zhu <peter@peterzhu.ca>

commit b361a800c22e0248bf126d77e96a7bd4f9c34d1b
  Author:     Jemma Issroff <jemmaissroff@gmail.com>
  AuthorDate: 2023-12-08 05:03:06 +0900
  Commit:     Jemma Issroff <jemmaissroff@gmail.com>
  CommitDate: 2023-12-08 05:29:35 +0900

    Added comment

commit a0c7bb4328c981be5f3f0e82e7ef75fc8bbd51b6
  Author:     Jemma Issroff <jemmaissroff@gmail.com>
  AuthorDate: 2023-12-08 04:13:33 +0900
  Commit:     Jemma Issroff <jemmaissroff@gmail.com>
  CommitDate: 2023-12-08 05:29:35 +0900

    [PRISM] Account for multiple arguments when compiling ArgumentsNode

    BreakNode, ReturnNode and NextNode all compile the ArgumentsNode
    directly, but we weren't accounting for multiple arguments. If there
    is more than one argument, we need to also emit a newarray
    instruction to put the arguments onto the stack

commit 7738b31d390e70b26e913d86c133a70c8e65a645
  Author:     Jeremy Evans <code@jeremyevans.net>
  AuthorDate: 2023-12-01 08:30:30 +0900
  Commit:     Jeremy Evans <code@jeremyevans.net>
  CommitDate: 2023-12-08 04:27:55 +0900

